searchData={"items":[{"type":"module","title":"GoogleApi.Sheets.V4","doc":"API client metadata for GoogleApi.Sheets.V4.","ref":"GoogleApi.Sheets.V4.html"},{"type":"function","title":"GoogleApi.Sheets.V4.discovery_revision/0","doc":"","ref":"GoogleApi.Sheets.V4.html#discovery_revision/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Api.Spreadsheets","doc":"API calls for all endpoints tagged `Spreadsheets`.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_batch_update/4","doc":"Applies one or more updates to the spreadsheet. Each request is validated before being applied. If any request is not valid then the entire request will fail and nothing will be applied. Some requests have replies to give you some information about how they are applied. The replies will mirror the requests. For example, if you applied 4 updates and the 3rd one had a reply, then the response will have 2 empty replies, the actual reply, and another empty reply, in that order. Due to the collaborative nature of spreadsheets, it is not guaranteed that the spreadsheet will reflect exactly your changes after this completes, however it is guaranteed that the updates in the request will be applied together atomically. Your changes may be altered with respect to collaborator changes. If there are no collaborators, the spreadsheet should reflect your changes.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_batch_update/4"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_batch_update/4","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The spreadsheet to apply the updates to.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_batch_update/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_batch_update/4","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_batch_update/4-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_create/3","doc":"Creates a spreadsheet, returning the newly created spreadsheet.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_create/3"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_create/3","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Sheets.V4.Model.Spreadsheet.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_create/3-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_create/3","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.Spreadsheet{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_create/3-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_developer_metadata_get/5","doc":"Returns the developer metadata with the specified ID. The caller must specify the spreadsheet ID and the developer metadata's unique metadataId.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_developer_metadata_get/5"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_developer_metadata_get/5","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The ID of the spreadsheet to retrieve metadata from.\n*   `metadata_id` (*type:* `integer()`) - The ID of the developer metadata to retrieve.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_developer_metadata_get/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_developer_metadata_get/5","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.DeveloperMetadata{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_developer_metadata_get/5-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_developer_metadata_search/4","doc":"Returns all developer metadata matching the specified DataFilter. If the provided DataFilter represents a DeveloperMetadataLookup object, this will return all DeveloperMetadata entries selected by it. If the DataFilter represents a location in a spreadsheet, this will return all developer metadata associated with locations intersecting that region.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_developer_metadata_search/4"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_developer_metadata_search/4","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The ID of the spreadsheet to retrieve metadata from.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_developer_metadata_search/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_developer_metadata_search/4","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_developer_metadata_search/4-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_get/4","doc":"Returns the spreadsheet at the given ID. The caller must specify the spreadsheet ID. By default, data within grids is not returned. You can include grid data in one of 2 ways: * Specify a [field mask](https://developers.google.com/sheets/api/guides/field-masks) listing your desired fields using the `fields` URL parameter in HTTP * Set the includeGridData URL parameter to true. If a field mask is set, the `includeGridData` parameter is ignored For large spreadsheets, as a best practice, retrieve only the specific spreadsheet fields that you want. To retrieve only subsets of spreadsheet data, use the ranges URL parameter. Ranges are specified using [A1 notation](/sheets/api/guides/concepts#cell). You can define a single cell (for example, `A1`) or multiple cells (for example, `A1:D5`). You can also get cells from other sheets within the same spreadsheet (for example, `Sheet2!A1:C4`) or retrieve multiple ranges at once (for example, `?ranges=A1:D5&ranges=Sheet2!A1:C4`). Limiting the range returns only the portions of the spreadsheet that intersect the requested ranges.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_get/4"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_get/4","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The spreadsheet to request.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:includeGridData` (*type:* `boolean()`) - True if grid data should be returned. This parameter is ignored if a field mask was set in the request.\n    *   `:ranges` (*type:* `list(String.t)`) - The ranges to retrieve from the spreadsheet.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_get/4","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.Spreadsheet{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_get/4-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_get_by_data_filter/4","doc":"Returns the spreadsheet at the given ID. The caller must specify the spreadsheet ID. This method differs from GetSpreadsheet in that it allows selecting which subsets of spreadsheet data to return by specifying a dataFilters parameter. Multiple DataFilters can be specified. Specifying one or more data filters returns the portions of the spreadsheet that intersect ranges matched by any of the filters. By default, data within grids is not returned. You can include grid data one of 2 ways: * Specify a [field mask](https://developers.google.com/sheets/api/guides/field-masks) listing your desired fields using the `fields` URL parameter in HTTP * Set the includeGridData parameter to true. If a field mask is set, the `includeGridData` parameter is ignored For large spreadsheets, as a best practice, retrieve only the specific spreadsheet fields that you want.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_get_by_data_filter/4"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_get_by_data_filter/4","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The spreadsheet to request.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Sheets.V4.Model.GetSpreadsheetByDataFilterRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_get_by_data_filter/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_get_by_data_filter/4","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.Spreadsheet{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_get_by_data_filter/4-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_sheets_copy_to/5","doc":"Copies a single sheet from a spreadsheet to another spreadsheet. Returns the properties of the newly created sheet.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_sheets_copy_to/5"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_sheets_copy_to/5","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The ID of the spreadsheet containing the sheet to copy.\n*   `sheet_id` (*type:* `integer()`) - The ID of the sheet to copy.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Sheets.V4.Model.CopySheetToAnotherSpreadsheetRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_sheets_copy_to/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_sheets_copy_to/5","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.SheetProperties{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_sheets_copy_to/5-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_append/5","doc":"Appends values to a spreadsheet. The input range is used to search for existing data and find a \"table\" within that range. Values will be appended to the next row of the table, starting with the first column of the table. See the [guide](/sheets/api/guides/values#appending_values) and [sample code](/sheets/api/samples/writing#append_values) for specific details of how tables are detected and data is appended. The caller must specify the spreadsheet ID, range, and a valueInputOption. The `valueInputOption` only controls how the input data will be added to the sheet (column-wise or row-wise), it does not influence what cell the data starts being written to.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_append/5"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_append/5","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The ID of the spreadsheet to update.\n*   `range` (*type:* `String.t`) - The [A1 notation](/sheets/api/guides/concepts#cell) of a range to search for a logical table of data. Values are appended after the last row of the table.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:includeValuesInResponse` (*type:* `boolean()`) - Determines if the update response should include the values of the cells that were appended. By default, responses do not include the updated values.\n    *   `:insertDataOption` (*type:* `String.t`) - How the input data should be inserted.\n    *   `:responseDateTimeRenderOption` (*type:* `String.t`) - Determines how dates, times, and durations in the response should be rendered. This is ignored if response_value_render_option is FORMATTED_VALUE. The default dateTime render option is SERIAL_NUMBER.\n    *   `:responseValueRenderOption` (*type:* `String.t`) - Determines how values in the response should be rendered. The default render option is FORMATTED_VALUE.\n    *   `:valueInputOption` (*type:* `String.t`) - How the input data should be interpreted.\n    *   `:body` (*type:* `GoogleApi.Sheets.V4.Model.ValueRange.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_append/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_append/5","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.AppendValuesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_append/5-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_clear/4","doc":"Clears one or more ranges of values from a spreadsheet. The caller must specify the spreadsheet ID and one or more ranges. Only values are cleared -- all other properties of the cell (such as formatting and data validation) are kept.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_clear/4"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_clear/4","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The ID of the spreadsheet to update.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Sheets.V4.Model.BatchClearValuesRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_clear/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_clear/4","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.BatchClearValuesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_clear/4-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_clear_by_data_filter/4","doc":"Clears one or more ranges of values from a spreadsheet. The caller must specify the spreadsheet ID and one or more DataFilters. Ranges matching any of the specified data filters will be cleared. Only values are cleared -- all other properties of the cell (such as formatting, data validation, etc..) are kept.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_clear_by_data_filter/4"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_clear_by_data_filter/4","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The ID of the spreadsheet to update.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_clear_by_data_filter/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_clear_by_data_filter/4","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_clear_by_data_filter/4-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_get/4","doc":"Returns one or more ranges of values from a spreadsheet. The caller must specify the spreadsheet ID and one or more ranges.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_get/4"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_get/4","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The ID of the spreadsheet to retrieve data from.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:dateTimeRenderOption` (*type:* `String.t`) - How dates, times, and durations should be represented in the output. This is ignored if value_render_option is FORMATTED_VALUE. The default dateTime render option is SERIAL_NUMBER.\n    *   `:majorDimension` (*type:* `String.t`) - The major dimension that results should use. For example, if the spreadsheet data is: `A1=1,B1=2,A2=3,B2=4`, then requesting `ranges=[\"A1:B2\"],majorDimension=ROWS` returns `[[1,2],[3,4]]`, whereas requesting `ranges=[\"A1:B2\"],majorDimension=COLUMNS` returns `[[1,3],[2,4]]`.\n    *   `:ranges` (*type:* `list(String.t)`) - The [A1 notation or R1C1 notation](/sheets/api/guides/concepts#cell) of the range to retrieve values from.\n    *   `:valueRenderOption` (*type:* `String.t`) - How values should be represented in the output. The default render option is ValueRenderOption.FORMATTED_VALUE.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_get/4","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.BatchGetValuesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_get/4-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_get_by_data_filter/4","doc":"Returns one or more ranges of values that match the specified data filters. The caller must specify the spreadsheet ID and one or more DataFilters. Ranges that match any of the data filters in the request will be returned.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_get_by_data_filter/4"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_get_by_data_filter/4","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The ID of the spreadsheet to retrieve data from.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_get_by_data_filter/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_get_by_data_filter/4","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_get_by_data_filter/4-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_update/4","doc":"Sets values in one or more ranges of a spreadsheet. The caller must specify the spreadsheet ID, a valueInputOption, and one or more ValueRanges.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_update/4"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_update/4","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The ID of the spreadsheet to update.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Sheets.V4.Model.BatchUpdateValuesRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_update/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_update/4","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.BatchUpdateValuesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_update/4-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_update_by_data_filter/4","doc":"Sets values in one or more ranges of a spreadsheet. The caller must specify the spreadsheet ID, a valueInputOption, and one or more DataFilterValueRanges.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_update_by_data_filter/4"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_update_by_data_filter/4","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The ID of the spreadsheet to update.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_update_by_data_filter/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_batch_update_by_data_filter/4","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_batch_update_by_data_filter/4-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_clear/5","doc":"Clears values from a spreadsheet. The caller must specify the spreadsheet ID and range. Only values are cleared -- all other properties of the cell (such as formatting, data validation, etc..) are kept.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_clear/5"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_clear/5","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The ID of the spreadsheet to update.\n*   `range` (*type:* `String.t`) - The [A1 notation or R1C1 notation](/sheets/api/guides/concepts#cell) of the values to clear.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Sheets.V4.Model.ClearValuesRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_clear/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_clear/5","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.ClearValuesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_clear/5-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_get/5","doc":"Returns a range of values from a spreadsheet. The caller must specify the spreadsheet ID and a range.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_get/5"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_get/5","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The ID of the spreadsheet to retrieve data from.\n*   `range` (*type:* `String.t`) - The [A1 notation or R1C1 notation](/sheets/api/guides/concepts#cell) of the range to retrieve values from.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:dateTimeRenderOption` (*type:* `String.t`) - How dates, times, and durations should be represented in the output. This is ignored if value_render_option is FORMATTED_VALUE. The default dateTime render option is SERIAL_NUMBER.\n    *   `:majorDimension` (*type:* `String.t`) - The major dimension that results should use. For example, if the spreadsheet data in Sheet1 is: `A1=1,B1=2,A2=3,B2=4`, then requesting `range=Sheet1!A1:B2?majorDimension=ROWS` returns `[[1,2],[3,4]]`, whereas requesting `range=Sheet1!A1:B2?majorDimension=COLUMNS` returns `[[1,3],[2,4]]`.\n    *   `:valueRenderOption` (*type:* `String.t`) - How values should be represented in the output. The default render option is FORMATTED_VALUE.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_get/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_get/5","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.ValueRange{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_get/5-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_update/5","doc":"Sets values in a range of a spreadsheet. The caller must specify the spreadsheet ID, range, and a valueInputOption.","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_update/5"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_update/5","doc":"*   `connection` (*type:* `GoogleApi.Sheets.V4.Connection.t`) - Connection to server\n*   `spreadsheet_id` (*type:* `String.t`) - The ID of the spreadsheet to update.\n*   `range` (*type:* `String.t`) - The [A1 notation](/sheets/api/guides/concepts#cell) of the values to update.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:includeValuesInResponse` (*type:* `boolean()`) - Determines if the update response should include the values of the cells that were updated. By default, responses do not include the updated values. If the range to write was larger than the range actually written, the response includes all values in the requested range (excluding trailing empty rows and columns).\n    *   `:responseDateTimeRenderOption` (*type:* `String.t`) - Determines how dates, times, and durations in the response should be rendered. This is ignored if response_value_render_option is FORMATTED_VALUE. The default dateTime render option is SERIAL_NUMBER.\n    *   `:responseValueRenderOption` (*type:* `String.t`) - Determines how values in the response should be rendered. The default render option is FORMATTED_VALUE.\n    *   `:valueInputOption` (*type:* `String.t`) - How the input data should be interpreted.\n    *   `:body` (*type:* `GoogleApi.Sheets.V4.Model.ValueRange.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_update/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Api.Spreadsheets.sheets_spreadsheets_values_update/5","doc":"*   `{:ok, %GoogleApi.Sheets.V4.Model.UpdateValuesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Sheets.V4.Api.Spreadsheets.html#sheets_spreadsheets_values_update/5-returns"},{"type":"module","title":"GoogleApi.Sheets.V4.Connection","doc":"Handle Tesla connections for GoogleApi.Sheets.V4.","ref":"GoogleApi.Sheets.V4.Connection.html"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Sheets.V4.Connection.html#delete/3"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Sheets.V4.Connection.html#delete!/3"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.execute/2","doc":"Execute a request on this connection","ref":"GoogleApi.Sheets.V4.Connection.html#execute/2"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Connection.execute/2","doc":"*   `{:ok, Tesla.Env.t}` - If the call was successful\n*   `{:error, reason}` - If the call failed","ref":"GoogleApi.Sheets.V4.Connection.html#execute/2-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Sheets.V4.Connection.html#get/3"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Sheets.V4.Connection.html#get!/3"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Sheets.V4.Connection.html#head/3"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Sheets.V4.Connection.html#head!/3"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.new/0","doc":"Configure an authless client connection","ref":"GoogleApi.Sheets.V4.Connection.html#new/0"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Connection.new/0","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.Sheets.V4.Connection.html#new/0-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.new/1","doc":"Configure a client connection using a function which yields a Bearer token.","ref":"GoogleApi.Sheets.V4.Connection.html#new/1"},{"type":"function","title":"Parameters - GoogleApi.Sheets.V4.Connection.new/1","doc":"*   `token_fetcher` (*type:* `list(String.t()) -> String.t()`) - Callback\n    which provides an OAuth2 token given a list of scopes","ref":"GoogleApi.Sheets.V4.Connection.html#new/1-parameters"},{"type":"function","title":"Returns - GoogleApi.Sheets.V4.Connection.new/1","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.Sheets.V4.Connection.html#new/1-returns"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Sheets.V4.Connection.html#options/3"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Sheets.V4.Connection.html#options!/3"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Sheets.V4.Connection.html#patch/4"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Sheets.V4.Connection.html#patch!/4"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Sheets.V4.Connection.html#post/4"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Sheets.V4.Connection.html#post!/4"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Sheets.V4.Connection.html#put/4"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Sheets.V4.Connection.html#put!/4"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.request/2","doc":"Perform a request.","ref":"GoogleApi.Sheets.V4.Connection.html#request/2"},{"type":"function","title":"Options - GoogleApi.Sheets.V4.Connection.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"GoogleApi.Sheets.V4.Connection.html#request/2-options"},{"type":"function","title":"Examples - GoogleApi.Sheets.V4.Connection.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"GoogleApi.Sheets.V4.Connection.html#request/2-examples"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"GoogleApi.Sheets.V4.Connection.html#request!/2"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Sheets.V4.Connection.html#trace/3"},{"type":"function","title":"GoogleApi.Sheets.V4.Connection.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Sheets.V4.Connection.html#trace!/3"},{"type":"type","title":"GoogleApi.Sheets.V4.Connection.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"GoogleApi.Sheets.V4.Connection.html#t:option/0"},{"type":"type","title":"GoogleApi.Sheets.V4.Connection.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Connection.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddBandingRequest","doc":"Adds a new banded range to the spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.AddBandingRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddBandingRequest","doc":"*   `bandedRange` (*type:* `GoogleApi.Sheets.V4.Model.BandedRange.t`, *default:* `nil`) - The banded range to add. The bandedRangeId field is optional; if one is not set, an id will be randomly generated. (It is an error to specify the ID of a range that already exists.)","ref":"GoogleApi.Sheets.V4.Model.AddBandingRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddBandingRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddBandingRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddBandingRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddBandingRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddBandingResponse","doc":"The result of adding a banded range.","ref":"GoogleApi.Sheets.V4.Model.AddBandingResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddBandingResponse","doc":"*   `bandedRange` (*type:* `GoogleApi.Sheets.V4.Model.BandedRange.t`, *default:* `nil`) - The banded range that was added.","ref":"GoogleApi.Sheets.V4.Model.AddBandingResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddBandingResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddBandingResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddBandingResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddBandingResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddChartRequest","doc":"Adds a chart to a sheet in the spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.AddChartRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddChartRequest","doc":"*   `chart` (*type:* `GoogleApi.Sheets.V4.Model.EmbeddedChart.t`, *default:* `nil`) - The chart that should be added to the spreadsheet, including the position where it should be placed. The chartId field is optional; if one is not set, an id will be randomly generated. (It is an error to specify the ID of an embedded object that already exists.)","ref":"GoogleApi.Sheets.V4.Model.AddChartRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddChartRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddChartRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddChartRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddChartRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddChartResponse","doc":"The result of adding a chart to a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.AddChartResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddChartResponse","doc":"*   `chart` (*type:* `GoogleApi.Sheets.V4.Model.EmbeddedChart.t`, *default:* `nil`) - The newly added chart.","ref":"GoogleApi.Sheets.V4.Model.AddChartResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddChartResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddChartResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddChartResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddChartResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddConditionalFormatRuleRequest","doc":"Adds a new conditional format rule at the given index. All subsequent rules' indexes are incremented.","ref":"GoogleApi.Sheets.V4.Model.AddConditionalFormatRuleRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddConditionalFormatRuleRequest","doc":"*   `index` (*type:* `integer()`, *default:* `nil`) - The zero-based index where the rule should be inserted.\n*   `rule` (*type:* `GoogleApi.Sheets.V4.Model.ConditionalFormatRule.t`, *default:* `nil`) - The rule to add.","ref":"GoogleApi.Sheets.V4.Model.AddConditionalFormatRuleRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddConditionalFormatRuleRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddConditionalFormatRuleRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddConditionalFormatRuleRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddConditionalFormatRuleRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddDataSourceRequest","doc":"Adds a data source. After the data source is added successfully, an associated DATA_SOURCE sheet is created and an execution is triggered to refresh the sheet to read data from the data source. The request requires an additional `bigquery.readonly` OAuth scope.","ref":"GoogleApi.Sheets.V4.Model.AddDataSourceRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddDataSourceRequest","doc":"*   `dataSource` (*type:* `GoogleApi.Sheets.V4.Model.DataSource.t`, *default:* `nil`) - The data source to add.","ref":"GoogleApi.Sheets.V4.Model.AddDataSourceRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddDataSourceRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddDataSourceRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddDataSourceRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddDataSourceRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddDataSourceResponse","doc":"The result of adding a data source.","ref":"GoogleApi.Sheets.V4.Model.AddDataSourceResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddDataSourceResponse","doc":"*   `dataExecutionStatus` (*type:* `GoogleApi.Sheets.V4.Model.DataExecutionStatus.t`, *default:* `nil`) - The data execution status.\n*   `dataSource` (*type:* `GoogleApi.Sheets.V4.Model.DataSource.t`, *default:* `nil`) - The data source that was created.","ref":"GoogleApi.Sheets.V4.Model.AddDataSourceResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddDataSourceResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddDataSourceResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddDataSourceResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddDataSourceResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddDimensionGroupRequest","doc":"Creates a group over the specified range. If the requested range is a superset of the range of an existing group G, then the depth of G is incremented and this new group G' has the depth of that group. For example, a group [C:D, depth 1] + [B:E] results in groups [B:E, depth 1] and [C:D, depth 2]. If the requested range is a subset of the range of an existing group G, then the depth of the new group G' becomes one greater than the depth of G. For example, a group [B:E, depth 1] + [C:D] results in groups [B:E, depth 1] and [C:D, depth 2]. If the requested range starts before and ends within, or starts within and ends after, the range of an existing group G, then the range of the existing group G becomes the union of the ranges, and the new group G' has depth one greater than the depth of G and range as the intersection of the ranges. For example, a group [B:D, depth 1] + [C:E] results in groups [B:E, depth 1] and [C:D, depth 2].","ref":"GoogleApi.Sheets.V4.Model.AddDimensionGroupRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddDimensionGroupRequest","doc":"*   `range` (*type:* `GoogleApi.Sheets.V4.Model.DimensionRange.t`, *default:* `nil`) - The range over which to create a group.","ref":"GoogleApi.Sheets.V4.Model.AddDimensionGroupRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddDimensionGroupRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddDimensionGroupRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddDimensionGroupRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddDimensionGroupRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddDimensionGroupResponse","doc":"The result of adding a group.","ref":"GoogleApi.Sheets.V4.Model.AddDimensionGroupResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddDimensionGroupResponse","doc":"*   `dimensionGroups` (*type:* `list(GoogleApi.Sheets.V4.Model.DimensionGroup.t)`, *default:* `nil`) - All groups of a dimension after adding a group to that dimension.","ref":"GoogleApi.Sheets.V4.Model.AddDimensionGroupResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddDimensionGroupResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddDimensionGroupResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddDimensionGroupResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddDimensionGroupResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddFilterViewRequest","doc":"Adds a filter view.","ref":"GoogleApi.Sheets.V4.Model.AddFilterViewRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddFilterViewRequest","doc":"*   `filter` (*type:* `GoogleApi.Sheets.V4.Model.FilterView.t`, *default:* `nil`) - The filter to add. The filterViewId field is optional; if one is not set, an id will be randomly generated. (It is an error to specify the ID of a filter that already exists.)","ref":"GoogleApi.Sheets.V4.Model.AddFilterViewRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddFilterViewRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddFilterViewRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddFilterViewRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddFilterViewRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddFilterViewResponse","doc":"The result of adding a filter view.","ref":"GoogleApi.Sheets.V4.Model.AddFilterViewResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddFilterViewResponse","doc":"*   `filter` (*type:* `GoogleApi.Sheets.V4.Model.FilterView.t`, *default:* `nil`) - The newly added filter view.","ref":"GoogleApi.Sheets.V4.Model.AddFilterViewResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddFilterViewResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddFilterViewResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddFilterViewResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddFilterViewResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddNamedRangeRequest","doc":"Adds a named range to the spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.AddNamedRangeRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddNamedRangeRequest","doc":"*   `namedRange` (*type:* `GoogleApi.Sheets.V4.Model.NamedRange.t`, *default:* `nil`) - The named range to add. The namedRangeId field is optional; if one is not set, an id will be randomly generated. (It is an error to specify the ID of a range that already exists.)","ref":"GoogleApi.Sheets.V4.Model.AddNamedRangeRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddNamedRangeRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddNamedRangeRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddNamedRangeRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddNamedRangeRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddNamedRangeResponse","doc":"The result of adding a named range.","ref":"GoogleApi.Sheets.V4.Model.AddNamedRangeResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddNamedRangeResponse","doc":"*   `namedRange` (*type:* `GoogleApi.Sheets.V4.Model.NamedRange.t`, *default:* `nil`) - The named range to add.","ref":"GoogleApi.Sheets.V4.Model.AddNamedRangeResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddNamedRangeResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddNamedRangeResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddNamedRangeResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddNamedRangeResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddProtectedRangeRequest","doc":"Adds a new protected range.","ref":"GoogleApi.Sheets.V4.Model.AddProtectedRangeRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddProtectedRangeRequest","doc":"*   `protectedRange` (*type:* `GoogleApi.Sheets.V4.Model.ProtectedRange.t`, *default:* `nil`) - The protected range to be added. The protectedRangeId field is optional; if one is not set, an id will be randomly generated. (It is an error to specify the ID of a range that already exists.)","ref":"GoogleApi.Sheets.V4.Model.AddProtectedRangeRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddProtectedRangeRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddProtectedRangeRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddProtectedRangeRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddProtectedRangeRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddProtectedRangeResponse","doc":"The result of adding a new protected range.","ref":"GoogleApi.Sheets.V4.Model.AddProtectedRangeResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddProtectedRangeResponse","doc":"*   `protectedRange` (*type:* `GoogleApi.Sheets.V4.Model.ProtectedRange.t`, *default:* `nil`) - The newly added protected range.","ref":"GoogleApi.Sheets.V4.Model.AddProtectedRangeResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddProtectedRangeResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddProtectedRangeResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddProtectedRangeResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddProtectedRangeResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddSheetRequest","doc":"Adds a new sheet. When a sheet is added at a given index, all subsequent sheets' indexes are incremented. To add an object sheet, use AddChartRequest instead and specify EmbeddedObjectPosition.sheetId or EmbeddedObjectPosition.newSheet.","ref":"GoogleApi.Sheets.V4.Model.AddSheetRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddSheetRequest","doc":"*   `properties` (*type:* `GoogleApi.Sheets.V4.Model.SheetProperties.t`, *default:* `nil`) - The properties the new sheet should have. All properties are optional. The sheetId field is optional; if one is not set, an id will be randomly generated. (It is an error to specify the ID of a sheet that already exists.)","ref":"GoogleApi.Sheets.V4.Model.AddSheetRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddSheetRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddSheetRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddSheetRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddSheetRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddSheetResponse","doc":"The result of adding a sheet.","ref":"GoogleApi.Sheets.V4.Model.AddSheetResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddSheetResponse","doc":"*   `properties` (*type:* `GoogleApi.Sheets.V4.Model.SheetProperties.t`, *default:* `nil`) - The properties of the newly added sheet.","ref":"GoogleApi.Sheets.V4.Model.AddSheetResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddSheetResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddSheetResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddSheetResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddSheetResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddSlicerRequest","doc":"Adds a slicer to a sheet in the spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.AddSlicerRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddSlicerRequest","doc":"*   `slicer` (*type:* `GoogleApi.Sheets.V4.Model.Slicer.t`, *default:* `nil`) - The slicer that should be added to the spreadsheet, including the position where it should be placed. The slicerId field is optional; if one is not set, an id will be randomly generated. (It is an error to specify the ID of a slicer that already exists.)","ref":"GoogleApi.Sheets.V4.Model.AddSlicerRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddSlicerRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddSlicerRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddSlicerRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddSlicerRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AddSlicerResponse","doc":"The result of adding a slicer to a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.AddSlicerResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AddSlicerResponse","doc":"*   `slicer` (*type:* `GoogleApi.Sheets.V4.Model.Slicer.t`, *default:* `nil`) - The newly added slicer.","ref":"GoogleApi.Sheets.V4.Model.AddSlicerResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AddSlicerResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AddSlicerResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AddSlicerResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AddSlicerResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AppendCellsRequest","doc":"Adds new cells after the last row with data in a sheet, inserting new rows into the sheet if necessary.","ref":"GoogleApi.Sheets.V4.Model.AppendCellsRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AppendCellsRequest","doc":"*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields of CellData that should be updated. At least one field must be specified. The root is the CellData; 'row.values.' should not be specified. A single `\"*\"` can be used as short-hand for listing every field.\n*   `rows` (*type:* `list(GoogleApi.Sheets.V4.Model.RowData.t)`, *default:* `nil`) - The data to append.\n*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The sheet ID to append the data to.","ref":"GoogleApi.Sheets.V4.Model.AppendCellsRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AppendCellsRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AppendCellsRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AppendCellsRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AppendCellsRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AppendDimensionRequest","doc":"Appends rows or columns to the end of a sheet.","ref":"GoogleApi.Sheets.V4.Model.AppendDimensionRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AppendDimensionRequest","doc":"*   `dimension` (*type:* `String.t`, *default:* `nil`) - Whether rows or columns should be appended.\n*   `length` (*type:* `integer()`, *default:* `nil`) - The number of rows or columns to append.\n*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The sheet to append rows or columns to.","ref":"GoogleApi.Sheets.V4.Model.AppendDimensionRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AppendDimensionRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AppendDimensionRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AppendDimensionRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AppendDimensionRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AppendValuesResponse","doc":"The response when updating a range of values in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.AppendValuesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AppendValuesResponse","doc":"*   `spreadsheetId` (*type:* `String.t`, *default:* `nil`) - The spreadsheet the updates were applied to.\n*   `tableRange` (*type:* `String.t`, *default:* `nil`) - The range (in A1 notation) of the table that values are being appended to (before the values were appended). Empty if no table was found.\n*   `updates` (*type:* `GoogleApi.Sheets.V4.Model.UpdateValuesResponse.t`, *default:* `nil`) - Information about the updates that were applied.","ref":"GoogleApi.Sheets.V4.Model.AppendValuesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AppendValuesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AppendValuesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AppendValuesResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AppendValuesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AutoFillRequest","doc":"Fills in more data based on existing data.","ref":"GoogleApi.Sheets.V4.Model.AutoFillRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AutoFillRequest","doc":"*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range to autofill. This will examine the range and detect the location that has data and automatically fill that data in to the rest of the range.\n*   `sourceAndDestination` (*type:* `GoogleApi.Sheets.V4.Model.SourceAndDestination.t`, *default:* `nil`) - The source and destination areas to autofill. This explicitly lists the source of the autofill and where to extend that data.\n*   `useAlternateSeries` (*type:* `boolean()`, *default:* `nil`) - True if we should generate data with the \"alternate\" series. This differs based on the type and amount of source data.","ref":"GoogleApi.Sheets.V4.Model.AutoFillRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AutoFillRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AutoFillRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AutoFillRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AutoFillRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.AutoResizeDimensionsRequest","doc":"Automatically resizes one or more dimensions based on the contents of the cells in that dimension.","ref":"GoogleApi.Sheets.V4.Model.AutoResizeDimensionsRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.AutoResizeDimensionsRequest","doc":"*   `dataSourceSheetDimensions` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceSheetDimensionRange.t`, *default:* `nil`) - The dimensions on a data source sheet to automatically resize.\n*   `dimensions` (*type:* `GoogleApi.Sheets.V4.Model.DimensionRange.t`, *default:* `nil`) - The dimensions to automatically resize.","ref":"GoogleApi.Sheets.V4.Model.AutoResizeDimensionsRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.AutoResizeDimensionsRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.AutoResizeDimensionsRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.AutoResizeDimensionsRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.AutoResizeDimensionsRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BandedRange","doc":"A banded (alternating colors) range in a sheet.","ref":"GoogleApi.Sheets.V4.Model.BandedRange.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BandedRange","doc":"*   `bandedRangeId` (*type:* `integer()`, *default:* `nil`) - The ID of the banded range.\n*   `columnProperties` (*type:* `GoogleApi.Sheets.V4.Model.BandingProperties.t`, *default:* `nil`) - Properties for column bands. These properties are applied on a column- by-column basis throughout all the columns in the range. At least one of row_properties or column_properties must be specified.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range over which these properties are applied.\n*   `rowProperties` (*type:* `GoogleApi.Sheets.V4.Model.BandingProperties.t`, *default:* `nil`) - Properties for row bands. These properties are applied on a row-by-row basis throughout all the rows in the range. At least one of row_properties or column_properties must be specified.","ref":"GoogleApi.Sheets.V4.Model.BandedRange.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BandedRange.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BandedRange.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BandedRange.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BandedRange.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BandingProperties","doc":"Properties referring a single dimension (either row or column). If both BandedRange.row_properties and BandedRange.column_properties are set, the fill colors are applied to cells according to the following rules: * header_color and footer_color take priority over band colors. * first_band_color takes priority over second_band_color. * row_properties takes priority over column_properties. For example, the first row color takes priority over the first column color, but the first column color takes priority over the second row color. Similarly, the row header takes priority over the column header in the top left cell, but the column header takes priority over the first row color if the row header is not set.","ref":"GoogleApi.Sheets.V4.Model.BandingProperties.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BandingProperties","doc":"*   `firstBandColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The first color that is alternating. (Required) Deprecated: Use first_band_color_style.\n*   `firstBandColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The first color that is alternating. (Required) If first_band_color is also set, this field takes precedence.\n*   `footerColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The color of the last row or column. If this field is not set, the last row or column is filled with either first_band_color or second_band_color, depending on the color of the previous row or column. Deprecated: Use footer_color_style.\n*   `footerColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The color of the last row or column. If this field is not set, the last row or column is filled with either first_band_color or second_band_color, depending on the color of the previous row or column. If footer_color is also set, this field takes precedence.\n*   `headerColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The color of the first row or column. If this field is set, the first row or column is filled with this color and the colors alternate between first_band_color and second_band_color starting from the second row or column. Otherwise, the first row or column is filled with first_band_color and the colors proceed to alternate as they normally would. Deprecated: Use header_color_style.\n*   `headerColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The color of the first row or column. If this field is set, the first row or column is filled with this color and the colors alternate between first_band_color and second_band_color starting from the second row or column. Otherwise, the first row or column is filled with first_band_color and the colors proceed to alternate as they normally would. If header_color is also set, this field takes precedence.\n*   `secondBandColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The second color that is alternating. (Required) Deprecated: Use second_band_color_style.\n*   `secondBandColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The second color that is alternating. (Required) If second_band_color is also set, this field takes precedence.","ref":"GoogleApi.Sheets.V4.Model.BandingProperties.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BandingProperties.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BandingProperties.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BandingProperties.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BandingProperties.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BaselineValueFormat","doc":"Formatting options for baseline value.","ref":"GoogleApi.Sheets.V4.Model.BaselineValueFormat.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BaselineValueFormat","doc":"*   `comparisonType` (*type:* `String.t`, *default:* `nil`) - The comparison type of key value with baseline value.\n*   `description` (*type:* `String.t`, *default:* `nil`) - Description which is appended after the baseline value. This field is optional.\n*   `negativeColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - Color to be used, in case baseline value represents a negative change for key value. This field is optional. Deprecated: Use negative_color_style.\n*   `negativeColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - Color to be used, in case baseline value represents a negative change for key value. This field is optional. If negative_color is also set, this field takes precedence.\n*   `position` (*type:* `GoogleApi.Sheets.V4.Model.TextPosition.t`, *default:* `nil`) - Specifies the horizontal text positioning of baseline value. This field is optional. If not specified, default positioning is used.\n*   `positiveColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - Color to be used, in case baseline value represents a positive change for key value. This field is optional. Deprecated: Use positive_color_style.\n*   `positiveColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - Color to be used, in case baseline value represents a positive change for key value. This field is optional. If positive_color is also set, this field takes precedence.\n*   `textFormat` (*type:* `GoogleApi.Sheets.V4.Model.TextFormat.t`, *default:* `nil`) - Text formatting options for baseline value. The link field is not supported.","ref":"GoogleApi.Sheets.V4.Model.BaselineValueFormat.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BaselineValueFormat.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BaselineValueFormat.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BaselineValueFormat.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BaselineValueFormat.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BasicChartAxis","doc":"An axis of the chart. A chart may not have more than one axis per axis position.","ref":"GoogleApi.Sheets.V4.Model.BasicChartAxis.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BasicChartAxis","doc":"*   `format` (*type:* `GoogleApi.Sheets.V4.Model.TextFormat.t`, *default:* `nil`) - The format of the title. Only valid if the axis is not associated with the domain. The link field is not supported.\n*   `position` (*type:* `String.t`, *default:* `nil`) - The position of this axis.\n*   `title` (*type:* `String.t`, *default:* `nil`) - The title of this axis. If set, this overrides any title inferred from headers of the data.\n*   `titleTextPosition` (*type:* `GoogleApi.Sheets.V4.Model.TextPosition.t`, *default:* `nil`) - The axis title text position.\n*   `viewWindowOptions` (*type:* `GoogleApi.Sheets.V4.Model.ChartAxisViewWindowOptions.t`, *default:* `nil`) - The view window options for this axis.","ref":"GoogleApi.Sheets.V4.Model.BasicChartAxis.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BasicChartAxis.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BasicChartAxis.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BasicChartAxis.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BasicChartAxis.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BasicChartDomain","doc":"The domain of a chart. For example, if charting stock prices over time, this would be the date.","ref":"GoogleApi.Sheets.V4.Model.BasicChartDomain.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BasicChartDomain","doc":"*   `domain` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data of the domain. For example, if charting stock prices over time, this is the data representing the dates.\n*   `reversed` (*type:* `boolean()`, *default:* `nil`) - True to reverse the order of the domain values (horizontal axis).","ref":"GoogleApi.Sheets.V4.Model.BasicChartDomain.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BasicChartDomain.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BasicChartDomain.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BasicChartDomain.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BasicChartDomain.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BasicChartSeries","doc":"A single series of data in a chart. For example, if charting stock prices over time, multiple series may exist, one for the \"Open Price\", \"High Price\", \"Low Price\" and \"Close Price\".","ref":"GoogleApi.Sheets.V4.Model.BasicChartSeries.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BasicChartSeries","doc":"*   `color` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The color for elements (such as bars, lines, and points) associated with this series. If empty, a default color is used. Deprecated: Use color_style.\n*   `colorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The color for elements (such as bars, lines, and points) associated with this series. If empty, a default color is used. If color is also set, this field takes precedence.\n*   `dataLabel` (*type:* `GoogleApi.Sheets.V4.Model.DataLabel.t`, *default:* `nil`) - Information about the data labels for this series.\n*   `lineStyle` (*type:* `GoogleApi.Sheets.V4.Model.LineStyle.t`, *default:* `nil`) - The line style of this series. Valid only if the chartType is AREA, LINE, or SCATTER. COMBO charts are also supported if the series chart type is AREA or LINE.\n*   `pointStyle` (*type:* `GoogleApi.Sheets.V4.Model.PointStyle.t`, *default:* `nil`) - The style for points associated with this series. Valid only if the chartType is AREA, LINE, or SCATTER. COMBO charts are also supported if the series chart type is AREA, LINE, or SCATTER. If empty, a default point style is used.\n*   `series` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data being visualized in this chart series.\n*   `styleOverrides` (*type:* `list(GoogleApi.Sheets.V4.Model.BasicSeriesDataPointStyleOverride.t)`, *default:* `nil`) - Style override settings for series data points.\n*   `targetAxis` (*type:* `String.t`, *default:* `nil`) - The minor axis that will specify the range of values for this series. For example, if charting stocks over time, the \"Volume\" series may want to be pinned to the right with the prices pinned to the left, because the scale of trading volume is different than the scale of prices. It is an error to specify an axis that isn't a valid minor axis for the chart's type.\n*   `type` (*type:* `String.t`, *default:* `nil`) - The type of this series. Valid only if the chartType is COMBO. Different types will change the way the series is visualized. Only LINE, AREA, and COLUMN are supported.","ref":"GoogleApi.Sheets.V4.Model.BasicChartSeries.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BasicChartSeries.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BasicChartSeries.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BasicChartSeries.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BasicChartSeries.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BasicChartSpec","doc":"The specification for a basic chart. See BasicChartType for the list of charts this supports.","ref":"GoogleApi.Sheets.V4.Model.BasicChartSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BasicChartSpec","doc":"*   `axis` (*type:* `list(GoogleApi.Sheets.V4.Model.BasicChartAxis.t)`, *default:* `nil`) - The axis on the chart.\n*   `chartType` (*type:* `String.t`, *default:* `nil`) - The type of the chart.\n*   `compareMode` (*type:* `String.t`, *default:* `nil`) - The behavior of tooltips and data highlighting when hovering on data and chart area.\n*   `domains` (*type:* `list(GoogleApi.Sheets.V4.Model.BasicChartDomain.t)`, *default:* `nil`) - The domain of data this is charting. Only a single domain is supported.\n*   `headerCount` (*type:* `integer()`, *default:* `nil`) - The number of rows or columns in the data that are \"headers\". If not set, Google Sheets will guess how many rows are headers based on the data. (Note that BasicChartAxis.title may override the axis title inferred from the header values.)\n*   `interpolateNulls` (*type:* `boolean()`, *default:* `nil`) - If some values in a series are missing, gaps may appear in the chart (e.g, segments of lines in a line chart will be missing). To eliminate these gaps set this to true. Applies to Line, Area, and Combo charts.\n*   `legendPosition` (*type:* `String.t`, *default:* `nil`) - The position of the chart legend.\n*   `lineSmoothing` (*type:* `boolean()`, *default:* `nil`) - Gets whether all lines should be rendered smooth or straight by default. Applies to Line charts.\n*   `series` (*type:* `list(GoogleApi.Sheets.V4.Model.BasicChartSeries.t)`, *default:* `nil`) - The data this chart is visualizing.\n*   `stackedType` (*type:* `String.t`, *default:* `nil`) - The stacked type for charts that support vertical stacking. Applies to Area, Bar, Column, Combo, and Stepped Area charts.\n*   `threeDimensional` (*type:* `boolean()`, *default:* `nil`) - True to make the chart 3D. Applies to Bar and Column charts.\n*   `totalDataLabel` (*type:* `GoogleApi.Sheets.V4.Model.DataLabel.t`, *default:* `nil`) - Controls whether to display additional data labels on stacked charts which sum the total value of all stacked values at each value along the domain axis. These data labels can only be set when chart_type is one of AREA, BAR, COLUMN, COMBO or STEPPED_AREA and stacked_type is either STACKED or PERCENT_STACKED. In addition, for COMBO, this will only be supported if there is only one type of stackable series type or one type has more series than the others and each of the other types have no more than one series. For example, if a chart has two stacked bar series and one area series, the total data labels will be supported. If it has three bar series and two area series, total data labels are not allowed. Neither CUSTOM nor placement can be set on the total_data_label.","ref":"GoogleApi.Sheets.V4.Model.BasicChartSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BasicChartSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BasicChartSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BasicChartSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BasicChartSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BasicFilter","doc":"The default filter associated with a sheet.","ref":"GoogleApi.Sheets.V4.Model.BasicFilter.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BasicFilter","doc":"*   `criteria` (*type:* `%{optional(String.t) => GoogleApi.Sheets.V4.Model.FilterCriteria.t}`, *default:* `nil`) - The criteria for showing/hiding values per column. The map's key is the column index, and the value is the criteria for that column. This field is deprecated in favor of filter_specs.\n*   `filterSpecs` (*type:* `list(GoogleApi.Sheets.V4.Model.FilterSpec.t)`, *default:* `nil`) - The filter criteria per column. Both criteria and filter_specs are populated in responses. If both fields are specified in an update request, this field takes precedence.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range the filter covers.\n*   `sortSpecs` (*type:* `list(GoogleApi.Sheets.V4.Model.SortSpec.t)`, *default:* `nil`) - The sort order per column. Later specifications are used when values are equal in the earlier specifications.","ref":"GoogleApi.Sheets.V4.Model.BasicFilter.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BasicFilter.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BasicFilter.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BasicFilter.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BasicFilter.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BasicSeriesDataPointStyleOverride","doc":"Style override settings for a single series data point.","ref":"GoogleApi.Sheets.V4.Model.BasicSeriesDataPointStyleOverride.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BasicSeriesDataPointStyleOverride","doc":"*   `color` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - Color of the series data point. If empty, the series default is used. Deprecated: Use color_style.\n*   `colorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - Color of the series data point. If empty, the series default is used. If color is also set, this field takes precedence.\n*   `index` (*type:* `integer()`, *default:* `nil`) - The zero-based index of the series data point.\n*   `pointStyle` (*type:* `GoogleApi.Sheets.V4.Model.PointStyle.t`, *default:* `nil`) - Point style of the series data point. Valid only if the chartType is AREA, LINE, or SCATTER. COMBO charts are also supported if the series chart type is AREA, LINE, or SCATTER. If empty, the series default is used.","ref":"GoogleApi.Sheets.V4.Model.BasicSeriesDataPointStyleOverride.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BasicSeriesDataPointStyleOverride.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BasicSeriesDataPointStyleOverride.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BasicSeriesDataPointStyleOverride.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BasicSeriesDataPointStyleOverride.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterRequest","doc":"The request for clearing more than one range selected by a DataFilter in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterRequest","doc":"*   `dataFilters` (*type:* `list(GoogleApi.Sheets.V4.Model.DataFilter.t)`, *default:* `nil`) - The DataFilters used to determine which ranges to clear.","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterResponse","doc":"The response when clearing a range of values selected with DataFilters in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterResponse","doc":"*   `clearedRanges` (*type:* `list(String.t)`, *default:* `nil`) - The ranges that were cleared, in [A1 notation](/sheets/api/guides/concepts#cell). If the requests are for an unbounded range or a ranger larger than the bounds of the sheet, this is the actual ranges that were cleared, bounded to the sheet's limits.\n*   `spreadsheetId` (*type:* `String.t`, *default:* `nil`) - The spreadsheet the updates were applied to.","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesByDataFilterResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BatchClearValuesRequest","doc":"The request for clearing more than one range of values in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BatchClearValuesRequest","doc":"*   `ranges` (*type:* `list(String.t)`, *default:* `nil`) - The ranges to clear, in [A1 notation or R1C1 notation](/sheets/api/guides/concepts#cell).","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BatchClearValuesRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BatchClearValuesRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BatchClearValuesResponse","doc":"The response when clearing a range of values in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BatchClearValuesResponse","doc":"*   `clearedRanges` (*type:* `list(String.t)`, *default:* `nil`) - The ranges that were cleared, in A1 notation. If the requests are for an unbounded range or a ranger larger than the bounds of the sheet, this is the actual ranges that were cleared, bounded to the sheet's limits.\n*   `spreadsheetId` (*type:* `String.t`, *default:* `nil`) - The spreadsheet the updates were applied to.","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BatchClearValuesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BatchClearValuesResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BatchClearValuesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterRequest","doc":"The request for retrieving a range of values in a spreadsheet selected by a set of DataFilters.","ref":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterRequest","doc":"*   `dataFilters` (*type:* `list(GoogleApi.Sheets.V4.Model.DataFilter.t)`, *default:* `nil`) - The data filters used to match the ranges of values to retrieve. Ranges that match any of the specified data filters are included in the response.\n*   `dateTimeRenderOption` (*type:* `String.t`, *default:* `nil`) - How dates, times, and durations should be represented in the output. This is ignored if value_render_option is FORMATTED_VALUE. The default dateTime render option is SERIAL_NUMBER.\n*   `majorDimension` (*type:* `String.t`, *default:* `nil`) - The major dimension that results should use. For example, if the spreadsheet data is: `A1=1,B1=2,A2=3,B2=4`, then a request that selects that range and sets `majorDimension=ROWS` returns `[[1,2],[3,4]]`, whereas a request that sets `majorDimension=COLUMNS` returns `[[1,3],[2,4]]`.\n*   `valueRenderOption` (*type:* `String.t`, *default:* `nil`) - How values should be represented in the output. The default render option is FORMATTED_VALUE.","ref":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterResponse","doc":"The response when retrieving more than one range of values in a spreadsheet selected by DataFilters.","ref":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterResponse","doc":"*   `spreadsheetId` (*type:* `String.t`, *default:* `nil`) - The ID of the spreadsheet the data was retrieved from.\n*   `valueRanges` (*type:* `list(GoogleApi.Sheets.V4.Model.MatchedValueRange.t)`, *default:* `nil`) - The requested values with the list of data filters that matched them.","ref":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BatchGetValuesByDataFilterResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BatchGetValuesResponse","doc":"The response when retrieving more than one range of values in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.BatchGetValuesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BatchGetValuesResponse","doc":"*   `spreadsheetId` (*type:* `String.t`, *default:* `nil`) - The ID of the spreadsheet the data was retrieved from.\n*   `valueRanges` (*type:* `list(GoogleApi.Sheets.V4.Model.ValueRange.t)`, *default:* `nil`) - The requested values. The order of the ValueRanges is the same as the order of the requested ranges.","ref":"GoogleApi.Sheets.V4.Model.BatchGetValuesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BatchGetValuesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BatchGetValuesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BatchGetValuesResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BatchGetValuesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetRequest","doc":"The request for updating any aspect of a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetRequest","doc":"*   `includeSpreadsheetInResponse` (*type:* `boolean()`, *default:* `nil`) - Determines if the update response should include the spreadsheet resource.\n*   `requests` (*type:* `list(GoogleApi.Sheets.V4.Model.Request.t)`, *default:* `nil`) - A list of updates to apply to the spreadsheet. Requests will be applied in the order they are specified. If any request is not valid, no requests will be applied.\n*   `responseIncludeGridData` (*type:* `boolean()`, *default:* `nil`) - True if grid data should be returned. Meaningful only if include_spreadsheet_in_response is 'true'. This parameter is ignored if a field mask was set in the request.\n*   `responseRanges` (*type:* `list(String.t)`, *default:* `nil`) - Limits the ranges included in the response spreadsheet. Meaningful only if include_spreadsheet_in_response is 'true'.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetResponse","doc":"The reply for batch updating a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetResponse","doc":"*   `replies` (*type:* `list(GoogleApi.Sheets.V4.Model.Response.t)`, *default:* `nil`) - The reply of the updates. This maps 1:1 with the updates, although replies to some requests may be empty.\n*   `spreadsheetId` (*type:* `String.t`, *default:* `nil`) - The spreadsheet the updates were applied to.\n*   `updatedSpreadsheet` (*type:* `GoogleApi.Sheets.V4.Model.Spreadsheet.t`, *default:* `nil`) - The spreadsheet after updates were applied. This is only set if BatchUpdateSpreadsheetRequest.include_spreadsheet_in_response is `true`.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateSpreadsheetResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterRequest","doc":"The request for updating more than one range of values in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterRequest","doc":"*   `data` (*type:* `list(GoogleApi.Sheets.V4.Model.DataFilterValueRange.t)`, *default:* `nil`) - The new values to apply to the spreadsheet. If more than one range is matched by the specified DataFilter the specified values are applied to all of those ranges.\n*   `includeValuesInResponse` (*type:* `boolean()`, *default:* `nil`) - Determines if the update response should include the values of the cells that were updated. By default, responses do not include the updated values. The `updatedData` field within each of the BatchUpdateValuesResponse.responses contains the updated values. If the range to write was larger than the range actually written, the response includes all values in the requested range (excluding trailing empty rows and columns).\n*   `responseDateTimeRenderOption` (*type:* `String.t`, *default:* `nil`) - Determines how dates, times, and durations in the response should be rendered. This is ignored if response_value_render_option is FORMATTED_VALUE. The default dateTime render option is SERIAL_NUMBER.\n*   `responseValueRenderOption` (*type:* `String.t`, *default:* `nil`) - Determines how values in the response should be rendered. The default render option is FORMATTED_VALUE.\n*   `valueInputOption` (*type:* `String.t`, *default:* `nil`) - How the input data should be interpreted.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterResponse","doc":"The response when updating a range of values in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterResponse","doc":"*   `responses` (*type:* `list(GoogleApi.Sheets.V4.Model.UpdateValuesByDataFilterResponse.t)`, *default:* `nil`) - The response for each range updated.\n*   `spreadsheetId` (*type:* `String.t`, *default:* `nil`) - The spreadsheet the updates were applied to.\n*   `totalUpdatedCells` (*type:* `integer()`, *default:* `nil`) - The total number of cells updated.\n*   `totalUpdatedColumns` (*type:* `integer()`, *default:* `nil`) - The total number of columns where at least one cell in the column was updated.\n*   `totalUpdatedRows` (*type:* `integer()`, *default:* `nil`) - The total number of rows where at least one cell in the row was updated.\n*   `totalUpdatedSheets` (*type:* `integer()`, *default:* `nil`) - The total number of sheets where at least one cell in the sheet was updated.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesByDataFilterResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesRequest","doc":"The request for updating more than one range of values in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BatchUpdateValuesRequest","doc":"*   `data` (*type:* `list(GoogleApi.Sheets.V4.Model.ValueRange.t)`, *default:* `nil`) - The new values to apply to the spreadsheet.\n*   `includeValuesInResponse` (*type:* `boolean()`, *default:* `nil`) - Determines if the update response should include the values of the cells that were updated. By default, responses do not include the updated values. The `updatedData` field within each of the BatchUpdateValuesResponse.responses contains the updated values. If the range to write was larger than the range actually written, the response includes all values in the requested range (excluding trailing empty rows and columns).\n*   `responseDateTimeRenderOption` (*type:* `String.t`, *default:* `nil`) - Determines how dates, times, and durations in the response should be rendered. This is ignored if response_value_render_option is FORMATTED_VALUE. The default dateTime render option is SERIAL_NUMBER.\n*   `responseValueRenderOption` (*type:* `String.t`, *default:* `nil`) - Determines how values in the response should be rendered. The default render option is FORMATTED_VALUE.\n*   `valueInputOption` (*type:* `String.t`, *default:* `nil`) - How the input data should be interpreted.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesResponse","doc":"The response when updating a range of values in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BatchUpdateValuesResponse","doc":"*   `responses` (*type:* `list(GoogleApi.Sheets.V4.Model.UpdateValuesResponse.t)`, *default:* `nil`) - One UpdateValuesResponse per requested range, in the same order as the requests appeared.\n*   `spreadsheetId` (*type:* `String.t`, *default:* `nil`) - The spreadsheet the updates were applied to.\n*   `totalUpdatedCells` (*type:* `integer()`, *default:* `nil`) - The total number of cells updated.\n*   `totalUpdatedColumns` (*type:* `integer()`, *default:* `nil`) - The total number of columns where at least one cell in the column was updated.\n*   `totalUpdatedRows` (*type:* `integer()`, *default:* `nil`) - The total number of rows where at least one cell in the row was updated.\n*   `totalUpdatedSheets` (*type:* `integer()`, *default:* `nil`) - The total number of sheets where at least one cell in the sheet was updated.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BatchUpdateValuesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BigQueryDataSourceSpec","doc":"The specification of a BigQuery data source that's connected to a sheet.","ref":"GoogleApi.Sheets.V4.Model.BigQueryDataSourceSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BigQueryDataSourceSpec","doc":"*   `projectId` (*type:* `String.t`, *default:* `nil`) - The ID of a BigQuery enabled Google Cloud project with a billing account attached. For any queries executed against the data source, the project is charged.\n*   `querySpec` (*type:* `GoogleApi.Sheets.V4.Model.BigQueryQuerySpec.t`, *default:* `nil`) - A BigQueryQuerySpec.\n*   `tableSpec` (*type:* `GoogleApi.Sheets.V4.Model.BigQueryTableSpec.t`, *default:* `nil`) - A BigQueryTableSpec.","ref":"GoogleApi.Sheets.V4.Model.BigQueryDataSourceSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BigQueryDataSourceSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BigQueryDataSourceSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BigQueryDataSourceSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BigQueryDataSourceSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BigQueryQuerySpec","doc":"Specifies a custom BigQuery query.","ref":"GoogleApi.Sheets.V4.Model.BigQueryQuerySpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BigQueryQuerySpec","doc":"*   `rawQuery` (*type:* `String.t`, *default:* `nil`) - The raw query string.","ref":"GoogleApi.Sheets.V4.Model.BigQueryQuerySpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BigQueryQuerySpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BigQueryQuerySpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BigQueryQuerySpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BigQueryQuerySpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BigQueryTableSpec","doc":"Specifies a BigQuery table definition. Only [native tables](https://cloud.google.com/bigquery/docs/tables-intro) are allowed.","ref":"GoogleApi.Sheets.V4.Model.BigQueryTableSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BigQueryTableSpec","doc":"*   `datasetId` (*type:* `String.t`, *default:* `nil`) - The BigQuery dataset id.\n*   `tableId` (*type:* `String.t`, *default:* `nil`) - The BigQuery table id.\n*   `tableProjectId` (*type:* `String.t`, *default:* `nil`) - The ID of a BigQuery project the table belongs to. If not specified, the project_id is assumed.","ref":"GoogleApi.Sheets.V4.Model.BigQueryTableSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BigQueryTableSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BigQueryTableSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BigQueryTableSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BigQueryTableSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BooleanCondition","doc":"A condition that can evaluate to true or false. BooleanConditions are used by conditional formatting, data validation, and the criteria in filters.","ref":"GoogleApi.Sheets.V4.Model.BooleanCondition.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BooleanCondition","doc":"*   `type` (*type:* `String.t`, *default:* `nil`) - The type of condition.\n*   `values` (*type:* `list(GoogleApi.Sheets.V4.Model.ConditionValue.t)`, *default:* `nil`) - The values of the condition. The number of supported values depends on the condition type. Some support zero values, others one or two values, and ConditionType.ONE_OF_LIST supports an arbitrary number of values.","ref":"GoogleApi.Sheets.V4.Model.BooleanCondition.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BooleanCondition.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BooleanCondition.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BooleanCondition.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BooleanCondition.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BooleanRule","doc":"A rule that may or may not match, depending on the condition.","ref":"GoogleApi.Sheets.V4.Model.BooleanRule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BooleanRule","doc":"*   `condition` (*type:* `GoogleApi.Sheets.V4.Model.BooleanCondition.t`, *default:* `nil`) - The condition of the rule. If the condition evaluates to true, the format is applied.\n*   `format` (*type:* `GoogleApi.Sheets.V4.Model.CellFormat.t`, *default:* `nil`) - The format to apply. Conditional formatting can only apply a subset of formatting: bold, italic, strikethrough, foreground color and, background color.","ref":"GoogleApi.Sheets.V4.Model.BooleanRule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BooleanRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BooleanRule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BooleanRule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BooleanRule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.Border","doc":"A border along a cell.","ref":"GoogleApi.Sheets.V4.Model.Border.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.Border","doc":"*   `color` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The color of the border. Deprecated: Use color_style.\n*   `colorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The color of the border. If color is also set, this field takes precedence.\n*   `style` (*type:* `String.t`, *default:* `nil`) - The style of the border.\n*   `width` (*type:* `integer()`, *default:* `nil`) - The width of the border, in pixels. Deprecated; the width is determined by the \"style\" field.","ref":"GoogleApi.Sheets.V4.Model.Border.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.Border.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.Border.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.Border.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.Border.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.Borders","doc":"The borders of the cell.","ref":"GoogleApi.Sheets.V4.Model.Borders.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.Borders","doc":"*   `bottom` (*type:* `GoogleApi.Sheets.V4.Model.Border.t`, *default:* `nil`) - The bottom border of the cell.\n*   `left` (*type:* `GoogleApi.Sheets.V4.Model.Border.t`, *default:* `nil`) - The left border of the cell.\n*   `right` (*type:* `GoogleApi.Sheets.V4.Model.Border.t`, *default:* `nil`) - The right border of the cell.\n*   `top` (*type:* `GoogleApi.Sheets.V4.Model.Border.t`, *default:* `nil`) - The top border of the cell.","ref":"GoogleApi.Sheets.V4.Model.Borders.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.Borders.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.Borders.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.Borders.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.Borders.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.BubbleChartSpec","doc":"A bubble chart.","ref":"GoogleApi.Sheets.V4.Model.BubbleChartSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.BubbleChartSpec","doc":"*   `bubbleBorderColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The bubble border color. Deprecated: Use bubble_border_color_style.\n*   `bubbleBorderColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The bubble border color. If bubble_border_color is also set, this field takes precedence.\n*   `bubbleLabels` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data containing the bubble labels. These do not need to be unique.\n*   `bubbleMaxRadiusSize` (*type:* `integer()`, *default:* `nil`) - The max radius size of the bubbles, in pixels. If specified, the field must be a positive value.\n*   `bubbleMinRadiusSize` (*type:* `integer()`, *default:* `nil`) - The minimum radius size of the bubbles, in pixels. If specific, the field must be a positive value.\n*   `bubbleOpacity` (*type:* `number()`, *default:* `nil`) - The opacity of the bubbles between 0 and 1.0. 0 is fully transparent and 1 is fully opaque.\n*   `bubbleSizes` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data containing the bubble sizes. Bubble sizes are used to draw the bubbles at different sizes relative to each other. If specified, group_ids must also be specified. This field is optional.\n*   `bubbleTextStyle` (*type:* `GoogleApi.Sheets.V4.Model.TextFormat.t`, *default:* `nil`) - The format of the text inside the bubbles. Strikethrough, underline, and link are not supported.\n*   `domain` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data containing the bubble x-values. These values locate the bubbles in the chart horizontally.\n*   `groupIds` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data containing the bubble group IDs. All bubbles with the same group ID are drawn in the same color. If bubble_sizes is specified then this field must also be specified but may contain blank values. This field is optional.\n*   `legendPosition` (*type:* `String.t`, *default:* `nil`) - Where the legend of the chart should be drawn.\n*   `series` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data containing the bubble y-values. These values locate the bubbles in the chart vertically.","ref":"GoogleApi.Sheets.V4.Model.BubbleChartSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.BubbleChartSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.BubbleChartSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.BubbleChartSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.BubbleChartSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.CandlestickChartSpec","doc":"A candlestick chart.","ref":"GoogleApi.Sheets.V4.Model.CandlestickChartSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.CandlestickChartSpec","doc":"*   `data` (*type:* `list(GoogleApi.Sheets.V4.Model.CandlestickData.t)`, *default:* `nil`) - The Candlestick chart data. Only one CandlestickData is supported.\n*   `domain` (*type:* `GoogleApi.Sheets.V4.Model.CandlestickDomain.t`, *default:* `nil`) - The domain data (horizontal axis) for the candlestick chart. String data will be treated as discrete labels, other data will be treated as continuous values.","ref":"GoogleApi.Sheets.V4.Model.CandlestickChartSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.CandlestickChartSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.CandlestickChartSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.CandlestickChartSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.CandlestickChartSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.CandlestickData","doc":"The Candlestick chart data, each containing the low, open, close, and high values for a series.","ref":"GoogleApi.Sheets.V4.Model.CandlestickData.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.CandlestickData","doc":"*   `closeSeries` (*type:* `GoogleApi.Sheets.V4.Model.CandlestickSeries.t`, *default:* `nil`) - The range data (vertical axis) for the close/final value for each candle. This is the top of the candle body. If greater than the open value the candle will be filled. Otherwise the candle will be hollow.\n*   `highSeries` (*type:* `GoogleApi.Sheets.V4.Model.CandlestickSeries.t`, *default:* `nil`) - The range data (vertical axis) for the high/maximum value for each candle. This is the top of the candle's center line.\n*   `lowSeries` (*type:* `GoogleApi.Sheets.V4.Model.CandlestickSeries.t`, *default:* `nil`) - The range data (vertical axis) for the low/minimum value for each candle. This is the bottom of the candle's center line.\n*   `openSeries` (*type:* `GoogleApi.Sheets.V4.Model.CandlestickSeries.t`, *default:* `nil`) - The range data (vertical axis) for the open/initial value for each candle. This is the bottom of the candle body. If less than the close value the candle will be filled. Otherwise the candle will be hollow.","ref":"GoogleApi.Sheets.V4.Model.CandlestickData.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.CandlestickData.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.CandlestickData.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.CandlestickData.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.CandlestickData.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.CandlestickDomain","doc":"The domain of a CandlestickChart.","ref":"GoogleApi.Sheets.V4.Model.CandlestickDomain.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.CandlestickDomain","doc":"*   `data` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data of the CandlestickDomain.\n*   `reversed` (*type:* `boolean()`, *default:* `nil`) - True to reverse the order of the domain values (horizontal axis).","ref":"GoogleApi.Sheets.V4.Model.CandlestickDomain.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.CandlestickDomain.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.CandlestickDomain.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.CandlestickDomain.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.CandlestickDomain.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.CandlestickSeries","doc":"The series of a CandlestickData.","ref":"GoogleApi.Sheets.V4.Model.CandlestickSeries.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.CandlestickSeries","doc":"*   `data` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data of the CandlestickSeries.","ref":"GoogleApi.Sheets.V4.Model.CandlestickSeries.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.CandlestickSeries.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.CandlestickSeries.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.CandlestickSeries.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.CandlestickSeries.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.CellData","doc":"Data about a specific cell.","ref":"GoogleApi.Sheets.V4.Model.CellData.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.CellData","doc":"*   `dataSourceFormula` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceFormula.t`, *default:* `nil`) - Output only. Information about a data source formula on the cell. The field is set if user_entered_value is a formula referencing some DATA_SOURCE sheet, e.g. `=SUM(DataSheet!Column)`.\n*   `dataSourceTable` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceTable.t`, *default:* `nil`) - A data source table anchored at this cell. The size of data source table itself is computed dynamically based on its configuration. Only the first cell of the data source table contains the data source table definition. The other cells will contain the display values of the data source table result in their effective_value fields.\n*   `dataValidation` (*type:* `GoogleApi.Sheets.V4.Model.DataValidationRule.t`, *default:* `nil`) - A data validation rule on the cell, if any. When writing, the new data validation rule will overwrite any prior rule.\n*   `effectiveFormat` (*type:* `GoogleApi.Sheets.V4.Model.CellFormat.t`, *default:* `nil`) - The effective format being used by the cell. This includes the results of applying any conditional formatting and, if the cell contains a formula, the computed number format. If the effective format is the default format, effective format will not be written. This field is read-only.\n*   `effectiveValue` (*type:* `GoogleApi.Sheets.V4.Model.ExtendedValue.t`, *default:* `nil`) - The effective value of the cell. For cells with formulas, this is the calculated value. For cells with literals, this is the same as the user_entered_value. This field is read-only.\n*   `formattedValue` (*type:* `String.t`, *default:* `nil`) - The formatted value of the cell. This is the value as it's shown to the user. This field is read-only.\n*   `hyperlink` (*type:* `String.t`, *default:* `nil`) - A hyperlink this cell points to, if any. If the cell contains multiple hyperlinks, this field will be empty. This field is read-only. To set it, use a `=HYPERLINK` formula in the userEnteredValue.formulaValue field. A cell-level link can also be set from the userEnteredFormat.textFormat field. Alternatively, set a hyperlink in the textFormatRun.format.link field that spans the entire cell.\n*   `note` (*type:* `String.t`, *default:* `nil`) - Any note on the cell.\n*   `pivotTable` (*type:* `GoogleApi.Sheets.V4.Model.PivotTable.t`, *default:* `nil`) - A pivot table anchored at this cell. The size of pivot table itself is computed dynamically based on its data, grouping, filters, values, etc. Only the top-left cell of the pivot table contains the pivot table definition. The other cells will contain the calculated values of the results of the pivot in their effective_value fields.\n*   `textFormatRuns` (*type:* `list(GoogleApi.Sheets.V4.Model.TextFormatRun.t)`, *default:* `nil`) - Runs of rich text applied to subsections of the cell. Runs are only valid on user entered strings, not formulas, bools, or numbers. Properties of a run start at a specific index in the text and continue until the next run. Runs will inherit the properties of the cell unless explicitly changed. When writing, the new runs will overwrite any prior runs. When writing a new user_entered_value, previous runs are erased.\n*   `userEnteredFormat` (*type:* `GoogleApi.Sheets.V4.Model.CellFormat.t`, *default:* `nil`) - The format the user entered for the cell. When writing, the new format will be merged with the existing format.\n*   `userEnteredValue` (*type:* `GoogleApi.Sheets.V4.Model.ExtendedValue.t`, *default:* `nil`) - The value the user entered in the cell. e.g., `1234`, `'Hello'`, or `=NOW()` Note: Dates, Times and DateTimes are represented as doubles in serial number format.","ref":"GoogleApi.Sheets.V4.Model.CellData.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.CellData.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.CellData.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.CellData.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.CellData.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.CellFormat","doc":"The format of a cell.","ref":"GoogleApi.Sheets.V4.Model.CellFormat.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.CellFormat","doc":"*   `backgroundColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The background color of the cell. Deprecated: Use background_color_style.\n*   `backgroundColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The background color of the cell. If background_color is also set, this field takes precedence.\n*   `borders` (*type:* `GoogleApi.Sheets.V4.Model.Borders.t`, *default:* `nil`) - The borders of the cell.\n*   `horizontalAlignment` (*type:* `String.t`, *default:* `nil`) - The horizontal alignment of the value in the cell.\n*   `hyperlinkDisplayType` (*type:* `String.t`, *default:* `nil`) - If one exists, how a hyperlink should be displayed in the cell.\n*   `numberFormat` (*type:* `GoogleApi.Sheets.V4.Model.NumberFormat.t`, *default:* `nil`) - A format describing how number values should be represented to the user.\n*   `padding` (*type:* `GoogleApi.Sheets.V4.Model.Padding.t`, *default:* `nil`) - The padding of the cell.\n*   `textDirection` (*type:* `String.t`, *default:* `nil`) - The direction of the text in the cell.\n*   `textFormat` (*type:* `GoogleApi.Sheets.V4.Model.TextFormat.t`, *default:* `nil`) - The format of the text in the cell (unless overridden by a format run). Setting a cell-level link here clears the cell's existing links. Setting the link field in a TextFormatRun takes precedence over the cell-level link.\n*   `textRotation` (*type:* `GoogleApi.Sheets.V4.Model.TextRotation.t`, *default:* `nil`) - The rotation applied to text in the cell.\n*   `verticalAlignment` (*type:* `String.t`, *default:* `nil`) - The vertical alignment of the value in the cell.\n*   `wrapStrategy` (*type:* `String.t`, *default:* `nil`) - The wrap strategy for the value in the cell.","ref":"GoogleApi.Sheets.V4.Model.CellFormat.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.CellFormat.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.CellFormat.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.CellFormat.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.CellFormat.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ChartAxisViewWindowOptions","doc":"The options that define a \"view window\" for a chart (such as the visible values in an axis).","ref":"GoogleApi.Sheets.V4.Model.ChartAxisViewWindowOptions.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ChartAxisViewWindowOptions","doc":"*   `viewWindowMax` (*type:* `float()`, *default:* `nil`) - The maximum numeric value to be shown in this view window. If unset, will automatically determine a maximum value that looks good for the data.\n*   `viewWindowMin` (*type:* `float()`, *default:* `nil`) - The minimum numeric value to be shown in this view window. If unset, will automatically determine a minimum value that looks good for the data.\n*   `viewWindowMode` (*type:* `String.t`, *default:* `nil`) - The view window's mode.","ref":"GoogleApi.Sheets.V4.Model.ChartAxisViewWindowOptions.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ChartAxisViewWindowOptions.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ChartAxisViewWindowOptions.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ChartAxisViewWindowOptions.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ChartAxisViewWindowOptions.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ChartCustomNumberFormatOptions","doc":"Custom number formatting options for chart attributes.","ref":"GoogleApi.Sheets.V4.Model.ChartCustomNumberFormatOptions.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ChartCustomNumberFormatOptions","doc":"*   `prefix` (*type:* `String.t`, *default:* `nil`) - Custom prefix to be prepended to the chart attribute. This field is optional.\n*   `suffix` (*type:* `String.t`, *default:* `nil`) - Custom suffix to be appended to the chart attribute. This field is optional.","ref":"GoogleApi.Sheets.V4.Model.ChartCustomNumberFormatOptions.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ChartCustomNumberFormatOptions.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ChartCustomNumberFormatOptions.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ChartCustomNumberFormatOptions.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ChartCustomNumberFormatOptions.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ChartData","doc":"The data included in a domain or series.","ref":"GoogleApi.Sheets.V4.Model.ChartData.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ChartData","doc":"*   `aggregateType` (*type:* `String.t`, *default:* `nil`) - The aggregation type for the series of a data source chart. Only supported for data source charts.\n*   `columnReference` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceColumnReference.t`, *default:* `nil`) - The reference to the data source column that the data reads from.\n*   `groupRule` (*type:* `GoogleApi.Sheets.V4.Model.ChartGroupRule.t`, *default:* `nil`) - The rule to group the data by if the ChartData backs the domain of a data source chart. Only supported for data source charts.\n*   `sourceRange` (*type:* `GoogleApi.Sheets.V4.Model.ChartSourceRange.t`, *default:* `nil`) - The source ranges of the data.","ref":"GoogleApi.Sheets.V4.Model.ChartData.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ChartData.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ChartData.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ChartData.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ChartData.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ChartDateTimeRule","doc":"Allows you to organize the date-time values in a source data column into buckets based on selected parts of their date or time values.","ref":"GoogleApi.Sheets.V4.Model.ChartDateTimeRule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ChartDateTimeRule","doc":"*   `type` (*type:* `String.t`, *default:* `nil`) - The type of date-time grouping to apply.","ref":"GoogleApi.Sheets.V4.Model.ChartDateTimeRule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ChartDateTimeRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ChartDateTimeRule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ChartDateTimeRule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ChartDateTimeRule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ChartGroupRule","doc":"An optional setting on the ChartData of the domain of a data source chart that defines buckets for the values in the domain rather than breaking out each individual value. For example, when plotting a data source chart, you can specify a histogram rule on the domain (it should only contain numeric values), grouping its values into buckets. Any values of a chart series that fall into the same bucket are aggregated based on the aggregate_type.","ref":"GoogleApi.Sheets.V4.Model.ChartGroupRule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ChartGroupRule","doc":"*   `dateTimeRule` (*type:* `GoogleApi.Sheets.V4.Model.ChartDateTimeRule.t`, *default:* `nil`) - A ChartDateTimeRule.\n*   `histogramRule` (*type:* `GoogleApi.Sheets.V4.Model.ChartHistogramRule.t`, *default:* `nil`) - A ChartHistogramRule","ref":"GoogleApi.Sheets.V4.Model.ChartGroupRule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ChartGroupRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ChartGroupRule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ChartGroupRule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ChartGroupRule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ChartHistogramRule","doc":"Allows you to organize numeric values in a source data column into buckets of constant size.","ref":"GoogleApi.Sheets.V4.Model.ChartHistogramRule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ChartHistogramRule","doc":"*   `intervalSize` (*type:* `float()`, *default:* `nil`) - The size of the buckets that are created. Must be positive.\n*   `maxValue` (*type:* `float()`, *default:* `nil`) - The maximum value at which items are placed into buckets. Values greater than the maximum are grouped into a single bucket. If omitted, it is determined by the maximum item value.\n*   `minValue` (*type:* `float()`, *default:* `nil`) - The minimum value at which items are placed into buckets. Values that are less than the minimum are grouped into a single bucket. If omitted, it is determined by the minimum item value.","ref":"GoogleApi.Sheets.V4.Model.ChartHistogramRule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ChartHistogramRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ChartHistogramRule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ChartHistogramRule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ChartHistogramRule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ChartSourceRange","doc":"Source ranges for a chart.","ref":"GoogleApi.Sheets.V4.Model.ChartSourceRange.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ChartSourceRange","doc":"*   `sources` (*type:* `list(GoogleApi.Sheets.V4.Model.GridRange.t)`, *default:* `nil`) - The ranges of data for a series or domain. Exactly one dimension must have a length of 1, and all sources in the list must have the same dimension with length 1. The domain (if it exists) & all series must have the same number of source ranges. If using more than one source range, then the source range at a given offset must be in order and contiguous across the domain and series. For example, these are valid configurations: domain sources: A1:A5 series1 sources: B1:B5 series2 sources: D6:D10 domain sources: A1:A5, C10:C12 series1 sources: B1:B5, D10:D12 series2 sources: C1:C5, E10:E12","ref":"GoogleApi.Sheets.V4.Model.ChartSourceRange.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ChartSourceRange.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ChartSourceRange.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ChartSourceRange.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ChartSourceRange.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ChartSpec","doc":"The specifications of a chart.","ref":"GoogleApi.Sheets.V4.Model.ChartSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ChartSpec","doc":"*   `altText` (*type:* `String.t`, *default:* `nil`) - The alternative text that describes the chart. This is often used for accessibility.\n*   `backgroundColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The background color of the entire chart. Not applicable to Org charts. Deprecated: Use background_color_style.\n*   `backgroundColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The background color of the entire chart. Not applicable to Org charts. If background_color is also set, this field takes precedence.\n*   `basicChart` (*type:* `GoogleApi.Sheets.V4.Model.BasicChartSpec.t`, *default:* `nil`) - A basic chart specification, can be one of many kinds of charts. See BasicChartType for the list of all charts this supports.\n*   `bubbleChart` (*type:* `GoogleApi.Sheets.V4.Model.BubbleChartSpec.t`, *default:* `nil`) - A bubble chart specification.\n*   `candlestickChart` (*type:* `GoogleApi.Sheets.V4.Model.CandlestickChartSpec.t`, *default:* `nil`) - A candlestick chart specification.\n*   `dataSourceChartProperties` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceChartProperties.t`, *default:* `nil`) - If present, the field contains data source chart specific properties.\n*   `filterSpecs` (*type:* `list(GoogleApi.Sheets.V4.Model.FilterSpec.t)`, *default:* `nil`) - The filters applied to the source data of the chart. Only supported for data source charts.\n*   `fontName` (*type:* `String.t`, *default:* `nil`) - The name of the font to use by default for all chart text (e.g. title, axis labels, legend). If a font is specified for a specific part of the chart it will override this font name.\n*   `hiddenDimensionStrategy` (*type:* `String.t`, *default:* `nil`) - Determines how the charts will use hidden rows or columns.\n*   `histogramChart` (*type:* `GoogleApi.Sheets.V4.Model.HistogramChartSpec.t`, *default:* `nil`) - A histogram chart specification.\n*   `maximized` (*type:* `boolean()`, *default:* `nil`) - True to make a chart fill the entire space in which it's rendered with minimum padding. False to use the default padding. (Not applicable to Geo and Org charts.)\n*   `orgChart` (*type:* `GoogleApi.Sheets.V4.Model.OrgChartSpec.t`, *default:* `nil`) - An org chart specification.\n*   `pieChart` (*type:* `GoogleApi.Sheets.V4.Model.PieChartSpec.t`, *default:* `nil`) - A pie chart specification.\n*   `scorecardChart` (*type:* `GoogleApi.Sheets.V4.Model.ScorecardChartSpec.t`, *default:* `nil`) - A scorecard chart specification.\n*   `sortSpecs` (*type:* `list(GoogleApi.Sheets.V4.Model.SortSpec.t)`, *default:* `nil`) - The order to sort the chart data by. Only a single sort spec is supported. Only supported for data source charts.\n*   `subtitle` (*type:* `String.t`, *default:* `nil`) - The subtitle of the chart.\n*   `subtitleTextFormat` (*type:* `GoogleApi.Sheets.V4.Model.TextFormat.t`, *default:* `nil`) - The subtitle text format. Strikethrough, underline, and link are not supported.\n*   `subtitleTextPosition` (*type:* `GoogleApi.Sheets.V4.Model.TextPosition.t`, *default:* `nil`) - The subtitle text position. This field is optional.\n*   `title` (*type:* `String.t`, *default:* `nil`) - The title of the chart.\n*   `titleTextFormat` (*type:* `GoogleApi.Sheets.V4.Model.TextFormat.t`, *default:* `nil`) - The title text format. Strikethrough, underline, and link are not supported.\n*   `titleTextPosition` (*type:* `GoogleApi.Sheets.V4.Model.TextPosition.t`, *default:* `nil`) - The title text position. This field is optional.\n*   `treemapChart` (*type:* `GoogleApi.Sheets.V4.Model.TreemapChartSpec.t`, *default:* `nil`) - A treemap chart specification.\n*   `waterfallChart` (*type:* `GoogleApi.Sheets.V4.Model.WaterfallChartSpec.t`, *default:* `nil`) - A waterfall chart specification.","ref":"GoogleApi.Sheets.V4.Model.ChartSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ChartSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ChartSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ChartSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ChartSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ClearBasicFilterRequest","doc":"Clears the basic filter, if any exists on the sheet.","ref":"GoogleApi.Sheets.V4.Model.ClearBasicFilterRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ClearBasicFilterRequest","doc":"*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The sheet ID on which the basic filter should be cleared.","ref":"GoogleApi.Sheets.V4.Model.ClearBasicFilterRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ClearBasicFilterRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ClearBasicFilterRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ClearBasicFilterRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ClearBasicFilterRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ClearValuesRequest","doc":"The request for clearing a range of values in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.ClearValuesRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ClearValuesRequest","doc":"","ref":"GoogleApi.Sheets.V4.Model.ClearValuesRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ClearValuesRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ClearValuesRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ClearValuesRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ClearValuesRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ClearValuesResponse","doc":"The response when clearing a range of values in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.ClearValuesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ClearValuesResponse","doc":"*   `clearedRange` (*type:* `String.t`, *default:* `nil`) - The range (in A1 notation) that was cleared. (If the request was for an unbounded range or a ranger larger than the bounds of the sheet, this will be the actual range that was cleared, bounded to the sheet's limits.)\n*   `spreadsheetId` (*type:* `String.t`, *default:* `nil`) - The spreadsheet the updates were applied to.","ref":"GoogleApi.Sheets.V4.Model.ClearValuesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ClearValuesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ClearValuesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ClearValuesResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ClearValuesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.Color","doc":"Represents a color in the RGBA color space. This representation is designed for simplicity of conversion to and from color representations in various languages over compactness. For example, the fields of this representation can be trivially provided to the constructor of `java.awt.Color` in Java; it can also be trivially provided to UIColor's `+colorWithRed:green:blue:alpha` method in iOS; and, with just a little work, it can be easily formatted into a CSS `rgba()` string in JavaScript. This reference page doesn't have information about the absolute color space that should be used to interpret the RGB value—for example, sRGB, Adobe RGB, DCI-P3, and BT.2020. By default, applications should assume the sRGB color space. When color equality needs to be decided, implementations, unless documented otherwise, treat two colors as equal if all their red, green, blue, and alpha values each differ by at most `1e-5`. Example (Java): import com.google.type.Color; // ... public static java.awt.Color fromProto(Color protocolor) { float alpha = protocolor.hasAlpha() ? protocolor.getAlpha().getValue() : 1.0; return new java.awt.Color( protocolor.getRed(), protocolor.getGreen(), protocolor.getBlue(), alpha); } public static Color toProto(java.awt.Color color) { float red = (float) color.getRed(); float green = (float) color.getGreen(); float blue = (float) color.getBlue(); float denominator = 255.0; Color.Builder resultBuilder = Color .newBuilder() .setRed(red / denominator) .setGreen(green / denominator) .setBlue(blue / denominator); int alpha = color.getAlpha(); if (alpha != 255) { result.setAlpha( FloatValue .newBuilder() .setValue(((float) alpha) / denominator) .build()); } return resultBuilder.build(); } // ... Example (iOS / Obj-C): // ... static UIColor* fromProto(Color* protocolor) { float red = [protocolor red]; float green = [protocolor green]; float blue = [protocolor blue]; FloatValue* alpha_wrapper = [protocolor alpha]; float alpha = 1.0; if (alpha_wrapper != nil) { alpha = [alpha_wrapper value]; } return [UIColor colorWithRed:red green:green blue:blue alpha:alpha]; } static Color* toProto(UIColor* color) { CGFloat red, green, blue, alpha; if (![color getRed:&red green:&green blue:&blue alpha:&alpha]) { return nil; } Color* result = [[Color alloc] init]; [result setRed:red]; [result setGreen:green]; [result setBlue:blue]; if (alpha <= 0.9999) { [result setAlpha:floatWrapperWithValue(alpha)]; } [result autorelease]; return result; } // ... Example (JavaScript): // ... var protoToCssColor = function(rgb_color) { var redFrac = rgb_color.red || 0.0; var greenFrac = rgb_color.green || 0.0; var blueFrac = rgb_color.blue || 0.0; var red = Math.floor(redFrac * 255); var green = Math.floor(greenFrac * 255); var blue = Math.floor(blueFrac * 255); if (!('alpha' in rgb_color)) { return rgbToCssColor(red, green, blue); } var alphaFrac = rgb_color.alpha.value || 0.0; var rgbParams = [red, green, blue].join(','); return ['rgba(', rgbParams, ',', alphaFrac, ')'].join(''); }; var rgbToCssColor = function(red, green, blue) { var rgbNumber = new Number((red << 16) | (green << 8) | blue); var hexString = rgbNumber.toString(16); var missingZeros = 6 - hexString.length; var resultBuilder = ['#']; for (var i = 0; i < missingZeros; i++) { resultBuilder.push('0'); } resultBuilder.push(hexString); return resultBuilder.join(''); }; // ...","ref":"GoogleApi.Sheets.V4.Model.Color.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.Color","doc":"*   `alpha` (*type:* `number()`, *default:* `nil`) - The fraction of this color that should be applied to the pixel. That is, the final pixel color is defined by the equation: `pixel color = alpha * (this color) + (1.0 - alpha) * (background color)` This means that a value of 1.0 corresponds to a solid color, whereas a value of 0.0 corresponds to a completely transparent color. This uses a wrapper message rather than a simple float scalar so that it is possible to distinguish between a default value and the value being unset. If omitted, this color object is rendered as a solid color (as if the alpha value had been explicitly given a value of 1.0).\n*   `blue` (*type:* `number()`, *default:* `nil`) - The amount of blue in the color as a value in the interval [0, 1].\n*   `green` (*type:* `number()`, *default:* `nil`) - The amount of green in the color as a value in the interval [0, 1].\n*   `red` (*type:* `number()`, *default:* `nil`) - The amount of red in the color as a value in the interval [0, 1].","ref":"GoogleApi.Sheets.V4.Model.Color.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.Color.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.Color.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.Color.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.Color.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ColorStyle","doc":"A color value.","ref":"GoogleApi.Sheets.V4.Model.ColorStyle.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ColorStyle","doc":"*   `rgbColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - RGB color. The [`alpha`](/sheets/api/reference/rest/v4/spreadsheets/other#Color.FIELDS.alpha) value in the [`Color`](/sheets/api/reference/rest/v4/spreadsheets/other#color) object isn't generally supported.\n*   `themeColor` (*type:* `String.t`, *default:* `nil`) - Theme color.","ref":"GoogleApi.Sheets.V4.Model.ColorStyle.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ColorStyle.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ColorStyle.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ColorStyle.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ColorStyle.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ConditionValue","doc":"The value of the condition.","ref":"GoogleApi.Sheets.V4.Model.ConditionValue.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ConditionValue","doc":"*   `relativeDate` (*type:* `String.t`, *default:* `nil`) - A relative date (based on the current date). Valid only if the type is DATE_BEFORE, DATE_AFTER, DATE_ON_OR_BEFORE or DATE_ON_OR_AFTER. Relative dates are not supported in data validation. They are supported only in conditional formatting and conditional filters.\n*   `userEnteredValue` (*type:* `String.t`, *default:* `nil`) - A value the condition is based on. The value is parsed as if the user typed into a cell. Formulas are supported (and must begin with an `=` or a '+').","ref":"GoogleApi.Sheets.V4.Model.ConditionValue.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ConditionValue.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ConditionValue.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ConditionValue.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ConditionValue.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ConditionalFormatRule","doc":"A rule describing a conditional format.","ref":"GoogleApi.Sheets.V4.Model.ConditionalFormatRule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ConditionalFormatRule","doc":"*   `booleanRule` (*type:* `GoogleApi.Sheets.V4.Model.BooleanRule.t`, *default:* `nil`) - The formatting is either \"on\" or \"off\" according to the rule.\n*   `gradientRule` (*type:* `GoogleApi.Sheets.V4.Model.GradientRule.t`, *default:* `nil`) - The formatting will vary based on the gradients in the rule.\n*   `ranges` (*type:* `list(GoogleApi.Sheets.V4.Model.GridRange.t)`, *default:* `nil`) - The ranges that are formatted if the condition is true. All the ranges must be on the same grid.","ref":"GoogleApi.Sheets.V4.Model.ConditionalFormatRule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ConditionalFormatRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ConditionalFormatRule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ConditionalFormatRule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ConditionalFormatRule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.CopyPasteRequest","doc":"Copies data from the source to the destination.","ref":"GoogleApi.Sheets.V4.Model.CopyPasteRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.CopyPasteRequest","doc":"*   `destination` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The location to paste to. If the range covers a span that's a multiple of the source's height or width, then the data will be repeated to fill in the destination range. If the range is smaller than the source range, the entire source data will still be copied (beyond the end of the destination range).\n*   `pasteOrientation` (*type:* `String.t`, *default:* `nil`) - How that data should be oriented when pasting.\n*   `pasteType` (*type:* `String.t`, *default:* `nil`) - What kind of data to paste.\n*   `source` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The source range to copy.","ref":"GoogleApi.Sheets.V4.Model.CopyPasteRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.CopyPasteRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.CopyPasteRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.CopyPasteRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.CopyPasteRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.CopySheetToAnotherSpreadsheetRequest","doc":"The request to copy a sheet across spreadsheets.","ref":"GoogleApi.Sheets.V4.Model.CopySheetToAnotherSpreadsheetRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.CopySheetToAnotherSpreadsheetRequest","doc":"*   `destinationSpreadsheetId` (*type:* `String.t`, *default:* `nil`) - The ID of the spreadsheet to copy the sheet to.","ref":"GoogleApi.Sheets.V4.Model.CopySheetToAnotherSpreadsheetRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.CopySheetToAnotherSpreadsheetRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.CopySheetToAnotherSpreadsheetRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.CopySheetToAnotherSpreadsheetRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.CopySheetToAnotherSpreadsheetRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataRequest","doc":"A request to create developer metadata.","ref":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataRequest","doc":"*   `developerMetadata` (*type:* `GoogleApi.Sheets.V4.Model.DeveloperMetadata.t`, *default:* `nil`) - The developer metadata to create.","ref":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataResponse","doc":"The response from creating developer metadata.","ref":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataResponse","doc":"*   `developerMetadata` (*type:* `GoogleApi.Sheets.V4.Model.DeveloperMetadata.t`, *default:* `nil`) - The developer metadata that was created.","ref":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.CutPasteRequest","doc":"Moves data from the source to the destination.","ref":"GoogleApi.Sheets.V4.Model.CutPasteRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.CutPasteRequest","doc":"*   `destination` (*type:* `GoogleApi.Sheets.V4.Model.GridCoordinate.t`, *default:* `nil`) - The top-left coordinate where the data should be pasted.\n*   `pasteType` (*type:* `String.t`, *default:* `nil`) - What kind of data to paste. All the source data will be cut, regardless of what is pasted.\n*   `source` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The source data to cut.","ref":"GoogleApi.Sheets.V4.Model.CutPasteRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.CutPasteRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.CutPasteRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.CutPasteRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.CutPasteRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataExecutionStatus","doc":"The data execution status. A data execution is created to sync a data source object with the latest data from a DataSource. It is usually scheduled to run at background, you can check its state to tell if an execution completes There are several scenarios where a data execution is triggered to run: * Adding a data source creates an associated data source sheet as well as a data execution to sync the data from the data source to the sheet. * Updating a data source creates a data execution to refresh the associated data source sheet similarly. * You can send refresh request to explicitly refresh one or multiple data source objects.","ref":"GoogleApi.Sheets.V4.Model.DataExecutionStatus.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataExecutionStatus","doc":"*   `errorCode` (*type:* `String.t`, *default:* `nil`) - The error code.\n*   `errorMessage` (*type:* `String.t`, *default:* `nil`) - The error message, which may be empty.\n*   `lastRefreshTime` (*type:* `DateTime.t`, *default:* `nil`) - Gets the time the data last successfully refreshed.\n*   `state` (*type:* `String.t`, *default:* `nil`) - The state of the data execution.","ref":"GoogleApi.Sheets.V4.Model.DataExecutionStatus.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataExecutionStatus.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataExecutionStatus.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataExecutionStatus.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataExecutionStatus.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataFilter","doc":"Filter that describes what data should be selected or returned from a request.","ref":"GoogleApi.Sheets.V4.Model.DataFilter.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataFilter","doc":"*   `a1Range` (*type:* `String.t`, *default:* `nil`) - Selects data that matches the specified A1 range.\n*   `developerMetadataLookup` (*type:* `GoogleApi.Sheets.V4.Model.DeveloperMetadataLookup.t`, *default:* `nil`) - Selects data associated with the developer metadata matching the criteria described by this DeveloperMetadataLookup.\n*   `gridRange` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - Selects data that matches the range described by the GridRange.","ref":"GoogleApi.Sheets.V4.Model.DataFilter.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataFilter.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataFilter.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataFilter.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataFilter.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataFilterValueRange","doc":"A range of values whose location is specified by a DataFilter.","ref":"GoogleApi.Sheets.V4.Model.DataFilterValueRange.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataFilterValueRange","doc":"*   `dataFilter` (*type:* `GoogleApi.Sheets.V4.Model.DataFilter.t`, *default:* `nil`) - The data filter describing the location of the values in the spreadsheet.\n*   `majorDimension` (*type:* `String.t`, *default:* `nil`) - The major dimension of the values.\n*   `values` (*type:* `list(list(any()))`, *default:* `nil`) - The data to be written. If the provided values exceed any of the ranges matched by the data filter then the request fails. If the provided values are less than the matched ranges only the specified values are written, existing values in the matched ranges remain unaffected.","ref":"GoogleApi.Sheets.V4.Model.DataFilterValueRange.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataFilterValueRange.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataFilterValueRange.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataFilterValueRange.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataFilterValueRange.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataLabel","doc":"Settings for one set of data labels. Data labels are annotations that appear next to a set of data, such as the points on a line chart, and provide additional information about what the data represents, such as a text representation of the value behind that point on the graph.","ref":"GoogleApi.Sheets.V4.Model.DataLabel.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataLabel","doc":"*   `customLabelData` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - Data to use for custom labels. Only used if type is set to CUSTOM. This data must be the same length as the series or other element this data label is applied to. In addition, if the series is split into multiple source ranges, this source data must come from the next column in the source data. For example, if the series is B2:B4,E6:E8 then this data must come from C2:C4,F6:F8.\n*   `placement` (*type:* `String.t`, *default:* `nil`) - The placement of the data label relative to the labeled data.\n*   `textFormat` (*type:* `GoogleApi.Sheets.V4.Model.TextFormat.t`, *default:* `nil`) - The text format used for the data label. The link field is not supported.\n*   `type` (*type:* `String.t`, *default:* `nil`) - The type of the data label.","ref":"GoogleApi.Sheets.V4.Model.DataLabel.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataLabel.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataLabel.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataLabel.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataLabel.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSource","doc":"Information about an external data source in the spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.DataSource.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSource","doc":"*   `calculatedColumns` (*type:* `list(GoogleApi.Sheets.V4.Model.DataSourceColumn.t)`, *default:* `nil`) - All calculated columns in the data source.\n*   `dataSourceId` (*type:* `String.t`, *default:* `nil`) - The spreadsheet-scoped unique ID that identifies the data source. Example: 1080547365.\n*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The ID of the Sheet connected with the data source. The field cannot be changed once set. When creating a data source, an associated DATA_SOURCE sheet is also created, if the field is not specified, the ID of the created sheet will be randomly generated.\n*   `spec` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceSpec.t`, *default:* `nil`) - The DataSourceSpec for the data source connected with this spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.DataSource.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSource.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSource.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSource.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSource.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceChartProperties","doc":"Properties of a data source chart.","ref":"GoogleApi.Sheets.V4.Model.DataSourceChartProperties.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceChartProperties","doc":"*   `dataExecutionStatus` (*type:* `GoogleApi.Sheets.V4.Model.DataExecutionStatus.t`, *default:* `nil`) - Output only. The data execution status.\n*   `dataSourceId` (*type:* `String.t`, *default:* `nil`) - ID of the data source that the chart is associated with.","ref":"GoogleApi.Sheets.V4.Model.DataSourceChartProperties.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceChartProperties.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceChartProperties.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceChartProperties.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceChartProperties.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceColumn","doc":"A column in a data source.","ref":"GoogleApi.Sheets.V4.Model.DataSourceColumn.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceColumn","doc":"*   `formula` (*type:* `String.t`, *default:* `nil`) - The formula of the calculated column.\n*   `reference` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceColumnReference.t`, *default:* `nil`) - The column reference.","ref":"GoogleApi.Sheets.V4.Model.DataSourceColumn.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceColumn.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceColumn.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceColumn.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceColumn.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceColumnReference","doc":"An unique identifier that references a data source column.","ref":"GoogleApi.Sheets.V4.Model.DataSourceColumnReference.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceColumnReference","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - The display name of the column. It should be unique within a data source.","ref":"GoogleApi.Sheets.V4.Model.DataSourceColumnReference.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceColumnReference.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceColumnReference.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceColumnReference.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceColumnReference.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceFormula","doc":"A data source formula.","ref":"GoogleApi.Sheets.V4.Model.DataSourceFormula.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceFormula","doc":"*   `dataExecutionStatus` (*type:* `GoogleApi.Sheets.V4.Model.DataExecutionStatus.t`, *default:* `nil`) - Output only. The data execution status.\n*   `dataSourceId` (*type:* `String.t`, *default:* `nil`) - The ID of the data source the formula is associated with.","ref":"GoogleApi.Sheets.V4.Model.DataSourceFormula.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceFormula.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceFormula.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceFormula.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceFormula.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceObjectReference","doc":"Reference to a data source object.","ref":"GoogleApi.Sheets.V4.Model.DataSourceObjectReference.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceObjectReference","doc":"*   `chartId` (*type:* `integer()`, *default:* `nil`) - References to a data source chart.\n*   `dataSourceFormulaCell` (*type:* `GoogleApi.Sheets.V4.Model.GridCoordinate.t`, *default:* `nil`) - References to a cell containing DataSourceFormula.\n*   `dataSourcePivotTableAnchorCell` (*type:* `GoogleApi.Sheets.V4.Model.GridCoordinate.t`, *default:* `nil`) - References to a data source PivotTable anchored at the cell.\n*   `dataSourceTableAnchorCell` (*type:* `GoogleApi.Sheets.V4.Model.GridCoordinate.t`, *default:* `nil`) - References to a DataSourceTable anchored at the cell.\n*   `sheetId` (*type:* `String.t`, *default:* `nil`) - References to a DATA_SOURCE sheet.","ref":"GoogleApi.Sheets.V4.Model.DataSourceObjectReference.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceObjectReference.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceObjectReference.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceObjectReference.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceObjectReference.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceObjectReferences","doc":"A list of references to data source objects.","ref":"GoogleApi.Sheets.V4.Model.DataSourceObjectReferences.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceObjectReferences","doc":"*   `references` (*type:* `list(GoogleApi.Sheets.V4.Model.DataSourceObjectReference.t)`, *default:* `nil`) - The references.","ref":"GoogleApi.Sheets.V4.Model.DataSourceObjectReferences.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceObjectReferences.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceObjectReferences.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceObjectReferences.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceObjectReferences.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceParameter","doc":"A parameter in a data source's query. The parameter allows the user to pass in values from the spreadsheet into a query.","ref":"GoogleApi.Sheets.V4.Model.DataSourceParameter.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceParameter","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - Named parameter. Must be a legitimate identifier for the DataSource that supports it. For example, [BigQuery identifier](https://cloud.google.com/bigquery/docs/reference/standard-sql/lexical#identifiers).\n*   `namedRangeId` (*type:* `String.t`, *default:* `nil`) - ID of a NamedRange. Its size must be 1x1.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - A range that contains the value of the parameter. Its size must be 1x1.","ref":"GoogleApi.Sheets.V4.Model.DataSourceParameter.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceParameter.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceParameter.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceParameter.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceParameter.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceRefreshDailySchedule","doc":"A schedule for data to refresh every day in a given time interval.","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshDailySchedule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceRefreshDailySchedule","doc":"*   `startTime` (*type:* `GoogleApi.Sheets.V4.Model.TimeOfDay.t`, *default:* `nil`) - The start time of a time interval in which a data source refresh is scheduled. Only `hours` part is used. The time interval size defaults to that in the Sheets editor.","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshDailySchedule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceRefreshDailySchedule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshDailySchedule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceRefreshDailySchedule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshDailySchedule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceRefreshMonthlySchedule","doc":"A monthly schedule for data to refresh on specific days in the month in a given time interval.","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshMonthlySchedule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceRefreshMonthlySchedule","doc":"*   `daysOfMonth` (*type:* `list(integer())`, *default:* `nil`) - Days of the month to refresh. Only 1-28 are supported, mapping to the 1st to the 28th day. At least one day must be specified.\n*   `startTime` (*type:* `GoogleApi.Sheets.V4.Model.TimeOfDay.t`, *default:* `nil`) - The start time of a time interval in which a data source refresh is scheduled. Only `hours` part is used. The time interval size defaults to that in the Sheets editor.","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshMonthlySchedule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceRefreshMonthlySchedule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshMonthlySchedule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceRefreshMonthlySchedule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshMonthlySchedule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceRefreshSchedule","doc":"Schedule for refreshing the data source. Data sources in the spreadsheet are refreshed within a time interval. You can specify the start time by clicking the Scheduled Refresh button in the Sheets editor, but the interval is fixed at 4 hours. For example, if you specify a start time of 8 AM , the refresh will take place between 8 AM and 12 PM every day.","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshSchedule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceRefreshSchedule","doc":"*   `dailySchedule` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceRefreshDailySchedule.t`, *default:* `nil`) - Daily refresh schedule.\n*   `enabled` (*type:* `boolean()`, *default:* `nil`) - True if the refresh schedule is enabled, or false otherwise.\n*   `monthlySchedule` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceRefreshMonthlySchedule.t`, *default:* `nil`) - Monthly refresh schedule.\n*   `nextRun` (*type:* `GoogleApi.Sheets.V4.Model.Interval.t`, *default:* `nil`) - Output only. The time interval of the next run.\n*   `refreshScope` (*type:* `String.t`, *default:* `nil`) - The scope of the refresh. Must be ALL_DATA_SOURCES.\n*   `weeklySchedule` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceRefreshWeeklySchedule.t`, *default:* `nil`) - Weekly refresh schedule.","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshSchedule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceRefreshSchedule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshSchedule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceRefreshSchedule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshSchedule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceRefreshWeeklySchedule","doc":"A weekly schedule for data to refresh on specific days in a given time interval.","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshWeeklySchedule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceRefreshWeeklySchedule","doc":"*   `daysOfWeek` (*type:* `list(String.t)`, *default:* `nil`) - Days of the week to refresh. At least one day must be specified.\n*   `startTime` (*type:* `GoogleApi.Sheets.V4.Model.TimeOfDay.t`, *default:* `nil`) - The start time of a time interval in which a data source refresh is scheduled. Only `hours` part is used. The time interval size defaults to that in the Sheets editor.","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshWeeklySchedule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceRefreshWeeklySchedule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshWeeklySchedule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceRefreshWeeklySchedule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceRefreshWeeklySchedule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceSheetDimensionRange","doc":"A range along a single dimension on a DATA_SOURCE sheet.","ref":"GoogleApi.Sheets.V4.Model.DataSourceSheetDimensionRange.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceSheetDimensionRange","doc":"*   `columnReferences` (*type:* `list(GoogleApi.Sheets.V4.Model.DataSourceColumnReference.t)`, *default:* `nil`) - The columns on the data source sheet.\n*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The ID of the data source sheet the range is on.","ref":"GoogleApi.Sheets.V4.Model.DataSourceSheetDimensionRange.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceSheetDimensionRange.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceSheetDimensionRange.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceSheetDimensionRange.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceSheetDimensionRange.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceSheetProperties","doc":"Additional properties of a DATA_SOURCE sheet.","ref":"GoogleApi.Sheets.V4.Model.DataSourceSheetProperties.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceSheetProperties","doc":"*   `columns` (*type:* `list(GoogleApi.Sheets.V4.Model.DataSourceColumn.t)`, *default:* `nil`) - The columns displayed on the sheet, corresponding to the values in RowData.\n*   `dataExecutionStatus` (*type:* `GoogleApi.Sheets.V4.Model.DataExecutionStatus.t`, *default:* `nil`) - The data execution status.\n*   `dataSourceId` (*type:* `String.t`, *default:* `nil`) - ID of the DataSource the sheet is connected to.","ref":"GoogleApi.Sheets.V4.Model.DataSourceSheetProperties.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceSheetProperties.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceSheetProperties.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceSheetProperties.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceSheetProperties.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceSpec","doc":"This specifies the details of the data source. For example, for BigQuery, this specifies information about the BigQuery source.","ref":"GoogleApi.Sheets.V4.Model.DataSourceSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceSpec","doc":"*   `bigQuery` (*type:* `GoogleApi.Sheets.V4.Model.BigQueryDataSourceSpec.t`, *default:* `nil`) - A BigQueryDataSourceSpec.\n*   `parameters` (*type:* `list(GoogleApi.Sheets.V4.Model.DataSourceParameter.t)`, *default:* `nil`) - The parameters of the data source, used when querying the data source.","ref":"GoogleApi.Sheets.V4.Model.DataSourceSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataSourceTable","doc":"A data source table, which allows the user to import a static table of data from the DataSource into Sheets. This is also known as \"Extract\" in the Sheets editor.","ref":"GoogleApi.Sheets.V4.Model.DataSourceTable.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataSourceTable","doc":"*   `columnSelectionType` (*type:* `String.t`, *default:* `nil`) - The type to select columns for the data source table. Defaults to SELECTED.\n*   `columns` (*type:* `list(GoogleApi.Sheets.V4.Model.DataSourceColumnReference.t)`, *default:* `nil`) - Columns selected for the data source table. The column_selection_type must be SELECTED.\n*   `dataExecutionStatus` (*type:* `GoogleApi.Sheets.V4.Model.DataExecutionStatus.t`, *default:* `nil`) - Output only. The data execution status.\n*   `dataSourceId` (*type:* `String.t`, *default:* `nil`) - The ID of the data source the data source table is associated with.\n*   `filterSpecs` (*type:* `list(GoogleApi.Sheets.V4.Model.FilterSpec.t)`, *default:* `nil`) - Filter specifications in the data source table.\n*   `rowLimit` (*type:* `integer()`, *default:* `nil`) - The limit of rows to return. If not set, a default limit is applied. Please refer to the Sheets editor for the default and max limit.\n*   `sortSpecs` (*type:* `list(GoogleApi.Sheets.V4.Model.SortSpec.t)`, *default:* `nil`) - Sort specifications in the data source table. The result of the data source table is sorted based on the sort specifications in order.","ref":"GoogleApi.Sheets.V4.Model.DataSourceTable.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataSourceTable.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataSourceTable.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataSourceTable.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataSourceTable.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DataValidationRule","doc":"A data validation rule.","ref":"GoogleApi.Sheets.V4.Model.DataValidationRule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DataValidationRule","doc":"*   `condition` (*type:* `GoogleApi.Sheets.V4.Model.BooleanCondition.t`, *default:* `nil`) - The condition that data in the cell must match.\n*   `inputMessage` (*type:* `String.t`, *default:* `nil`) - A message to show the user when adding data to the cell.\n*   `showCustomUi` (*type:* `boolean()`, *default:* `nil`) - True if the UI should be customized based on the kind of condition. If true, \"List\" conditions will show a dropdown.\n*   `strict` (*type:* `boolean()`, *default:* `nil`) - True if invalid data should be rejected.","ref":"GoogleApi.Sheets.V4.Model.DataValidationRule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DataValidationRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DataValidationRule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DataValidationRule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DataValidationRule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DateTimeRule","doc":"Allows you to organize the date-time values in a source data column into buckets based on selected parts of their date or time values. For example, consider a pivot table showing sales transactions by date: +----------+--------------+ | Date | SUM of Sales | +----------+--------------+ | 1/1/2017 | $621.14 | | 2/3/2017 | $708.84 | | 5/8/2017 | $326.84 | ... +----------+--------------+ Applying a date-time group rule with a DateTimeRuleType of YEAR_MONTH results in the following pivot table. +--------------+--------------+ | Grouped Date | SUM of Sales | +--------------+--------------+ | 2017-Jan | $53,731.78 | | 2017-Feb | $83,475.32 | | 2017-Mar | $94,385.05 | ... +--------------+--------------+","ref":"GoogleApi.Sheets.V4.Model.DateTimeRule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DateTimeRule","doc":"*   `type` (*type:* `String.t`, *default:* `nil`) - The type of date-time grouping to apply.","ref":"GoogleApi.Sheets.V4.Model.DateTimeRule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DateTimeRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DateTimeRule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DateTimeRule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DateTimeRule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteBandingRequest","doc":"Removes the banded range with the given ID from the spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.DeleteBandingRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteBandingRequest","doc":"*   `bandedRangeId` (*type:* `integer()`, *default:* `nil`) - The ID of the banded range to delete.","ref":"GoogleApi.Sheets.V4.Model.DeleteBandingRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteBandingRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteBandingRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteBandingRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteBandingRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleRequest","doc":"Deletes a conditional format rule at the given index. All subsequent rules' indexes are decremented.","ref":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleRequest","doc":"*   `index` (*type:* `integer()`, *default:* `nil`) - The zero-based index of the rule to be deleted.\n*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The sheet the rule is being deleted from.","ref":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleResponse","doc":"The result of deleting a conditional format rule.","ref":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleResponse","doc":"*   `rule` (*type:* `GoogleApi.Sheets.V4.Model.ConditionalFormatRule.t`, *default:* `nil`) - The rule that was deleted.","ref":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteDataSourceRequest","doc":"Deletes a data source. The request also deletes the associated data source sheet, and unlinks all associated data source objects.","ref":"GoogleApi.Sheets.V4.Model.DeleteDataSourceRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteDataSourceRequest","doc":"*   `dataSourceId` (*type:* `String.t`, *default:* `nil`) - The ID of the data source to delete.","ref":"GoogleApi.Sheets.V4.Model.DeleteDataSourceRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteDataSourceRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteDataSourceRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteDataSourceRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteDataSourceRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataRequest","doc":"A request to delete developer metadata.","ref":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataRequest","doc":"*   `dataFilter` (*type:* `GoogleApi.Sheets.V4.Model.DataFilter.t`, *default:* `nil`) - The data filter describing the criteria used to select which developer metadata entry to delete.","ref":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataResponse","doc":"The response from deleting developer metadata.","ref":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataResponse","doc":"*   `deletedDeveloperMetadata` (*type:* `list(GoogleApi.Sheets.V4.Model.DeveloperMetadata.t)`, *default:* `nil`) - The metadata that was deleted.","ref":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupRequest","doc":"Deletes a group over the specified range by decrementing the depth of the dimensions in the range. For example, assume the sheet has a depth-1 group over B:E and a depth-2 group over C:D. Deleting a group over D:E leaves the sheet with a depth-1 group over B:D and a depth-2 group over C:C.","ref":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteDimensionGroupRequest","doc":"*   `range` (*type:* `GoogleApi.Sheets.V4.Model.DimensionRange.t`, *default:* `nil`) - The range of the group to be deleted.","ref":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupResponse","doc":"The result of deleting a group.","ref":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteDimensionGroupResponse","doc":"*   `dimensionGroups` (*type:* `list(GoogleApi.Sheets.V4.Model.DimensionGroup.t)`, *default:* `nil`) - All groups of a dimension after deleting a group from that dimension.","ref":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteDimensionGroupResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteDimensionRequest","doc":"Deletes the dimensions from the sheet.","ref":"GoogleApi.Sheets.V4.Model.DeleteDimensionRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteDimensionRequest","doc":"*   `range` (*type:* `GoogleApi.Sheets.V4.Model.DimensionRange.t`, *default:* `nil`) - The dimensions to delete from the sheet.","ref":"GoogleApi.Sheets.V4.Model.DeleteDimensionRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteDimensionRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteDimensionRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteDimensionRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteDimensionRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesRequest","doc":"Removes rows within this range that contain values in the specified columns that are duplicates of values in any previous row. Rows with identical values but different letter cases, formatting, or formulas are considered to be duplicates. This request also removes duplicate rows hidden from view (for example, due to a filter). When removing duplicates, the first instance of each duplicate row scanning from the top downwards is kept in the resulting range. Content outside of the specified range isn't removed, and rows considered duplicates do not have to be adjacent to each other in the range.","ref":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteDuplicatesRequest","doc":"*   `comparisonColumns` (*type:* `list(GoogleApi.Sheets.V4.Model.DimensionRange.t)`, *default:* `nil`) - The columns in the range to analyze for duplicate values. If no columns are selected then all columns are analyzed for duplicates.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range to remove duplicates rows from.","ref":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesResponse","doc":"The result of removing duplicates in a range.","ref":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteDuplicatesResponse","doc":"*   `duplicatesRemovedCount` (*type:* `integer()`, *default:* `nil`) - The number of duplicate rows removed.","ref":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteDuplicatesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteEmbeddedObjectRequest","doc":"Deletes the embedded object with the given ID.","ref":"GoogleApi.Sheets.V4.Model.DeleteEmbeddedObjectRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteEmbeddedObjectRequest","doc":"*   `objectId` (*type:* `integer()`, *default:* `nil`) - The ID of the embedded object to delete.","ref":"GoogleApi.Sheets.V4.Model.DeleteEmbeddedObjectRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteEmbeddedObjectRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteEmbeddedObjectRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteEmbeddedObjectRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteEmbeddedObjectRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteFilterViewRequest","doc":"Deletes a particular filter view.","ref":"GoogleApi.Sheets.V4.Model.DeleteFilterViewRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteFilterViewRequest","doc":"*   `filterId` (*type:* `integer()`, *default:* `nil`) - The ID of the filter to delete.","ref":"GoogleApi.Sheets.V4.Model.DeleteFilterViewRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteFilterViewRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteFilterViewRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteFilterViewRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteFilterViewRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteNamedRangeRequest","doc":"Removes the named range with the given ID from the spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.DeleteNamedRangeRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteNamedRangeRequest","doc":"*   `namedRangeId` (*type:* `String.t`, *default:* `nil`) - The ID of the named range to delete.","ref":"GoogleApi.Sheets.V4.Model.DeleteNamedRangeRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteNamedRangeRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteNamedRangeRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteNamedRangeRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteNamedRangeRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteProtectedRangeRequest","doc":"Deletes the protected range with the given ID.","ref":"GoogleApi.Sheets.V4.Model.DeleteProtectedRangeRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteProtectedRangeRequest","doc":"*   `protectedRangeId` (*type:* `integer()`, *default:* `nil`) - The ID of the protected range to delete.","ref":"GoogleApi.Sheets.V4.Model.DeleteProtectedRangeRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteProtectedRangeRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteProtectedRangeRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteProtectedRangeRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteProtectedRangeRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteRangeRequest","doc":"Deletes a range of cells, shifting other cells into the deleted area.","ref":"GoogleApi.Sheets.V4.Model.DeleteRangeRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteRangeRequest","doc":"*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range of cells to delete.\n*   `shiftDimension` (*type:* `String.t`, *default:* `nil`) - The dimension from which deleted cells will be replaced with. If ROWS, existing cells will be shifted upward to replace the deleted cells. If COLUMNS, existing cells will be shifted left to replace the deleted cells.","ref":"GoogleApi.Sheets.V4.Model.DeleteRangeRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteRangeRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteRangeRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteRangeRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteRangeRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeleteSheetRequest","doc":"Deletes the requested sheet.","ref":"GoogleApi.Sheets.V4.Model.DeleteSheetRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeleteSheetRequest","doc":"*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The ID of the sheet to delete. If the sheet is of DATA_SOURCE type, the associated DataSource is also deleted.","ref":"GoogleApi.Sheets.V4.Model.DeleteSheetRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeleteSheetRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeleteSheetRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeleteSheetRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeleteSheetRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeveloperMetadata","doc":"Developer metadata associated with a location or object in a spreadsheet. Developer metadata may be used to associate arbitrary data with various parts of a spreadsheet and will remain associated at those locations as they move around and the spreadsheet is edited. For example, if developer metadata is associated with row 5 and another row is then subsequently inserted above row 5, that original metadata will still be associated with the row it was first associated with (what is now row 6). If the associated object is deleted its metadata is deleted too.","ref":"GoogleApi.Sheets.V4.Model.DeveloperMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeveloperMetadata","doc":"*   `location` (*type:* `GoogleApi.Sheets.V4.Model.DeveloperMetadataLocation.t`, *default:* `nil`) - The location where the metadata is associated.\n*   `metadataId` (*type:* `integer()`, *default:* `nil`) - The spreadsheet-scoped unique ID that identifies the metadata. IDs may be specified when metadata is created, otherwise one will be randomly generated and assigned. Must be positive.\n*   `metadataKey` (*type:* `String.t`, *default:* `nil`) - The metadata key. There may be multiple metadata in a spreadsheet with the same key. Developer metadata must always have a key specified.\n*   `metadataValue` (*type:* `String.t`, *default:* `nil`) - Data associated with the metadata's key.\n*   `visibility` (*type:* `String.t`, *default:* `nil`) - The metadata visibility. Developer metadata must always have a visibility specified.","ref":"GoogleApi.Sheets.V4.Model.DeveloperMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeveloperMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeveloperMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeveloperMetadata.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeveloperMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLocation","doc":"A location where metadata may be associated in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLocation.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeveloperMetadataLocation","doc":"*   `dimensionRange` (*type:* `GoogleApi.Sheets.V4.Model.DimensionRange.t`, *default:* `nil`) - Represents the row or column when metadata is associated with a dimension. The specified DimensionRange must represent a single row or column; it cannot be unbounded or span multiple rows or columns.\n*   `locationType` (*type:* `String.t`, *default:* `nil`) - The type of location this object represents. This field is read-only.\n*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The ID of the sheet when metadata is associated with an entire sheet.\n*   `spreadsheet` (*type:* `boolean()`, *default:* `nil`) - True when metadata is associated with an entire spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLocation.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLocation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLocation.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLocation.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLocation.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLookup","doc":"Selects DeveloperMetadata that matches all of the specified fields. For example, if only a metadata ID is specified this considers the DeveloperMetadata with that particular unique ID. If a metadata key is specified, this considers all developer metadata with that key. If a key, visibility, and location type are all specified, this considers all developer metadata with that key and visibility that are associated with a location of that type. In general, this selects all DeveloperMetadata that matches the intersection of all the specified fields; any field or combination of fields may be specified.","ref":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLookup.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DeveloperMetadataLookup","doc":"*   `locationMatchingStrategy` (*type:* `String.t`, *default:* `nil`) - Determines how this lookup matches the location. If this field is specified as EXACT, only developer metadata associated on the exact location specified is matched. If this field is specified to INTERSECTING, developer metadata associated on intersecting locations is also matched. If left unspecified, this field assumes a default value of INTERSECTING. If this field is specified, a metadataLocation must also be specified.\n*   `locationType` (*type:* `String.t`, *default:* `nil`) - Limits the selected developer metadata to those entries which are associated with locations of the specified type. For example, when this field is specified as ROW this lookup only considers developer metadata associated on rows. If the field is left unspecified, all location types are considered. This field cannot be specified as SPREADSHEET when the locationMatchingStrategy is specified as INTERSECTING or when the metadataLocation is specified as a non-spreadsheet location: spreadsheet metadata cannot intersect any other developer metadata location. This field also must be left unspecified when the locationMatchingStrategy is specified as EXACT.\n*   `metadataId` (*type:* `integer()`, *default:* `nil`) - Limits the selected developer metadata to that which has a matching DeveloperMetadata.metadata_id.\n*   `metadataKey` (*type:* `String.t`, *default:* `nil`) - Limits the selected developer metadata to that which has a matching DeveloperMetadata.metadata_key.\n*   `metadataLocation` (*type:* `GoogleApi.Sheets.V4.Model.DeveloperMetadataLocation.t`, *default:* `nil`) - Limits the selected developer metadata to those entries associated with the specified location. This field either matches exact locations or all intersecting locations according the specified locationMatchingStrategy.\n*   `metadataValue` (*type:* `String.t`, *default:* `nil`) - Limits the selected developer metadata to that which has a matching DeveloperMetadata.metadata_value.\n*   `visibility` (*type:* `String.t`, *default:* `nil`) - Limits the selected developer metadata to that which has a matching DeveloperMetadata.visibility. If left unspecified, all developer metadata visibile to the requesting project is considered.","ref":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLookup.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLookup.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLookup.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLookup.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DeveloperMetadataLookup.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DimensionGroup","doc":"A group over an interval of rows or columns on a sheet, which can contain or be contained within other groups. A group can be collapsed or expanded as a unit on the sheet.","ref":"GoogleApi.Sheets.V4.Model.DimensionGroup.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DimensionGroup","doc":"*   `collapsed` (*type:* `boolean()`, *default:* `nil`) - This field is true if this group is collapsed. A collapsed group remains collapsed if an overlapping group at a shallower depth is expanded. A true value does not imply that all dimensions within the group are hidden, since a dimension's visibility can change independently from this group property. However, when this property is updated, all dimensions within it are set to hidden if this field is true, or set to visible if this field is false.\n*   `depth` (*type:* `integer()`, *default:* `nil`) - The depth of the group, representing how many groups have a range that wholly contains the range of this group.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.DimensionRange.t`, *default:* `nil`) - The range over which this group exists.","ref":"GoogleApi.Sheets.V4.Model.DimensionGroup.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DimensionGroup.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DimensionGroup.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DimensionGroup.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DimensionGroup.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DimensionProperties","doc":"Properties about a dimension.","ref":"GoogleApi.Sheets.V4.Model.DimensionProperties.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DimensionProperties","doc":"*   `dataSourceColumnReference` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceColumnReference.t`, *default:* `nil`) - Output only. If set, this is a column in a data source sheet.\n*   `developerMetadata` (*type:* `list(GoogleApi.Sheets.V4.Model.DeveloperMetadata.t)`, *default:* `nil`) - The developer metadata associated with a single row or column.\n*   `hiddenByFilter` (*type:* `boolean()`, *default:* `nil`) - True if this dimension is being filtered. This field is read-only.\n*   `hiddenByUser` (*type:* `boolean()`, *default:* `nil`) - True if this dimension is explicitly hidden.\n*   `pixelSize` (*type:* `integer()`, *default:* `nil`) - The height (if a row) or width (if a column) of the dimension in pixels.","ref":"GoogleApi.Sheets.V4.Model.DimensionProperties.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DimensionProperties.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DimensionProperties.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DimensionProperties.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DimensionProperties.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DimensionRange","doc":"A range along a single dimension on a sheet. All indexes are zero-based. Indexes are half open: the start index is inclusive and the end index is exclusive. Missing indexes indicate the range is unbounded on that side.","ref":"GoogleApi.Sheets.V4.Model.DimensionRange.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DimensionRange","doc":"*   `dimension` (*type:* `String.t`, *default:* `nil`) - The dimension of the span.\n*   `endIndex` (*type:* `integer()`, *default:* `nil`) - The end (exclusive) of the span, or not set if unbounded.\n*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The sheet this span is on.\n*   `startIndex` (*type:* `integer()`, *default:* `nil`) - The start (inclusive) of the span, or not set if unbounded.","ref":"GoogleApi.Sheets.V4.Model.DimensionRange.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DimensionRange.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DimensionRange.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DimensionRange.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DimensionRange.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewRequest","doc":"Duplicates a particular filter view.","ref":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DuplicateFilterViewRequest","doc":"*   `filterId` (*type:* `integer()`, *default:* `nil`) - The ID of the filter being duplicated.","ref":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewResponse","doc":"The result of a filter view being duplicated.","ref":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DuplicateFilterViewResponse","doc":"*   `filter` (*type:* `GoogleApi.Sheets.V4.Model.FilterView.t`, *default:* `nil`) - The newly created filter.","ref":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DuplicateFilterViewResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DuplicateSheetRequest","doc":"Duplicates the contents of a sheet.","ref":"GoogleApi.Sheets.V4.Model.DuplicateSheetRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DuplicateSheetRequest","doc":"*   `insertSheetIndex` (*type:* `integer()`, *default:* `nil`) - The zero-based index where the new sheet should be inserted. The index of all sheets after this are incremented.\n*   `newSheetId` (*type:* `integer()`, *default:* `nil`) - If set, the ID of the new sheet. If not set, an ID is chosen. If set, the ID must not conflict with any existing sheet ID. If set, it must be non-negative.\n*   `newSheetName` (*type:* `String.t`, *default:* `nil`) - The name of the new sheet. If empty, a new name is chosen for you.\n*   `sourceSheetId` (*type:* `integer()`, *default:* `nil`) - The sheet to duplicate. If the source sheet is of DATA_SOURCE type, its backing DataSource is also duplicated and associated with the new copy of the sheet. No data execution is triggered, the grid data of this sheet is also copied over but only available after the batch request completes.","ref":"GoogleApi.Sheets.V4.Model.DuplicateSheetRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DuplicateSheetRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DuplicateSheetRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DuplicateSheetRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DuplicateSheetRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.DuplicateSheetResponse","doc":"The result of duplicating a sheet.","ref":"GoogleApi.Sheets.V4.Model.DuplicateSheetResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.DuplicateSheetResponse","doc":"*   `properties` (*type:* `GoogleApi.Sheets.V4.Model.SheetProperties.t`, *default:* `nil`) - The properties of the duplicate sheet.","ref":"GoogleApi.Sheets.V4.Model.DuplicateSheetResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.DuplicateSheetResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.DuplicateSheetResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.DuplicateSheetResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.DuplicateSheetResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.Editors","doc":"The editors of a protected range.","ref":"GoogleApi.Sheets.V4.Model.Editors.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.Editors","doc":"*   `domainUsersCanEdit` (*type:* `boolean()`, *default:* `nil`) - True if anyone in the document's domain has edit access to the protected range. Domain protection is only supported on documents within a domain.\n*   `groups` (*type:* `list(String.t)`, *default:* `nil`) - The email addresses of groups with edit access to the protected range.\n*   `users` (*type:* `list(String.t)`, *default:* `nil`) - The email addresses of users with edit access to the protected range.","ref":"GoogleApi.Sheets.V4.Model.Editors.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.Editors.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.Editors.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.Editors.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.Editors.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.EmbeddedChart","doc":"A chart embedded in a sheet.","ref":"GoogleApi.Sheets.V4.Model.EmbeddedChart.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.EmbeddedChart","doc":"*   `border` (*type:* `GoogleApi.Sheets.V4.Model.EmbeddedObjectBorder.t`, *default:* `nil`) - The border of the chart.\n*   `chartId` (*type:* `integer()`, *default:* `nil`) - The ID of the chart.\n*   `position` (*type:* `GoogleApi.Sheets.V4.Model.EmbeddedObjectPosition.t`, *default:* `nil`) - The position of the chart.\n*   `spec` (*type:* `GoogleApi.Sheets.V4.Model.ChartSpec.t`, *default:* `nil`) - The specification of the chart.","ref":"GoogleApi.Sheets.V4.Model.EmbeddedChart.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.EmbeddedChart.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.EmbeddedChart.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.EmbeddedChart.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.EmbeddedChart.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.EmbeddedObjectBorder","doc":"A border along an embedded object.","ref":"GoogleApi.Sheets.V4.Model.EmbeddedObjectBorder.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.EmbeddedObjectBorder","doc":"*   `color` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The color of the border. Deprecated: Use color_style.\n*   `colorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The color of the border. If color is also set, this field takes precedence.","ref":"GoogleApi.Sheets.V4.Model.EmbeddedObjectBorder.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.EmbeddedObjectBorder.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.EmbeddedObjectBorder.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.EmbeddedObjectBorder.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.EmbeddedObjectBorder.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.EmbeddedObjectPosition","doc":"The position of an embedded object such as a chart.","ref":"GoogleApi.Sheets.V4.Model.EmbeddedObjectPosition.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.EmbeddedObjectPosition","doc":"*   `newSheet` (*type:* `boolean()`, *default:* `nil`) - If true, the embedded object is put on a new sheet whose ID is chosen for you. Used only when writing.\n*   `overlayPosition` (*type:* `GoogleApi.Sheets.V4.Model.OverlayPosition.t`, *default:* `nil`) - The position at which the object is overlaid on top of a grid.\n*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The sheet this is on. Set only if the embedded object is on its own sheet. Must be non-negative.","ref":"GoogleApi.Sheets.V4.Model.EmbeddedObjectPosition.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.EmbeddedObjectPosition.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.EmbeddedObjectPosition.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.EmbeddedObjectPosition.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.EmbeddedObjectPosition.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ErrorValue","doc":"An error in a cell.","ref":"GoogleApi.Sheets.V4.Model.ErrorValue.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ErrorValue","doc":"*   `message` (*type:* `String.t`, *default:* `nil`) - A message with more information about the error (in the spreadsheet's locale).\n*   `type` (*type:* `String.t`, *default:* `nil`) - The type of error.","ref":"GoogleApi.Sheets.V4.Model.ErrorValue.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ErrorValue.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ErrorValue.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ErrorValue.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ErrorValue.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ExtendedValue","doc":"The kinds of value that a cell in a spreadsheet can have.","ref":"GoogleApi.Sheets.V4.Model.ExtendedValue.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ExtendedValue","doc":"*   `boolValue` (*type:* `boolean()`, *default:* `nil`) - Represents a boolean value.\n*   `errorValue` (*type:* `GoogleApi.Sheets.V4.Model.ErrorValue.t`, *default:* `nil`) - Represents an error. This field is read-only.\n*   `formulaValue` (*type:* `String.t`, *default:* `nil`) - Represents a formula.\n*   `numberValue` (*type:* `float()`, *default:* `nil`) - Represents a double value. Note: Dates, Times and DateTimes are represented as doubles in SERIAL_NUMBER format.\n*   `stringValue` (*type:* `String.t`, *default:* `nil`) - Represents a string value. Leading single quotes are not included. For example, if the user typed `'123` into the UI, this would be represented as a `stringValue` of `\"123\"`.","ref":"GoogleApi.Sheets.V4.Model.ExtendedValue.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ExtendedValue.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ExtendedValue.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ExtendedValue.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ExtendedValue.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.FilterCriteria","doc":"Criteria for showing/hiding rows in a filter or filter view.","ref":"GoogleApi.Sheets.V4.Model.FilterCriteria.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.FilterCriteria","doc":"*   `condition` (*type:* `GoogleApi.Sheets.V4.Model.BooleanCondition.t`, *default:* `nil`) - A condition that must be true for values to be shown. (This does not override hidden_values -- if a value is listed there, it will still be hidden.)\n*   `hiddenValues` (*type:* `list(String.t)`, *default:* `nil`) - Values that should be hidden.\n*   `visibleBackgroundColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The background fill color to filter by; only cells with this fill color are shown. Mutually exclusive with visible_foreground_color. Deprecated: Use visible_background_color_style.\n*   `visibleBackgroundColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The background fill color to filter by; only cells with this fill color are shown. This field is mutually exclusive with visible_foreground_color, and must be set to an RGB-type color. If visible_background_color is also set, this field takes precedence.\n*   `visibleForegroundColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The foreground color to filter by; only cells with this foreground color are shown. Mutually exclusive with visible_background_color. Deprecated: Use visible_foreground_color_style.\n*   `visibleForegroundColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The foreground color to filter by; only cells with this foreground color are shown. This field is mutually exclusive with visible_background_color, and must be set to an RGB-type color. If visible_foreground_color is also set, this field takes precedence.","ref":"GoogleApi.Sheets.V4.Model.FilterCriteria.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.FilterCriteria.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.FilterCriteria.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.FilterCriteria.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.FilterCriteria.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.FilterSpec","doc":"The filter criteria associated with a specific column.","ref":"GoogleApi.Sheets.V4.Model.FilterSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.FilterSpec","doc":"*   `columnIndex` (*type:* `integer()`, *default:* `nil`) - The zero-based column index.\n*   `dataSourceColumnReference` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceColumnReference.t`, *default:* `nil`) - Reference to a data source column.\n*   `filterCriteria` (*type:* `GoogleApi.Sheets.V4.Model.FilterCriteria.t`, *default:* `nil`) - The criteria for the column.","ref":"GoogleApi.Sheets.V4.Model.FilterSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.FilterSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.FilterSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.FilterSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.FilterSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.FilterView","doc":"A filter view.","ref":"GoogleApi.Sheets.V4.Model.FilterView.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.FilterView","doc":"*   `criteria` (*type:* `%{optional(String.t) => GoogleApi.Sheets.V4.Model.FilterCriteria.t}`, *default:* `nil`) - The criteria for showing/hiding values per column. The map's key is the column index, and the value is the criteria for that column. This field is deprecated in favor of filter_specs.\n*   `filterSpecs` (*type:* `list(GoogleApi.Sheets.V4.Model.FilterSpec.t)`, *default:* `nil`) - The filter criteria for showing/hiding values per column. Both criteria and filter_specs are populated in responses. If both fields are specified in an update request, this field takes precedence.\n*   `filterViewId` (*type:* `integer()`, *default:* `nil`) - The ID of the filter view.\n*   `namedRangeId` (*type:* `String.t`, *default:* `nil`) - The named range this filter view is backed by, if any. When writing, only one of range or named_range_id may be set.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range this filter view covers. When writing, only one of range or named_range_id may be set.\n*   `sortSpecs` (*type:* `list(GoogleApi.Sheets.V4.Model.SortSpec.t)`, *default:* `nil`) - The sort order per column. Later specifications are used when values are equal in the earlier specifications.\n*   `title` (*type:* `String.t`, *default:* `nil`) - The name of the filter view.","ref":"GoogleApi.Sheets.V4.Model.FilterView.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.FilterView.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.FilterView.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.FilterView.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.FilterView.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.FindReplaceRequest","doc":"Finds and replaces data in cells over a range, sheet, or all sheets.","ref":"GoogleApi.Sheets.V4.Model.FindReplaceRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.FindReplaceRequest","doc":"*   `allSheets` (*type:* `boolean()`, *default:* `nil`) - True to find/replace over all sheets.\n*   `find` (*type:* `String.t`, *default:* `nil`) - The value to search.\n*   `includeFormulas` (*type:* `boolean()`, *default:* `nil`) - True if the search should include cells with formulas. False to skip cells with formulas.\n*   `matchCase` (*type:* `boolean()`, *default:* `nil`) - True if the search is case sensitive.\n*   `matchEntireCell` (*type:* `boolean()`, *default:* `nil`) - True if the find value should match the entire cell.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range to find/replace over.\n*   `replacement` (*type:* `String.t`, *default:* `nil`) - The value to use as the replacement.\n*   `searchByRegex` (*type:* `boolean()`, *default:* `nil`) - True if the find value is a regex. The regular expression and replacement should follow Java regex rules at https://docs.oracle.com/javase/8/docs/api/java/util/regex/Pattern.html. The replacement string is allowed to refer to capturing groups. For example, if one cell has the contents `\"Google Sheets\"` and another has `\"Google Docs\"`, then searching for `\"o.* (.*)\"` with a replacement of `\"$1 Rocks\"` would change the contents of the cells to `\"GSheets Rocks\"` and `\"GDocs Rocks\"` respectively.\n*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The sheet to find/replace over.","ref":"GoogleApi.Sheets.V4.Model.FindReplaceRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.FindReplaceRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.FindReplaceRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.FindReplaceRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.FindReplaceRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.FindReplaceResponse","doc":"The result of the find/replace.","ref":"GoogleApi.Sheets.V4.Model.FindReplaceResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.FindReplaceResponse","doc":"*   `formulasChanged` (*type:* `integer()`, *default:* `nil`) - The number of formula cells changed.\n*   `occurrencesChanged` (*type:* `integer()`, *default:* `nil`) - The number of occurrences (possibly multiple within a cell) changed. For example, if replacing `\"e\"` with `\"o\"` in `\"Google Sheets\"`, this would be `\"3\"` because `\"Google Sheets\"` -> `\"Googlo Shoots\"`.\n*   `rowsChanged` (*type:* `integer()`, *default:* `nil`) - The number of rows changed.\n*   `sheetsChanged` (*type:* `integer()`, *default:* `nil`) - The number of sheets changed.\n*   `valuesChanged` (*type:* `integer()`, *default:* `nil`) - The number of non-formula cells changed.","ref":"GoogleApi.Sheets.V4.Model.FindReplaceResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.FindReplaceResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.FindReplaceResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.FindReplaceResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.FindReplaceResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.GetSpreadsheetByDataFilterRequest","doc":"The request for retrieving a Spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.GetSpreadsheetByDataFilterRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.GetSpreadsheetByDataFilterRequest","doc":"*   `dataFilters` (*type:* `list(GoogleApi.Sheets.V4.Model.DataFilter.t)`, *default:* `nil`) - The DataFilters used to select which ranges to retrieve from the spreadsheet.\n*   `includeGridData` (*type:* `boolean()`, *default:* `nil`) - True if grid data should be returned. This parameter is ignored if a field mask was set in the request.","ref":"GoogleApi.Sheets.V4.Model.GetSpreadsheetByDataFilterRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.GetSpreadsheetByDataFilterRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.GetSpreadsheetByDataFilterRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.GetSpreadsheetByDataFilterRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.GetSpreadsheetByDataFilterRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.GradientRule","doc":"A rule that applies a gradient color scale format, based on the interpolation points listed. The format of a cell will vary based on its contents as compared to the values of the interpolation points.","ref":"GoogleApi.Sheets.V4.Model.GradientRule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.GradientRule","doc":"*   `maxpoint` (*type:* `GoogleApi.Sheets.V4.Model.InterpolationPoint.t`, *default:* `nil`) - The final interpolation point.\n*   `midpoint` (*type:* `GoogleApi.Sheets.V4.Model.InterpolationPoint.t`, *default:* `nil`) - An optional midway interpolation point.\n*   `minpoint` (*type:* `GoogleApi.Sheets.V4.Model.InterpolationPoint.t`, *default:* `nil`) - The starting interpolation point.","ref":"GoogleApi.Sheets.V4.Model.GradientRule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.GradientRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.GradientRule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.GradientRule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.GradientRule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.GridCoordinate","doc":"A coordinate in a sheet. All indexes are zero-based.","ref":"GoogleApi.Sheets.V4.Model.GridCoordinate.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.GridCoordinate","doc":"*   `columnIndex` (*type:* `integer()`, *default:* `nil`) - The column index of the coordinate.\n*   `rowIndex` (*type:* `integer()`, *default:* `nil`) - The row index of the coordinate.\n*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The sheet this coordinate is on.","ref":"GoogleApi.Sheets.V4.Model.GridCoordinate.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.GridCoordinate.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.GridCoordinate.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.GridCoordinate.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.GridCoordinate.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.GridData","doc":"Data in the grid, as well as metadata about the dimensions.","ref":"GoogleApi.Sheets.V4.Model.GridData.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.GridData","doc":"*   `columnMetadata` (*type:* `list(GoogleApi.Sheets.V4.Model.DimensionProperties.t)`, *default:* `nil`) - Metadata about the requested columns in the grid, starting with the column in start_column.\n*   `rowData` (*type:* `list(GoogleApi.Sheets.V4.Model.RowData.t)`, *default:* `nil`) - The data in the grid, one entry per row, starting with the row in startRow. The values in RowData will correspond to columns starting at start_column.\n*   `rowMetadata` (*type:* `list(GoogleApi.Sheets.V4.Model.DimensionProperties.t)`, *default:* `nil`) - Metadata about the requested rows in the grid, starting with the row in start_row.\n*   `startColumn` (*type:* `integer()`, *default:* `nil`) - The first column this GridData refers to, zero-based.\n*   `startRow` (*type:* `integer()`, *default:* `nil`) - The first row this GridData refers to, zero-based.","ref":"GoogleApi.Sheets.V4.Model.GridData.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.GridData.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.GridData.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.GridData.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.GridData.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.GridProperties","doc":"Properties of a grid.","ref":"GoogleApi.Sheets.V4.Model.GridProperties.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.GridProperties","doc":"*   `columnCount` (*type:* `integer()`, *default:* `nil`) - The number of columns in the grid.\n*   `columnGroupControlAfter` (*type:* `boolean()`, *default:* `nil`) - True if the column grouping control toggle is shown after the group.\n*   `frozenColumnCount` (*type:* `integer()`, *default:* `nil`) - The number of columns that are frozen in the grid.\n*   `frozenRowCount` (*type:* `integer()`, *default:* `nil`) - The number of rows that are frozen in the grid.\n*   `hideGridlines` (*type:* `boolean()`, *default:* `nil`) - True if the grid isn't showing gridlines in the UI.\n*   `rowCount` (*type:* `integer()`, *default:* `nil`) - The number of rows in the grid.\n*   `rowGroupControlAfter` (*type:* `boolean()`, *default:* `nil`) - True if the row grouping control toggle is shown after the group.","ref":"GoogleApi.Sheets.V4.Model.GridProperties.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.GridProperties.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.GridProperties.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.GridProperties.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.GridProperties.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.GridRange","doc":"A range on a sheet. All indexes are zero-based. Indexes are half open, i.e. the start index is inclusive and the end index is exclusive -- [start_index, end_index). Missing indexes indicate the range is unbounded on that side. For example, if `\"Sheet1\"` is sheet ID 123456, then: `Sheet1!A1:A1 == sheet_id: 123456, start_row_index: 0, end_row_index: 1, start_column_index: 0, end_column_index: 1` `Sheet1!A3:B4 == sheet_id: 123456, start_row_index: 2, end_row_index: 4, start_column_index: 0, end_column_index: 2` `Sheet1!A:B == sheet_id: 123456, start_column_index: 0, end_column_index: 2` `Sheet1!A5:B == sheet_id: 123456, start_row_index: 4, start_column_index: 0, end_column_index: 2` `Sheet1 == sheet_id: 123456` The start index must always be less than or equal to the end index. If the start index equals the end index, then the range is empty. Empty ranges are typically not meaningful and are usually rendered in the UI as `#REF!`.","ref":"GoogleApi.Sheets.V4.Model.GridRange.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.GridRange","doc":"*   `endColumnIndex` (*type:* `integer()`, *default:* `nil`) - The end column (exclusive) of the range, or not set if unbounded.\n*   `endRowIndex` (*type:* `integer()`, *default:* `nil`) - The end row (exclusive) of the range, or not set if unbounded.\n*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The sheet this range is on.\n*   `startColumnIndex` (*type:* `integer()`, *default:* `nil`) - The start column (inclusive) of the range, or not set if unbounded.\n*   `startRowIndex` (*type:* `integer()`, *default:* `nil`) - The start row (inclusive) of the range, or not set if unbounded.","ref":"GoogleApi.Sheets.V4.Model.GridRange.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.GridRange.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.GridRange.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.GridRange.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.GridRange.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.HistogramChartSpec","doc":"A histogram chart. A histogram chart groups data items into bins, displaying each bin as a column of stacked items. Histograms are used to display the distribution of a dataset. Each column of items represents a range into which those items fall. The number of bins can be chosen automatically or specified explicitly.","ref":"GoogleApi.Sheets.V4.Model.HistogramChartSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.HistogramChartSpec","doc":"*   `bucketSize` (*type:* `float()`, *default:* `nil`) - By default the bucket size (the range of values stacked in a single column) is chosen automatically, but it may be overridden here. E.g., A bucket size of 1.5 results in buckets from 0 - 1.5, 1.5 - 3.0, etc. Cannot be negative. This field is optional.\n*   `legendPosition` (*type:* `String.t`, *default:* `nil`) - The position of the chart legend.\n*   `outlierPercentile` (*type:* `float()`, *default:* `nil`) - The outlier percentile is used to ensure that outliers do not adversely affect the calculation of bucket sizes. For example, setting an outlier percentile of 0.05 indicates that the top and bottom 5% of values when calculating buckets. The values are still included in the chart, they will be added to the first or last buckets instead of their own buckets. Must be between 0.0 and 0.5.\n*   `series` (*type:* `list(GoogleApi.Sheets.V4.Model.HistogramSeries.t)`, *default:* `nil`) - The series for a histogram may be either a single series of values to be bucketed or multiple series, each of the same length, containing the name of the series followed by the values to be bucketed for that series.\n*   `showItemDividers` (*type:* `boolean()`, *default:* `nil`) - Whether horizontal divider lines should be displayed between items in each column.","ref":"GoogleApi.Sheets.V4.Model.HistogramChartSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.HistogramChartSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.HistogramChartSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.HistogramChartSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.HistogramChartSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.HistogramRule","doc":"Allows you to organize the numeric values in a source data column into buckets of a constant size. All values from HistogramRule.start to HistogramRule.end are placed into groups of size HistogramRule.interval. In addition, all values below HistogramRule.start are placed in one group, and all values above HistogramRule.end are placed in another. Only HistogramRule.interval is required, though if HistogramRule.start and HistogramRule.end are both provided, HistogramRule.start must be less than HistogramRule.end. For example, a pivot table showing average purchase amount by age that has 50+ rows: +-----+-------------------+ | Age | AVERAGE of Amount | +-----+-------------------+ | 16 | $27.13 | | 17 | $5.24 | | 18 | $20.15 | ... +-----+-------------------+ could be turned into a pivot table that looks like the one below by applying a histogram group rule with a HistogramRule.start of 25, an HistogramRule.interval of 20, and an HistogramRule.end of 65. +-------------+-------------------+ | Grouped Age | AVERAGE of Amount | +-------------+-------------------+ | < 25 | $19.34 | | 25-45 | $31.43 | | 45-65 | $35.87 | | > 65 | $27.55 | +-------------+-------------------+ | Grand Total | $29.12 | +-------------+-------------------+","ref":"GoogleApi.Sheets.V4.Model.HistogramRule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.HistogramRule","doc":"*   `end` (*type:* `float()`, *default:* `nil`) - The maximum value at which items are placed into buckets of constant size. Values above end are lumped into a single bucket. This field is optional.\n*   `interval` (*type:* `float()`, *default:* `nil`) - The size of the buckets that are created. Must be positive.\n*   `start` (*type:* `float()`, *default:* `nil`) - The minimum value at which items are placed into buckets of constant size. Values below start are lumped into a single bucket. This field is optional.","ref":"GoogleApi.Sheets.V4.Model.HistogramRule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.HistogramRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.HistogramRule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.HistogramRule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.HistogramRule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.HistogramSeries","doc":"A histogram series containing the series color and data.","ref":"GoogleApi.Sheets.V4.Model.HistogramSeries.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.HistogramSeries","doc":"*   `barColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The color of the column representing this series in each bucket. This field is optional. Deprecated: Use bar_color_style.\n*   `barColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The color of the column representing this series in each bucket. This field is optional. If bar_color is also set, this field takes precedence.\n*   `data` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data for this histogram series.","ref":"GoogleApi.Sheets.V4.Model.HistogramSeries.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.HistogramSeries.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.HistogramSeries.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.HistogramSeries.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.HistogramSeries.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.InsertDimensionRequest","doc":"Inserts rows or columns in a sheet at a particular index.","ref":"GoogleApi.Sheets.V4.Model.InsertDimensionRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.InsertDimensionRequest","doc":"*   `inheritFromBefore` (*type:* `boolean()`, *default:* `nil`) - Whether dimension properties should be extended from the dimensions before or after the newly inserted dimensions. True to inherit from the dimensions before (in which case the start index must be greater than 0), and false to inherit from the dimensions after. For example, if row index 0 has red background and row index 1 has a green background, then inserting 2 rows at index 1 can inherit either the green or red background. If `inheritFromBefore` is true, the two new rows will be red (because the row before the insertion point was red), whereas if `inheritFromBefore` is false, the two new rows will be green (because the row after the insertion point was green).\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.DimensionRange.t`, *default:* `nil`) - The dimensions to insert. Both the start and end indexes must be bounded.","ref":"GoogleApi.Sheets.V4.Model.InsertDimensionRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.InsertDimensionRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.InsertDimensionRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.InsertDimensionRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.InsertDimensionRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.InsertRangeRequest","doc":"Inserts cells into a range, shifting the existing cells over or down.","ref":"GoogleApi.Sheets.V4.Model.InsertRangeRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.InsertRangeRequest","doc":"*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range to insert new cells into.\n*   `shiftDimension` (*type:* `String.t`, *default:* `nil`) - The dimension which will be shifted when inserting cells. If ROWS, existing cells will be shifted down. If COLUMNS, existing cells will be shifted right.","ref":"GoogleApi.Sheets.V4.Model.InsertRangeRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.InsertRangeRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.InsertRangeRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.InsertRangeRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.InsertRangeRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.InterpolationPoint","doc":"A single interpolation point on a gradient conditional format. These pin the gradient color scale according to the color, type and value chosen.","ref":"GoogleApi.Sheets.V4.Model.InterpolationPoint.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.InterpolationPoint","doc":"*   `color` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The color this interpolation point should use. Deprecated: Use color_style.\n*   `colorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The color this interpolation point should use. If color is also set, this field takes precedence.\n*   `type` (*type:* `String.t`, *default:* `nil`) - How the value should be interpreted.\n*   `value` (*type:* `String.t`, *default:* `nil`) - The value this interpolation point uses. May be a formula. Unused if type is MIN or MAX.","ref":"GoogleApi.Sheets.V4.Model.InterpolationPoint.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.InterpolationPoint.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.InterpolationPoint.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.InterpolationPoint.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.InterpolationPoint.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.Interval","doc":"Represents a time interval, encoded as a Timestamp start (inclusive) and a Timestamp end (exclusive). The start must be less than or equal to the end. When the start equals the end, the interval is empty (matches no time). When both start and end are unspecified, the interval matches any time.","ref":"GoogleApi.Sheets.V4.Model.Interval.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.Interval","doc":"*   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - Optional. Exclusive end of the interval. If specified, a Timestamp matching this interval will have to be before the end.\n*   `startTime` (*type:* `DateTime.t`, *default:* `nil`) - Optional. Inclusive start of the interval. If specified, a Timestamp matching this interval will have to be the same or after the start.","ref":"GoogleApi.Sheets.V4.Model.Interval.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.Interval.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.Interval.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.Interval.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.Interval.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.IterativeCalculationSettings","doc":"Settings to control how circular dependencies are resolved with iterative calculation.","ref":"GoogleApi.Sheets.V4.Model.IterativeCalculationSettings.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.IterativeCalculationSettings","doc":"*   `convergenceThreshold` (*type:* `float()`, *default:* `nil`) - When iterative calculation is enabled and successive results differ by less than this threshold value, the calculation rounds stop.\n*   `maxIterations` (*type:* `integer()`, *default:* `nil`) - When iterative calculation is enabled, the maximum number of calculation rounds to perform.","ref":"GoogleApi.Sheets.V4.Model.IterativeCalculationSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.IterativeCalculationSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.IterativeCalculationSettings.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.IterativeCalculationSettings.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.IterativeCalculationSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.KeyValueFormat","doc":"Formatting options for key value.","ref":"GoogleApi.Sheets.V4.Model.KeyValueFormat.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.KeyValueFormat","doc":"*   `position` (*type:* `GoogleApi.Sheets.V4.Model.TextPosition.t`, *default:* `nil`) - Specifies the horizontal text positioning of key value. This field is optional. If not specified, default positioning is used.\n*   `textFormat` (*type:* `GoogleApi.Sheets.V4.Model.TextFormat.t`, *default:* `nil`) - Text formatting options for key value. The link field is not supported.","ref":"GoogleApi.Sheets.V4.Model.KeyValueFormat.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.KeyValueFormat.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.KeyValueFormat.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.KeyValueFormat.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.KeyValueFormat.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.LineStyle","doc":"Properties that describe the style of a line.","ref":"GoogleApi.Sheets.V4.Model.LineStyle.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.LineStyle","doc":"*   `type` (*type:* `String.t`, *default:* `nil`) - The dash type of the line.\n*   `width` (*type:* `integer()`, *default:* `nil`) - The thickness of the line, in px.","ref":"GoogleApi.Sheets.V4.Model.LineStyle.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.LineStyle.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.LineStyle.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.LineStyle.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.LineStyle.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.Link","doc":"An external or local reference.","ref":"GoogleApi.Sheets.V4.Model.Link.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.Link","doc":"*   `uri` (*type:* `String.t`, *default:* `nil`) - The link identifier.","ref":"GoogleApi.Sheets.V4.Model.Link.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.Link.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.Link.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.Link.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.Link.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ManualRule","doc":"Allows you to manually organize the values in a source data column into buckets with names of your choosing. For example, a pivot table that aggregates population by state: +-------+-------------------+ | State | SUM of Population | +-------+-------------------+ | AK | 0.7 | | AL | 4.8 | | AR | 2.9 | ... +-------+-------------------+ could be turned into a pivot table that aggregates population by time zone by providing a list of groups (for example, groupName = 'Central', items = ['AL', 'AR', 'IA', ...]) to a manual group rule. Note that a similar effect could be achieved by adding a time zone column to the source data and adjusting the pivot table. +-----------+-------------------+ | Time Zone | SUM of Population | +-----------+-------------------+ | Central | 106.3 | | Eastern | 151.9 | | Mountain | 17.4 | ... +-----------+-------------------+","ref":"GoogleApi.Sheets.V4.Model.ManualRule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ManualRule","doc":"*   `groups` (*type:* `list(GoogleApi.Sheets.V4.Model.ManualRuleGroup.t)`, *default:* `nil`) - The list of group names and the corresponding items from the source data that map to each group name.","ref":"GoogleApi.Sheets.V4.Model.ManualRule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ManualRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ManualRule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ManualRule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ManualRule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ManualRuleGroup","doc":"A group name and a list of items from the source data that should be placed in the group with this name.","ref":"GoogleApi.Sheets.V4.Model.ManualRuleGroup.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ManualRuleGroup","doc":"*   `groupName` (*type:* `GoogleApi.Sheets.V4.Model.ExtendedValue.t`, *default:* `nil`) - The group name, which must be a string. Each group in a given ManualRule must have a unique group name.\n*   `items` (*type:* `list(GoogleApi.Sheets.V4.Model.ExtendedValue.t)`, *default:* `nil`) - The items in the source data that should be placed into this group. Each item may be a string, number, or boolean. Items may appear in at most one group within a given ManualRule. Items that do not appear in any group will appear on their own.","ref":"GoogleApi.Sheets.V4.Model.ManualRuleGroup.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ManualRuleGroup.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ManualRuleGroup.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ManualRuleGroup.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ManualRuleGroup.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.MatchedDeveloperMetadata","doc":"A developer metadata entry and the data filters specified in the original request that matched it.","ref":"GoogleApi.Sheets.V4.Model.MatchedDeveloperMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.MatchedDeveloperMetadata","doc":"*   `dataFilters` (*type:* `list(GoogleApi.Sheets.V4.Model.DataFilter.t)`, *default:* `nil`) - All filters matching the returned developer metadata.\n*   `developerMetadata` (*type:* `GoogleApi.Sheets.V4.Model.DeveloperMetadata.t`, *default:* `nil`) - The developer metadata matching the specified filters.","ref":"GoogleApi.Sheets.V4.Model.MatchedDeveloperMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.MatchedDeveloperMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.MatchedDeveloperMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.MatchedDeveloperMetadata.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.MatchedDeveloperMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.MatchedValueRange","doc":"A value range that was matched by one or more data filers.","ref":"GoogleApi.Sheets.V4.Model.MatchedValueRange.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.MatchedValueRange","doc":"*   `dataFilters` (*type:* `list(GoogleApi.Sheets.V4.Model.DataFilter.t)`, *default:* `nil`) - The DataFilters from the request that matched the range of values.\n*   `valueRange` (*type:* `GoogleApi.Sheets.V4.Model.ValueRange.t`, *default:* `nil`) - The values matched by the DataFilter.","ref":"GoogleApi.Sheets.V4.Model.MatchedValueRange.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.MatchedValueRange.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.MatchedValueRange.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.MatchedValueRange.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.MatchedValueRange.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.MergeCellsRequest","doc":"Merges all cells in the range.","ref":"GoogleApi.Sheets.V4.Model.MergeCellsRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.MergeCellsRequest","doc":"*   `mergeType` (*type:* `String.t`, *default:* `nil`) - How the cells should be merged.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range of cells to merge.","ref":"GoogleApi.Sheets.V4.Model.MergeCellsRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.MergeCellsRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.MergeCellsRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.MergeCellsRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.MergeCellsRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.MoveDimensionRequest","doc":"Moves one or more rows or columns.","ref":"GoogleApi.Sheets.V4.Model.MoveDimensionRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.MoveDimensionRequest","doc":"*   `destinationIndex` (*type:* `integer()`, *default:* `nil`) - The zero-based start index of where to move the source data to, based on the coordinates *before* the source data is removed from the grid. Existing data will be shifted down or right (depending on the dimension) to make room for the moved dimensions. The source dimensions are removed from the grid, so the the data may end up in a different index than specified. For example, given `A1..A5` of `0, 1, 2, 3, 4` and wanting to move `\"1\"` and `\"2\"` to between `\"3\"` and `\"4\"`, the source would be `ROWS [1..3)`,and the destination index would be `\"4\"` (the zero-based index of row 5). The end result would be `A1..A5` of `0, 3, 1, 2, 4`.\n*   `source` (*type:* `GoogleApi.Sheets.V4.Model.DimensionRange.t`, *default:* `nil`) - The source dimensions to move.","ref":"GoogleApi.Sheets.V4.Model.MoveDimensionRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.MoveDimensionRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.MoveDimensionRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.MoveDimensionRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.MoveDimensionRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.NamedRange","doc":"A named range.","ref":"GoogleApi.Sheets.V4.Model.NamedRange.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.NamedRange","doc":"*   `name` (*type:* `String.t`, *default:* `nil`) - The name of the named range.\n*   `namedRangeId` (*type:* `String.t`, *default:* `nil`) - The ID of the named range.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range this represents.","ref":"GoogleApi.Sheets.V4.Model.NamedRange.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.NamedRange.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.NamedRange.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.NamedRange.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.NamedRange.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.NumberFormat","doc":"The number format of a cell.","ref":"GoogleApi.Sheets.V4.Model.NumberFormat.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.NumberFormat","doc":"*   `pattern` (*type:* `String.t`, *default:* `nil`) - Pattern string used for formatting. If not set, a default pattern based on the user's locale will be used if necessary for the given type. See the [Date and Number Formats guide](/sheets/api/guides/formats) for more information about the supported patterns.\n*   `type` (*type:* `String.t`, *default:* `nil`) - The type of the number format. When writing, this field must be set.","ref":"GoogleApi.Sheets.V4.Model.NumberFormat.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.NumberFormat.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.NumberFormat.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.NumberFormat.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.NumberFormat.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.OrgChartSpec","doc":"An org chart. Org charts require a unique set of labels in labels and may optionally include parent_labels and tooltips. parent_labels contain, for each node, the label identifying the parent node. tooltips contain, for each node, an optional tooltip. For example, to describe an OrgChart with Alice as the CEO, Bob as the President (reporting to Alice) and Cathy as VP of Sales (also reporting to Alice), have labels contain \"Alice\", \"Bob\", \"Cathy\", parent_labels contain \"\", \"Alice\", \"Alice\" and tooltips contain \"CEO\", \"President\", \"VP Sales\".","ref":"GoogleApi.Sheets.V4.Model.OrgChartSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.OrgChartSpec","doc":"*   `labels` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data containing the labels for all the nodes in the chart. Labels must be unique.\n*   `nodeColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The color of the org chart nodes. Deprecated: Use node_color_style.\n*   `nodeColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The color of the org chart nodes. If node_color is also set, this field takes precedence.\n*   `nodeSize` (*type:* `String.t`, *default:* `nil`) - The size of the org chart nodes.\n*   `parentLabels` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data containing the label of the parent for the corresponding node. A blank value indicates that the node has no parent and is a top-level node. This field is optional.\n*   `selectedNodeColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The color of the selected org chart nodes. Deprecated: Use selected_node_color_style.\n*   `selectedNodeColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The color of the selected org chart nodes. If selected_node_color is also set, this field takes precedence.\n*   `tooltips` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data containing the tooltip for the corresponding node. A blank value results in no tooltip being displayed for the node. This field is optional.","ref":"GoogleApi.Sheets.V4.Model.OrgChartSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.OrgChartSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.OrgChartSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.OrgChartSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.OrgChartSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.OverlayPosition","doc":"The location an object is overlaid on top of a grid.","ref":"GoogleApi.Sheets.V4.Model.OverlayPosition.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.OverlayPosition","doc":"*   `anchorCell` (*type:* `GoogleApi.Sheets.V4.Model.GridCoordinate.t`, *default:* `nil`) - The cell the object is anchored to.\n*   `heightPixels` (*type:* `integer()`, *default:* `nil`) - The height of the object, in pixels. Defaults to 371.\n*   `offsetXPixels` (*type:* `integer()`, *default:* `nil`) - The horizontal offset, in pixels, that the object is offset from the anchor cell.\n*   `offsetYPixels` (*type:* `integer()`, *default:* `nil`) - The vertical offset, in pixels, that the object is offset from the anchor cell.\n*   `widthPixels` (*type:* `integer()`, *default:* `nil`) - The width of the object, in pixels. Defaults to 600.","ref":"GoogleApi.Sheets.V4.Model.OverlayPosition.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.OverlayPosition.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.OverlayPosition.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.OverlayPosition.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.OverlayPosition.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.Padding","doc":"The amount of padding around the cell, in pixels. When updating padding, every field must be specified.","ref":"GoogleApi.Sheets.V4.Model.Padding.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.Padding","doc":"*   `bottom` (*type:* `integer()`, *default:* `nil`) - The bottom padding of the cell.\n*   `left` (*type:* `integer()`, *default:* `nil`) - The left padding of the cell.\n*   `right` (*type:* `integer()`, *default:* `nil`) - The right padding of the cell.\n*   `top` (*type:* `integer()`, *default:* `nil`) - The top padding of the cell.","ref":"GoogleApi.Sheets.V4.Model.Padding.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.Padding.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.Padding.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.Padding.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.Padding.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.PasteDataRequest","doc":"Inserts data into the spreadsheet starting at the specified coordinate.","ref":"GoogleApi.Sheets.V4.Model.PasteDataRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.PasteDataRequest","doc":"*   `coordinate` (*type:* `GoogleApi.Sheets.V4.Model.GridCoordinate.t`, *default:* `nil`) - The coordinate at which the data should start being inserted.\n*   `data` (*type:* `String.t`, *default:* `nil`) - The data to insert.\n*   `delimiter` (*type:* `String.t`, *default:* `nil`) - The delimiter in the data.\n*   `html` (*type:* `boolean()`, *default:* `nil`) - True if the data is HTML.\n*   `type` (*type:* `String.t`, *default:* `nil`) - How the data should be pasted.","ref":"GoogleApi.Sheets.V4.Model.PasteDataRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.PasteDataRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.PasteDataRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.PasteDataRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.PasteDataRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.PieChartSpec","doc":"A pie chart.","ref":"GoogleApi.Sheets.V4.Model.PieChartSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.PieChartSpec","doc":"*   `domain` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data that covers the domain of the pie chart.\n*   `legendPosition` (*type:* `String.t`, *default:* `nil`) - Where the legend of the pie chart should be drawn.\n*   `pieHole` (*type:* `float()`, *default:* `nil`) - The size of the hole in the pie chart.\n*   `series` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data that covers the one and only series of the pie chart.\n*   `threeDimensional` (*type:* `boolean()`, *default:* `nil`) - True if the pie is three dimensional.","ref":"GoogleApi.Sheets.V4.Model.PieChartSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.PieChartSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.PieChartSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.PieChartSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.PieChartSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.PivotFilterCriteria","doc":"Criteria for showing/hiding rows in a pivot table.","ref":"GoogleApi.Sheets.V4.Model.PivotFilterCriteria.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.PivotFilterCriteria","doc":"*   `condition` (*type:* `GoogleApi.Sheets.V4.Model.BooleanCondition.t`, *default:* `nil`) - A condition that must be true for values to be shown. (`visibleValues` does not override this -- even if a value is listed there, it is still hidden if it does not meet the condition.) Condition values that refer to ranges in A1-notation are evaluated relative to the pivot table sheet. References are treated absolutely, so are not filled down the pivot table. For example, a condition value of `=A1` on \"Pivot Table 1\" is treated as `'Pivot Table 1'!$A$1`. The source data of the pivot table can be referenced by column header name. For example, if the source data has columns named \"Revenue\" and \"Cost\" and a condition is applied to the \"Revenue\" column with type `NUMBER_GREATER` and value `=Cost`, then only columns where \"Revenue\" > \"Cost\" are included.\n*   `visibleByDefault` (*type:* `boolean()`, *default:* `nil`) - Whether values are visible by default. If true, the visible_values are ignored, all values that meet condition (if specified) are shown. If false, values that are both in visible_values and meet condition are shown.\n*   `visibleValues` (*type:* `list(String.t)`, *default:* `nil`) - Values that should be included. Values not listed here are excluded.","ref":"GoogleApi.Sheets.V4.Model.PivotFilterCriteria.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.PivotFilterCriteria.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.PivotFilterCriteria.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.PivotFilterCriteria.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.PivotFilterCriteria.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.PivotFilterSpec","doc":"The pivot table filter criteria associated with a specific source column offset.","ref":"GoogleApi.Sheets.V4.Model.PivotFilterSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.PivotFilterSpec","doc":"*   `columnOffsetIndex` (*type:* `integer()`, *default:* `nil`) - The zero-based column offset of the source range.\n*   `dataSourceColumnReference` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceColumnReference.t`, *default:* `nil`) - The reference to the data source column.\n*   `filterCriteria` (*type:* `GoogleApi.Sheets.V4.Model.PivotFilterCriteria.t`, *default:* `nil`) - The criteria for the column.","ref":"GoogleApi.Sheets.V4.Model.PivotFilterSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.PivotFilterSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.PivotFilterSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.PivotFilterSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.PivotFilterSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.PivotGroup","doc":"A single grouping (either row or column) in a pivot table.","ref":"GoogleApi.Sheets.V4.Model.PivotGroup.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.PivotGroup","doc":"*   `dataSourceColumnReference` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceColumnReference.t`, *default:* `nil`) - The reference to the data source column this grouping is based on.\n*   `groupLimit` (*type:* `GoogleApi.Sheets.V4.Model.PivotGroupLimit.t`, *default:* `nil`) - The count limit on rows or columns to apply to this pivot group.\n*   `groupRule` (*type:* `GoogleApi.Sheets.V4.Model.PivotGroupRule.t`, *default:* `nil`) - The group rule to apply to this row/column group.\n*   `label` (*type:* `String.t`, *default:* `nil`) - The labels to use for the row/column groups which can be customized. For example, in the following pivot table, the row label is `Region` (which could be renamed to `State`) and the column label is `Product` (which could be renamed `Item`). Pivot tables created before December 2017 do not have header labels. If you'd like to add header labels to an existing pivot table, please delete the existing pivot table and then create a new pivot table with same parameters. +--------------+---------+-------+ | SUM of Units | Product | | | Region | Pen | Paper | +--------------+---------+-------+ | New York | 345 | 98 | | Oregon | 234 | 123 | | Tennessee | 531 | 415 | +--------------+---------+-------+ | Grand Total | 1110 | 636 | +--------------+---------+-------+\n*   `repeatHeadings` (*type:* `boolean()`, *default:* `nil`) - True if the headings in this pivot group should be repeated. This is only valid for row groupings and is ignored by columns. By default, we minimize repetition of headings by not showing higher level headings where they are the same. For example, even though the third row below corresponds to \"Q1 Mar\", \"Q1\" is not shown because it is redundant with previous rows. Setting repeat_headings to true would cause \"Q1\" to be repeated for \"Feb\" and \"Mar\". +--------------+ | Q1 | Jan | | | Feb | | | Mar | +--------+-----+ | Q1 Total | +--------------+\n*   `showTotals` (*type:* `boolean()`, *default:* `nil`) - True if the pivot table should include the totals for this grouping.\n*   `sortOrder` (*type:* `String.t`, *default:* `nil`) - The order the values in this group should be sorted.\n*   `sourceColumnOffset` (*type:* `integer()`, *default:* `nil`) - The column offset of the source range that this grouping is based on. For example, if the source was `C10:E15`, a `sourceColumnOffset` of `0` means this group refers to column `C`, whereas the offset `1` would refer to column `D`.\n*   `valueBucket` (*type:* `GoogleApi.Sheets.V4.Model.PivotGroupSortValueBucket.t`, *default:* `nil`) - The bucket of the opposite pivot group to sort by. If not specified, sorting is alphabetical by this group's values.\n*   `valueMetadata` (*type:* `list(GoogleApi.Sheets.V4.Model.PivotGroupValueMetadata.t)`, *default:* `nil`) - Metadata about values in the grouping.","ref":"GoogleApi.Sheets.V4.Model.PivotGroup.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.PivotGroup.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.PivotGroup.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.PivotGroup.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.PivotGroup.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.PivotGroupLimit","doc":"The count limit on rows or columns in the pivot group.","ref":"GoogleApi.Sheets.V4.Model.PivotGroupLimit.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.PivotGroupLimit","doc":"*   `applyOrder` (*type:* `integer()`, *default:* `nil`) - The order in which the group limit is applied to the pivot table. Pivot group limits are applied from lower to higher order number. Order numbers are normalized to consecutive integers from 0. For write request, to fully customize the applying orders, all pivot group limits should have this field set with an unique number. Otherwise, the order is determined by the index in the PivotTable.rows list and then the PivotTable.columns list.\n*   `countLimit` (*type:* `integer()`, *default:* `nil`) - The count limit.","ref":"GoogleApi.Sheets.V4.Model.PivotGroupLimit.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.PivotGroupLimit.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.PivotGroupLimit.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.PivotGroupLimit.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.PivotGroupLimit.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.PivotGroupRule","doc":"An optional setting on a PivotGroup that defines buckets for the values in the source data column rather than breaking out each individual value. Only one PivotGroup with a group rule may be added for each column in the source data, though on any given column you may add both a PivotGroup that has a rule and a PivotGroup that does not.","ref":"GoogleApi.Sheets.V4.Model.PivotGroupRule.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.PivotGroupRule","doc":"*   `dateTimeRule` (*type:* `GoogleApi.Sheets.V4.Model.DateTimeRule.t`, *default:* `nil`) - A DateTimeRule.\n*   `histogramRule` (*type:* `GoogleApi.Sheets.V4.Model.HistogramRule.t`, *default:* `nil`) - A HistogramRule.\n*   `manualRule` (*type:* `GoogleApi.Sheets.V4.Model.ManualRule.t`, *default:* `nil`) - A ManualRule.","ref":"GoogleApi.Sheets.V4.Model.PivotGroupRule.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.PivotGroupRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.PivotGroupRule.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.PivotGroupRule.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.PivotGroupRule.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.PivotGroupSortValueBucket","doc":"Information about which values in a pivot group should be used for sorting.","ref":"GoogleApi.Sheets.V4.Model.PivotGroupSortValueBucket.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.PivotGroupSortValueBucket","doc":"*   `buckets` (*type:* `list(GoogleApi.Sheets.V4.Model.ExtendedValue.t)`, *default:* `nil`) - Determines the bucket from which values are chosen to sort. For example, in a pivot table with one row group & two column groups, the row group can list up to two values. The first value corresponds to a value within the first column group, and the second value corresponds to a value in the second column group. If no values are listed, this would indicate that the row should be sorted according to the \"Grand Total\" over the column groups. If a single value is listed, this would correspond to using the \"Total\" of that bucket.\n*   `valuesIndex` (*type:* `integer()`, *default:* `nil`) - The offset in the PivotTable.values list which the values in this grouping should be sorted by.","ref":"GoogleApi.Sheets.V4.Model.PivotGroupSortValueBucket.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.PivotGroupSortValueBucket.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.PivotGroupSortValueBucket.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.PivotGroupSortValueBucket.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.PivotGroupSortValueBucket.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.PivotGroupValueMetadata","doc":"Metadata about a value in a pivot grouping.","ref":"GoogleApi.Sheets.V4.Model.PivotGroupValueMetadata.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.PivotGroupValueMetadata","doc":"*   `collapsed` (*type:* `boolean()`, *default:* `nil`) - True if the data corresponding to the value is collapsed.\n*   `value` (*type:* `GoogleApi.Sheets.V4.Model.ExtendedValue.t`, *default:* `nil`) - The calculated value the metadata corresponds to. (Note that formulaValue is not valid, because the values will be calculated.)","ref":"GoogleApi.Sheets.V4.Model.PivotGroupValueMetadata.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.PivotGroupValueMetadata.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.PivotGroupValueMetadata.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.PivotGroupValueMetadata.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.PivotGroupValueMetadata.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.PivotTable","doc":"A pivot table.","ref":"GoogleApi.Sheets.V4.Model.PivotTable.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.PivotTable","doc":"*   `columns` (*type:* `list(GoogleApi.Sheets.V4.Model.PivotGroup.t)`, *default:* `nil`) - Each column grouping in the pivot table.\n*   `criteria` (*type:* `%{optional(String.t) => GoogleApi.Sheets.V4.Model.PivotFilterCriteria.t}`, *default:* `nil`) - An optional mapping of filters per source column offset. The filters are applied before aggregating data into the pivot table. The map's key is the column offset of the source range that you want to filter, and the value is the criteria for that column. For example, if the source was `C10:E15`, a key of `0` will have the filter for column `C`, whereas the key `1` is for column `D`. This field is deprecated in favor of filter_specs.\n*   `dataExecutionStatus` (*type:* `GoogleApi.Sheets.V4.Model.DataExecutionStatus.t`, *default:* `nil`) - Output only. The data execution status for data source pivot tables.\n*   `dataSourceId` (*type:* `String.t`, *default:* `nil`) - The ID of the data source the pivot table is reading data from.\n*   `filterSpecs` (*type:* `list(GoogleApi.Sheets.V4.Model.PivotFilterSpec.t)`, *default:* `nil`) - The filters applied to the source columns before aggregating data for the pivot table. Both criteria and filter_specs are populated in responses. If both fields are specified in an update request, this field takes precedence.\n*   `rows` (*type:* `list(GoogleApi.Sheets.V4.Model.PivotGroup.t)`, *default:* `nil`) - Each row grouping in the pivot table.\n*   `source` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range the pivot table is reading data from.\n*   `valueLayout` (*type:* `String.t`, *default:* `nil`) - Whether values should be listed horizontally (as columns) or vertically (as rows).\n*   `values` (*type:* `list(GoogleApi.Sheets.V4.Model.PivotValue.t)`, *default:* `nil`) - A list of values to include in the pivot table.","ref":"GoogleApi.Sheets.V4.Model.PivotTable.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.PivotTable.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.PivotTable.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.PivotTable.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.PivotTable.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.PivotValue","doc":"The definition of how a value in a pivot table should be calculated.","ref":"GoogleApi.Sheets.V4.Model.PivotValue.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.PivotValue","doc":"*   `calculatedDisplayType` (*type:* `String.t`, *default:* `nil`) - If specified, indicates that pivot values should be displayed as the result of a calculation with another pivot value. For example, if calculated_display_type is specified as PERCENT_OF_GRAND_TOTAL, all the pivot values are displayed as the percentage of the grand total. In the Sheets editor, this is referred to as \"Show As\" in the value section of a pivot table.\n*   `dataSourceColumnReference` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceColumnReference.t`, *default:* `nil`) - The reference to the data source column that this value reads from.\n*   `formula` (*type:* `String.t`, *default:* `nil`) - A custom formula to calculate the value. The formula must start with an `=` character.\n*   `name` (*type:* `String.t`, *default:* `nil`) - A name to use for the value.\n*   `sourceColumnOffset` (*type:* `integer()`, *default:* `nil`) - The column offset of the source range that this value reads from. For example, if the source was `C10:E15`, a `sourceColumnOffset` of `0` means this value refers to column `C`, whereas the offset `1` would refer to column `D`.\n*   `summarizeFunction` (*type:* `String.t`, *default:* `nil`) - A function to summarize the value. If formula is set, the only supported values are SUM and CUSTOM. If sourceColumnOffset is set, then `CUSTOM` is not supported.","ref":"GoogleApi.Sheets.V4.Model.PivotValue.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.PivotValue.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.PivotValue.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.PivotValue.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.PivotValue.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.PointStyle","doc":"The style of a point on the chart.","ref":"GoogleApi.Sheets.V4.Model.PointStyle.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.PointStyle","doc":"*   `shape` (*type:* `String.t`, *default:* `nil`) - The point shape. If empty or unspecified, a default shape is used.\n*   `size` (*type:* `float()`, *default:* `nil`) - The point size. If empty, a default size is used.","ref":"GoogleApi.Sheets.V4.Model.PointStyle.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.PointStyle.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.PointStyle.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.PointStyle.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.PointStyle.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ProtectedRange","doc":"A protected range.","ref":"GoogleApi.Sheets.V4.Model.ProtectedRange.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ProtectedRange","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - The description of this protected range.\n*   `editors` (*type:* `GoogleApi.Sheets.V4.Model.Editors.t`, *default:* `nil`) - The users and groups with edit access to the protected range. This field is only visible to users with edit access to the protected range and the document. Editors are not supported with warning_only protection.\n*   `namedRangeId` (*type:* `String.t`, *default:* `nil`) - The named range this protected range is backed by, if any. When writing, only one of range or named_range_id may be set.\n*   `protectedRangeId` (*type:* `integer()`, *default:* `nil`) - The ID of the protected range. This field is read-only.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range that is being protected. The range may be fully unbounded, in which case this is considered a protected sheet. When writing, only one of range or named_range_id may be set.\n*   `requestingUserCanEdit` (*type:* `boolean()`, *default:* `nil`) - True if the user who requested this protected range can edit the protected area. This field is read-only.\n*   `unprotectedRanges` (*type:* `list(GoogleApi.Sheets.V4.Model.GridRange.t)`, *default:* `nil`) - The list of unprotected ranges within a protected sheet. Unprotected ranges are only supported on protected sheets.\n*   `warningOnly` (*type:* `boolean()`, *default:* `nil`) - True if this protected range will show a warning when editing. Warning-based protection means that every user can edit data in the protected range, except editing will prompt a warning asking the user to confirm the edit. When writing: if this field is true, then editors are ignored. Additionally, if this field is changed from true to false and the `editors` field is not set (nor included in the field mask), then the editors will be set to all the editors in the document.","ref":"GoogleApi.Sheets.V4.Model.ProtectedRange.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ProtectedRange.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ProtectedRange.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ProtectedRange.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ProtectedRange.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.RandomizeRangeRequest","doc":"Randomizes the order of the rows in a range.","ref":"GoogleApi.Sheets.V4.Model.RandomizeRangeRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.RandomizeRangeRequest","doc":"*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range to randomize.","ref":"GoogleApi.Sheets.V4.Model.RandomizeRangeRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.RandomizeRangeRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.RandomizeRangeRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.RandomizeRangeRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.RandomizeRangeRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.RefreshDataSourceObjectExecutionStatus","doc":"The execution status of refreshing one data source object.","ref":"GoogleApi.Sheets.V4.Model.RefreshDataSourceObjectExecutionStatus.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.RefreshDataSourceObjectExecutionStatus","doc":"*   `dataExecutionStatus` (*type:* `GoogleApi.Sheets.V4.Model.DataExecutionStatus.t`, *default:* `nil`) - The data execution status.\n*   `reference` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceObjectReference.t`, *default:* `nil`) - Reference to a data source object being refreshed.","ref":"GoogleApi.Sheets.V4.Model.RefreshDataSourceObjectExecutionStatus.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.RefreshDataSourceObjectExecutionStatus.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.RefreshDataSourceObjectExecutionStatus.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.RefreshDataSourceObjectExecutionStatus.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.RefreshDataSourceObjectExecutionStatus.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.RefreshDataSourceRequest","doc":"Refreshes one or multiple data source objects in the spreadsheet by the specified references. The request requires an additional `bigquery.readonly` OAuth scope. If there are multiple refresh requests referencing the same data source objects in one batch, only the last refresh request is processed, and all those requests will have the same response accordingly.","ref":"GoogleApi.Sheets.V4.Model.RefreshDataSourceRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.RefreshDataSourceRequest","doc":"*   `dataSourceId` (*type:* `String.t`, *default:* `nil`) - Reference to a DataSource. If specified, refreshes all associated data source objects for the data source.\n*   `force` (*type:* `boolean()`, *default:* `nil`) - Refreshes the data source objects regardless of the current state. If not set and a referenced data source object was in error state, the refresh will fail immediately.\n*   `isAll` (*type:* `boolean()`, *default:* `nil`) - Refreshes all existing data source objects in the spreadsheet.\n*   `references` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceObjectReferences.t`, *default:* `nil`) - References to data source objects to refresh.","ref":"GoogleApi.Sheets.V4.Model.RefreshDataSourceRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.RefreshDataSourceRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.RefreshDataSourceRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.RefreshDataSourceRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.RefreshDataSourceRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.RefreshDataSourceResponse","doc":"The response from refreshing one or multiple data source objects.","ref":"GoogleApi.Sheets.V4.Model.RefreshDataSourceResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.RefreshDataSourceResponse","doc":"*   `statuses` (*type:* `list(GoogleApi.Sheets.V4.Model.RefreshDataSourceObjectExecutionStatus.t)`, *default:* `nil`) - All the refresh status for the data source object references specified in the request. If is_all is specified, the field contains only those in failure status.","ref":"GoogleApi.Sheets.V4.Model.RefreshDataSourceResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.RefreshDataSourceResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.RefreshDataSourceResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.RefreshDataSourceResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.RefreshDataSourceResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.RepeatCellRequest","doc":"Updates all cells in the range to the values in the given Cell object. Only the fields listed in the fields field are updated; others are unchanged. If writing a cell with a formula, the formula's ranges will automatically increment for each field in the range. For example, if writing a cell with formula `=A1` into range B2:C4, B2 would be `=A1`, B3 would be `=A2`, B4 would be `=A3`, C2 would be `=B1`, C3 would be `=B2`, C4 would be `=B3`. To keep the formula's ranges static, use the `$` indicator. For example, use the formula `=$A$1` to prevent both the row and the column from incrementing.","ref":"GoogleApi.Sheets.V4.Model.RepeatCellRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.RepeatCellRequest","doc":"*   `cell` (*type:* `GoogleApi.Sheets.V4.Model.CellData.t`, *default:* `nil`) - The data to write.\n*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `cell` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range to repeat the cell in.","ref":"GoogleApi.Sheets.V4.Model.RepeatCellRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.RepeatCellRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.RepeatCellRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.RepeatCellRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.RepeatCellRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.Request","doc":"A single kind of update to apply to a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.Request.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.Request","doc":"*   `appendCells` (*type:* `GoogleApi.Sheets.V4.Model.AppendCellsRequest.t`, *default:* `nil`) - Appends cells after the last row with data in a sheet.\n*   `autoFill` (*type:* `GoogleApi.Sheets.V4.Model.AutoFillRequest.t`, *default:* `nil`) - Automatically fills in more data based on existing data.\n*   `trimWhitespace` (*type:* `GoogleApi.Sheets.V4.Model.TrimWhitespaceRequest.t`, *default:* `nil`) - Trims cells of whitespace (such as spaces, tabs, or new lines).\n*   `moveDimension` (*type:* `GoogleApi.Sheets.V4.Model.MoveDimensionRequest.t`, *default:* `nil`) - Moves rows or columns to another location in a sheet.\n*   `insertRange` (*type:* `GoogleApi.Sheets.V4.Model.InsertRangeRequest.t`, *default:* `nil`) - Inserts new cells in a sheet, shifting the existing cells.\n*   `deleteDeveloperMetadata` (*type:* `GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataRequest.t`, *default:* `nil`) - Deletes developer metadata\n*   `addSheet` (*type:* `GoogleApi.Sheets.V4.Model.AddSheetRequest.t`, *default:* `nil`) - Adds a sheet.\n*   `addConditionalFormatRule` (*type:* `GoogleApi.Sheets.V4.Model.AddConditionalFormatRuleRequest.t`, *default:* `nil`) - Adds a new conditional format rule.\n*   `unmergeCells` (*type:* `GoogleApi.Sheets.V4.Model.UnmergeCellsRequest.t`, *default:* `nil`) - Unmerges merged cells.\n*   `addChart` (*type:* `GoogleApi.Sheets.V4.Model.AddChartRequest.t`, *default:* `nil`) - Adds a chart.\n*   `deleteDuplicates` (*type:* `GoogleApi.Sheets.V4.Model.DeleteDuplicatesRequest.t`, *default:* `nil`) - Removes rows containing duplicate values in specified columns of a cell range.\n*   `randomizeRange` (*type:* `GoogleApi.Sheets.V4.Model.RandomizeRangeRequest.t`, *default:* `nil`) - Randomizes the order of the rows in a range.\n*   `deleteSheet` (*type:* `GoogleApi.Sheets.V4.Model.DeleteSheetRequest.t`, *default:* `nil`) - Deletes a sheet.\n*   `repeatCell` (*type:* `GoogleApi.Sheets.V4.Model.RepeatCellRequest.t`, *default:* `nil`) - Repeats a single cell across a range.\n*   `textToColumns` (*type:* `GoogleApi.Sheets.V4.Model.TextToColumnsRequest.t`, *default:* `nil`) - Converts a column of text into many columns of text.\n*   `updateDataSource` (*type:* `GoogleApi.Sheets.V4.Model.UpdateDataSourceRequest.t`, *default:* `nil`) - Updates a data source.\n*   `updateChartSpec` (*type:* `GoogleApi.Sheets.V4.Model.UpdateChartSpecRequest.t`, *default:* `nil`) - Updates a chart's specifications.\n*   `insertDimension` (*type:* `GoogleApi.Sheets.V4.Model.InsertDimensionRequest.t`, *default:* `nil`) - Inserts new rows or columns in a sheet.\n*   `deleteDimension` (*type:* `GoogleApi.Sheets.V4.Model.DeleteDimensionRequest.t`, *default:* `nil`) - Deletes rows or columns in a sheet.\n*   `updateBanding` (*type:* `GoogleApi.Sheets.V4.Model.UpdateBandingRequest.t`, *default:* `nil`) - Updates a banded range\n*   `updateSpreadsheetProperties` (*type:* `GoogleApi.Sheets.V4.Model.UpdateSpreadsheetPropertiesRequest.t`, *default:* `nil`) - Updates the spreadsheet's properties.\n*   `findReplace` (*type:* `GoogleApi.Sheets.V4.Model.FindReplaceRequest.t`, *default:* `nil`) - Finds and replaces occurrences of some text with other text.\n*   `updateNamedRange` (*type:* `GoogleApi.Sheets.V4.Model.UpdateNamedRangeRequest.t`, *default:* `nil`) - Updates a named range.\n*   `setBasicFilter` (*type:* `GoogleApi.Sheets.V4.Model.SetBasicFilterRequest.t`, *default:* `nil`) - Sets the basic filter on a sheet.\n*   `autoResizeDimensions` (*type:* `GoogleApi.Sheets.V4.Model.AutoResizeDimensionsRequest.t`, *default:* `nil`) - Automatically resizes one or more dimensions based on the contents of the cells in that dimension.\n*   `deleteConditionalFormatRule` (*type:* `GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleRequest.t`, *default:* `nil`) - Deletes an existing conditional format rule.\n*   `updateSheetProperties` (*type:* `GoogleApi.Sheets.V4.Model.UpdateSheetPropertiesRequest.t`, *default:* `nil`) - Updates a sheet's properties.\n*   `pasteData` (*type:* `GoogleApi.Sheets.V4.Model.PasteDataRequest.t`, *default:* `nil`) - Pastes data (HTML or delimited) into a sheet.\n*   `updateEmbeddedObjectBorder` (*type:* `GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectBorderRequest.t`, *default:* `nil`) - Updates an embedded object's border.\n*   `sortRange` (*type:* `GoogleApi.Sheets.V4.Model.SortRangeRequest.t`, *default:* `nil`) - Sorts data in a range.\n*   `duplicateFilterView` (*type:* `GoogleApi.Sheets.V4.Model.DuplicateFilterViewRequest.t`, *default:* `nil`) - Duplicates a filter view.\n*   `cutPaste` (*type:* `GoogleApi.Sheets.V4.Model.CutPasteRequest.t`, *default:* `nil`) - Cuts data from one area and pastes it to another.\n*   `deleteBanding` (*type:* `GoogleApi.Sheets.V4.Model.DeleteBandingRequest.t`, *default:* `nil`) - Removes a banded range\n*   `deleteEmbeddedObject` (*type:* `GoogleApi.Sheets.V4.Model.DeleteEmbeddedObjectRequest.t`, *default:* `nil`) - Deletes an embedded object (e.g, chart, image) in a sheet.\n*   `refreshDataSource` (*type:* `GoogleApi.Sheets.V4.Model.RefreshDataSourceRequest.t`, *default:* `nil`) - Refreshes one or multiple data sources and associated dbobjects.\n*   `clearBasicFilter` (*type:* `GoogleApi.Sheets.V4.Model.ClearBasicFilterRequest.t`, *default:* `nil`) - Clears the basic filter on a sheet.\n*   `copyPaste` (*type:* `GoogleApi.Sheets.V4.Model.CopyPasteRequest.t`, *default:* `nil`) - Copies data from one area and pastes it to another.\n*   `updateFilterView` (*type:* `GoogleApi.Sheets.V4.Model.UpdateFilterViewRequest.t`, *default:* `nil`) - Updates the properties of a filter view.\n*   `updateDimensionGroup` (*type:* `GoogleApi.Sheets.V4.Model.UpdateDimensionGroupRequest.t`, *default:* `nil`) - Updates the state of the specified group.\n*   `addSlicer` (*type:* `GoogleApi.Sheets.V4.Model.AddSlicerRequest.t`, *default:* `nil`) - Adds a slicer.\n*   `deleteFilterView` (*type:* `GoogleApi.Sheets.V4.Model.DeleteFilterViewRequest.t`, *default:* `nil`) - Deletes a filter view from a sheet.\n*   `setDataValidation` (*type:* `GoogleApi.Sheets.V4.Model.SetDataValidationRequest.t`, *default:* `nil`) - Sets data validation for one or more cells.\n*   `updateEmbeddedObjectPosition` (*type:* `GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionRequest.t`, *default:* `nil`) - Updates an embedded object's (e.g. chart, image) position.\n*   `updateConditionalFormatRule` (*type:* `GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleRequest.t`, *default:* `nil`) - Updates an existing conditional format rule.\n*   `deleteRange` (*type:* `GoogleApi.Sheets.V4.Model.DeleteRangeRequest.t`, *default:* `nil`) - Deletes a range of cells from a sheet, shifting the remaining cells.\n*   `deleteDimensionGroup` (*type:* `GoogleApi.Sheets.V4.Model.DeleteDimensionGroupRequest.t`, *default:* `nil`) - Deletes a group over the specified range.\n*   `appendDimension` (*type:* `GoogleApi.Sheets.V4.Model.AppendDimensionRequest.t`, *default:* `nil`) - Appends dimensions to the end of a sheet.\n*   `updateSlicerSpec` (*type:* `GoogleApi.Sheets.V4.Model.UpdateSlicerSpecRequest.t`, *default:* `nil`) - Updates a slicer's specifications.\n*   `deleteDataSource` (*type:* `GoogleApi.Sheets.V4.Model.DeleteDataSourceRequest.t`, *default:* `nil`) - Deletes a data source.\n*   `createDeveloperMetadata` (*type:* `GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataRequest.t`, *default:* `nil`) - Creates new developer metadata\n*   `addFilterView` (*type:* `GoogleApi.Sheets.V4.Model.AddFilterViewRequest.t`, *default:* `nil`) - Adds a filter view.\n*   `addBanding` (*type:* `GoogleApi.Sheets.V4.Model.AddBandingRequest.t`, *default:* `nil`) - Adds a new banded range\n*   `deleteProtectedRange` (*type:* `GoogleApi.Sheets.V4.Model.DeleteProtectedRangeRequest.t`, *default:* `nil`) - Deletes a protected range.\n*   `updateDimensionProperties` (*type:* `GoogleApi.Sheets.V4.Model.UpdateDimensionPropertiesRequest.t`, *default:* `nil`) - Updates dimensions' properties.\n*   `updateProtectedRange` (*type:* `GoogleApi.Sheets.V4.Model.UpdateProtectedRangeRequest.t`, *default:* `nil`) - Updates a protected range.\n*   `addDimensionGroup` (*type:* `GoogleApi.Sheets.V4.Model.AddDimensionGroupRequest.t`, *default:* `nil`) - Creates a group over the specified range.\n*   `updateCells` (*type:* `GoogleApi.Sheets.V4.Model.UpdateCellsRequest.t`, *default:* `nil`) - Updates many cells at once.\n*   `addProtectedRange` (*type:* `GoogleApi.Sheets.V4.Model.AddProtectedRangeRequest.t`, *default:* `nil`) - Adds a protected range.\n*   `addDataSource` (*type:* `GoogleApi.Sheets.V4.Model.AddDataSourceRequest.t`, *default:* `nil`) - Adds a data source.\n*   `addNamedRange` (*type:* `GoogleApi.Sheets.V4.Model.AddNamedRangeRequest.t`, *default:* `nil`) - Adds a named range.\n*   `updateDeveloperMetadata` (*type:* `GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataRequest.t`, *default:* `nil`) - Updates an existing developer metadata entry\n*   `deleteNamedRange` (*type:* `GoogleApi.Sheets.V4.Model.DeleteNamedRangeRequest.t`, *default:* `nil`) - Deletes a named range.\n*   `duplicateSheet` (*type:* `GoogleApi.Sheets.V4.Model.DuplicateSheetRequest.t`, *default:* `nil`) - Duplicates a sheet.\n*   `updateBorders` (*type:* `GoogleApi.Sheets.V4.Model.UpdateBordersRequest.t`, *default:* `nil`) - Updates the borders in a range of cells.\n*   `mergeCells` (*type:* `GoogleApi.Sheets.V4.Model.MergeCellsRequest.t`, *default:* `nil`) - Merges cells together.","ref":"GoogleApi.Sheets.V4.Model.Request.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.Request.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.Request.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.Request.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.Request.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.Response","doc":"A single response from an update.","ref":"GoogleApi.Sheets.V4.Model.Response.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.Response","doc":"*   `addBanding` (*type:* `GoogleApi.Sheets.V4.Model.AddBandingResponse.t`, *default:* `nil`) - A reply from adding a banded range.\n*   `addChart` (*type:* `GoogleApi.Sheets.V4.Model.AddChartResponse.t`, *default:* `nil`) - A reply from adding a chart.\n*   `addDataSource` (*type:* `GoogleApi.Sheets.V4.Model.AddDataSourceResponse.t`, *default:* `nil`) - A reply from adding a data source.\n*   `addDimensionGroup` (*type:* `GoogleApi.Sheets.V4.Model.AddDimensionGroupResponse.t`, *default:* `nil`) - A reply from adding a dimension group.\n*   `addFilterView` (*type:* `GoogleApi.Sheets.V4.Model.AddFilterViewResponse.t`, *default:* `nil`) - A reply from adding a filter view.\n*   `addNamedRange` (*type:* `GoogleApi.Sheets.V4.Model.AddNamedRangeResponse.t`, *default:* `nil`) - A reply from adding a named range.\n*   `addProtectedRange` (*type:* `GoogleApi.Sheets.V4.Model.AddProtectedRangeResponse.t`, *default:* `nil`) - A reply from adding a protected range.\n*   `addSheet` (*type:* `GoogleApi.Sheets.V4.Model.AddSheetResponse.t`, *default:* `nil`) - A reply from adding a sheet.\n*   `addSlicer` (*type:* `GoogleApi.Sheets.V4.Model.AddSlicerResponse.t`, *default:* `nil`) - A reply from adding a slicer.\n*   `createDeveloperMetadata` (*type:* `GoogleApi.Sheets.V4.Model.CreateDeveloperMetadataResponse.t`, *default:* `nil`) - A reply from creating a developer metadata entry.\n*   `deleteConditionalFormatRule` (*type:* `GoogleApi.Sheets.V4.Model.DeleteConditionalFormatRuleResponse.t`, *default:* `nil`) - A reply from deleting a conditional format rule.\n*   `deleteDeveloperMetadata` (*type:* `GoogleApi.Sheets.V4.Model.DeleteDeveloperMetadataResponse.t`, *default:* `nil`) - A reply from deleting a developer metadata entry.\n*   `deleteDimensionGroup` (*type:* `GoogleApi.Sheets.V4.Model.DeleteDimensionGroupResponse.t`, *default:* `nil`) - A reply from deleting a dimension group.\n*   `deleteDuplicates` (*type:* `GoogleApi.Sheets.V4.Model.DeleteDuplicatesResponse.t`, *default:* `nil`) - A reply from removing rows containing duplicate values.\n*   `duplicateFilterView` (*type:* `GoogleApi.Sheets.V4.Model.DuplicateFilterViewResponse.t`, *default:* `nil`) - A reply from duplicating a filter view.\n*   `duplicateSheet` (*type:* `GoogleApi.Sheets.V4.Model.DuplicateSheetResponse.t`, *default:* `nil`) - A reply from duplicating a sheet.\n*   `findReplace` (*type:* `GoogleApi.Sheets.V4.Model.FindReplaceResponse.t`, *default:* `nil`) - A reply from doing a find/replace.\n*   `refreshDataSource` (*type:* `GoogleApi.Sheets.V4.Model.RefreshDataSourceResponse.t`, *default:* `nil`) - A reply from refreshing data source objects.\n*   `trimWhitespace` (*type:* `GoogleApi.Sheets.V4.Model.TrimWhitespaceResponse.t`, *default:* `nil`) - A reply from trimming whitespace.\n*   `updateConditionalFormatRule` (*type:* `GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleResponse.t`, *default:* `nil`) - A reply from updating a conditional format rule.\n*   `updateDataSource` (*type:* `GoogleApi.Sheets.V4.Model.UpdateDataSourceResponse.t`, *default:* `nil`) - A reply from updating a data source.\n*   `updateDeveloperMetadata` (*type:* `GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataResponse.t`, *default:* `nil`) - A reply from updating a developer metadata entry.\n*   `updateEmbeddedObjectPosition` (*type:* `GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionResponse.t`, *default:* `nil`) - A reply from updating an embedded object's position.","ref":"GoogleApi.Sheets.V4.Model.Response.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.Response.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.Response.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.Response.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.Response.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.RowData","doc":"Data about each cell in a row.","ref":"GoogleApi.Sheets.V4.Model.RowData.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.RowData","doc":"*   `values` (*type:* `list(GoogleApi.Sheets.V4.Model.CellData.t)`, *default:* `nil`) - The values in the row, one per column.","ref":"GoogleApi.Sheets.V4.Model.RowData.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.RowData.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.RowData.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.RowData.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.RowData.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ScorecardChartSpec","doc":"A scorecard chart. Scorecard charts are used to highlight key performance indicators, known as KPIs, on the spreadsheet. A scorecard chart can represent things like total sales, average cost, or a top selling item. You can specify a single data value, or aggregate over a range of data. Percentage or absolute difference from a baseline value can be highlighted, like changes over time.","ref":"GoogleApi.Sheets.V4.Model.ScorecardChartSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ScorecardChartSpec","doc":"*   `aggregateType` (*type:* `String.t`, *default:* `nil`) - The aggregation type for key and baseline chart data in scorecard chart. This field is not supported for data source charts. Use the ChartData.aggregateType field of the key_value_data or baseline_value_data instead for data source charts. This field is optional.\n*   `baselineValueData` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data for scorecard baseline value. This field is optional.\n*   `baselineValueFormat` (*type:* `GoogleApi.Sheets.V4.Model.BaselineValueFormat.t`, *default:* `nil`) - Formatting options for baseline value. This field is needed only if baseline_value_data is specified.\n*   `customFormatOptions` (*type:* `GoogleApi.Sheets.V4.Model.ChartCustomNumberFormatOptions.t`, *default:* `nil`) - Custom formatting options for numeric key/baseline values in scorecard chart. This field is used only when number_format_source is set to CUSTOM. This field is optional.\n*   `keyValueData` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data for scorecard key value.\n*   `keyValueFormat` (*type:* `GoogleApi.Sheets.V4.Model.KeyValueFormat.t`, *default:* `nil`) - Formatting options for key value.\n*   `numberFormatSource` (*type:* `String.t`, *default:* `nil`) - The number format source used in the scorecard chart. This field is optional.\n*   `scaleFactor` (*type:* `float()`, *default:* `nil`) - Value to scale scorecard key and baseline value. For example, a factor of 10 can be used to divide all values in the chart by 10. This field is optional.","ref":"GoogleApi.Sheets.V4.Model.ScorecardChartSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ScorecardChartSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ScorecardChartSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ScorecardChartSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ScorecardChartSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataRequest","doc":"A request to retrieve all developer metadata matching the set of specified criteria.","ref":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataRequest","doc":"*   `dataFilters` (*type:* `list(GoogleApi.Sheets.V4.Model.DataFilter.t)`, *default:* `nil`) - The data filters describing the criteria used to determine which DeveloperMetadata entries to return. DeveloperMetadata matching any of the specified filters are included in the response.","ref":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataResponse","doc":"A reply to a developer metadata search request.","ref":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataResponse","doc":"*   `matchedDeveloperMetadata` (*type:* `list(GoogleApi.Sheets.V4.Model.MatchedDeveloperMetadata.t)`, *default:* `nil`) - The metadata matching the criteria of the search request.","ref":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.SearchDeveloperMetadataResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.SetBasicFilterRequest","doc":"Sets the basic filter associated with a sheet.","ref":"GoogleApi.Sheets.V4.Model.SetBasicFilterRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.SetBasicFilterRequest","doc":"*   `filter` (*type:* `GoogleApi.Sheets.V4.Model.BasicFilter.t`, *default:* `nil`) - The filter to set.","ref":"GoogleApi.Sheets.V4.Model.SetBasicFilterRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.SetBasicFilterRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.SetBasicFilterRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.SetBasicFilterRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.SetBasicFilterRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.SetDataValidationRequest","doc":"Sets a data validation rule to every cell in the range. To clear validation in a range, call this with no rule specified.","ref":"GoogleApi.Sheets.V4.Model.SetDataValidationRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.SetDataValidationRequest","doc":"*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range the data validation rule should apply to.\n*   `rule` (*type:* `GoogleApi.Sheets.V4.Model.DataValidationRule.t`, *default:* `nil`) - The data validation rule to set on each cell in the range, or empty to clear the data validation in the range.","ref":"GoogleApi.Sheets.V4.Model.SetDataValidationRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.SetDataValidationRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.SetDataValidationRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.SetDataValidationRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.SetDataValidationRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.Sheet","doc":"A sheet in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.Sheet.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.Sheet","doc":"*   `bandedRanges` (*type:* `list(GoogleApi.Sheets.V4.Model.BandedRange.t)`, *default:* `nil`) - The banded (alternating colors) ranges on this sheet.\n*   `basicFilter` (*type:* `GoogleApi.Sheets.V4.Model.BasicFilter.t`, *default:* `nil`) - The filter on this sheet, if any.\n*   `charts` (*type:* `list(GoogleApi.Sheets.V4.Model.EmbeddedChart.t)`, *default:* `nil`) - The specifications of every chart on this sheet.\n*   `columnGroups` (*type:* `list(GoogleApi.Sheets.V4.Model.DimensionGroup.t)`, *default:* `nil`) - All column groups on this sheet, ordered by increasing range start index, then by group depth.\n*   `conditionalFormats` (*type:* `list(GoogleApi.Sheets.V4.Model.ConditionalFormatRule.t)`, *default:* `nil`) - The conditional format rules in this sheet.\n*   `data` (*type:* `list(GoogleApi.Sheets.V4.Model.GridData.t)`, *default:* `nil`) - Data in the grid, if this is a grid sheet. The number of GridData objects returned is dependent on the number of ranges requested on this sheet. For example, if this is representing `Sheet1`, and the spreadsheet was requested with ranges `Sheet1!A1:C10` and `Sheet1!D15:E20`, then the first GridData will have a startRow/startColumn of `0`, while the second one will have `startRow 14` (zero-based row 15), and `startColumn 3` (zero-based column D). For a DATA_SOURCE sheet, you can not request a specific range, the GridData contains all the values.\n*   `developerMetadata` (*type:* `list(GoogleApi.Sheets.V4.Model.DeveloperMetadata.t)`, *default:* `nil`) - The developer metadata associated with a sheet.\n*   `filterViews` (*type:* `list(GoogleApi.Sheets.V4.Model.FilterView.t)`, *default:* `nil`) - The filter views in this sheet.\n*   `merges` (*type:* `list(GoogleApi.Sheets.V4.Model.GridRange.t)`, *default:* `nil`) - The ranges that are merged together.\n*   `properties` (*type:* `GoogleApi.Sheets.V4.Model.SheetProperties.t`, *default:* `nil`) - The properties of the sheet.\n*   `protectedRanges` (*type:* `list(GoogleApi.Sheets.V4.Model.ProtectedRange.t)`, *default:* `nil`) - The protected ranges in this sheet.\n*   `rowGroups` (*type:* `list(GoogleApi.Sheets.V4.Model.DimensionGroup.t)`, *default:* `nil`) - All row groups on this sheet, ordered by increasing range start index, then by group depth.\n*   `slicers` (*type:* `list(GoogleApi.Sheets.V4.Model.Slicer.t)`, *default:* `nil`) - The slicers on this sheet.","ref":"GoogleApi.Sheets.V4.Model.Sheet.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.Sheet.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.Sheet.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.Sheet.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.Sheet.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.SheetProperties","doc":"Properties of a sheet.","ref":"GoogleApi.Sheets.V4.Model.SheetProperties.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.SheetProperties","doc":"*   `dataSourceSheetProperties` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceSheetProperties.t`, *default:* `nil`) - Output only. If present, the field contains DATA_SOURCE sheet specific properties.\n*   `gridProperties` (*type:* `GoogleApi.Sheets.V4.Model.GridProperties.t`, *default:* `nil`) - Additional properties of the sheet if this sheet is a grid. (If the sheet is an object sheet, containing a chart or image, then this field will be absent.) When writing it is an error to set any grid properties on non-grid sheets. If this sheet is a DATA_SOURCE sheet, this field is output only but contains the properties that reflect how a data source sheet is rendered in the UI, e.g. row_count.\n*   `hidden` (*type:* `boolean()`, *default:* `nil`) - True if the sheet is hidden in the UI, false if it's visible.\n*   `index` (*type:* `integer()`, *default:* `nil`) - The index of the sheet within the spreadsheet. When adding or updating sheet properties, if this field is excluded then the sheet is added or moved to the end of the sheet list. When updating sheet indices or inserting sheets, movement is considered in \"before the move\" indexes. For example, if there were three sheets (S1, S2, S3) in order to move S1 ahead of S2 the index would have to be set to 2. A sheet index update request is ignored if the requested index is identical to the sheets current index or if the requested new index is equal to the current sheet index + 1.\n*   `rightToLeft` (*type:* `boolean()`, *default:* `nil`) - True if the sheet is an RTL sheet instead of an LTR sheet.\n*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The ID of the sheet. Must be non-negative. This field cannot be changed once set.\n*   `sheetType` (*type:* `String.t`, *default:* `nil`) - The type of sheet. Defaults to GRID. This field cannot be changed once set.\n*   `tabColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The color of the tab in the UI. Deprecated: Use tab_color_style.\n*   `tabColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The color of the tab in the UI. If tab_color is also set, this field takes precedence.\n*   `title` (*type:* `String.t`, *default:* `nil`) - The name of the sheet.","ref":"GoogleApi.Sheets.V4.Model.SheetProperties.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.SheetProperties.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.SheetProperties.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.SheetProperties.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.SheetProperties.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.Slicer","doc":"A slicer in a sheet.","ref":"GoogleApi.Sheets.V4.Model.Slicer.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.Slicer","doc":"*   `position` (*type:* `GoogleApi.Sheets.V4.Model.EmbeddedObjectPosition.t`, *default:* `nil`) - The position of the slicer. Note that slicer can be positioned only on existing sheet. Also, width and height of slicer can be automatically adjusted to keep it within permitted limits.\n*   `slicerId` (*type:* `integer()`, *default:* `nil`) - The ID of the slicer.\n*   `spec` (*type:* `GoogleApi.Sheets.V4.Model.SlicerSpec.t`, *default:* `nil`) - The specification of the slicer.","ref":"GoogleApi.Sheets.V4.Model.Slicer.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.Slicer.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.Slicer.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.Slicer.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.Slicer.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.SlicerSpec","doc":"The specifications of a slicer.","ref":"GoogleApi.Sheets.V4.Model.SlicerSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.SlicerSpec","doc":"*   `applyToPivotTables` (*type:* `boolean()`, *default:* `nil`) - True if the filter should apply to pivot tables. If not set, default to `True`.\n*   `backgroundColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The background color of the slicer. Deprecated: Use background_color_style.\n*   `backgroundColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The background color of the slicer. If background_color is also set, this field takes precedence.\n*   `columnIndex` (*type:* `integer()`, *default:* `nil`) - The zero-based column index in the data table on which the filter is applied to.\n*   `dataRange` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The data range of the slicer.\n*   `filterCriteria` (*type:* `GoogleApi.Sheets.V4.Model.FilterCriteria.t`, *default:* `nil`) - The filtering criteria of the slicer.\n*   `horizontalAlignment` (*type:* `String.t`, *default:* `nil`) - The horizontal alignment of title in the slicer. If unspecified, defaults to `LEFT`\n*   `textFormat` (*type:* `GoogleApi.Sheets.V4.Model.TextFormat.t`, *default:* `nil`) - The text format of title in the slicer. The link field is not supported.\n*   `title` (*type:* `String.t`, *default:* `nil`) - The title of the slicer.","ref":"GoogleApi.Sheets.V4.Model.SlicerSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.SlicerSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.SlicerSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.SlicerSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.SlicerSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.SortRangeRequest","doc":"Sorts data in rows based on a sort order per column.","ref":"GoogleApi.Sheets.V4.Model.SortRangeRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.SortRangeRequest","doc":"*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range to sort.\n*   `sortSpecs` (*type:* `list(GoogleApi.Sheets.V4.Model.SortSpec.t)`, *default:* `nil`) - The sort order per column. Later specifications are used when values are equal in the earlier specifications.","ref":"GoogleApi.Sheets.V4.Model.SortRangeRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.SortRangeRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.SortRangeRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.SortRangeRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.SortRangeRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.SortSpec","doc":"A sort order associated with a specific column or row.","ref":"GoogleApi.Sheets.V4.Model.SortSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.SortSpec","doc":"*   `backgroundColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The background fill color to sort by; cells with this fill color are sorted to the top. Mutually exclusive with foreground_color. Deprecated: Use background_color_style.\n*   `backgroundColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The background fill color to sort by; cells with this fill color are sorted to the top. Mutually exclusive with foreground_color, and must be an RGB-type color. If background_color is also set, this field takes precedence.\n*   `dataSourceColumnReference` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceColumnReference.t`, *default:* `nil`) - Reference to a data source column.\n*   `dimensionIndex` (*type:* `integer()`, *default:* `nil`) - The dimension the sort should be applied to.\n*   `foregroundColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The foreground color to sort by; cells with this foreground color are sorted to the top. Mutually exclusive with background_color. Deprecated: Use foreground_color_style.\n*   `foregroundColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The foreground color to sort by; cells with this foreground color are sorted to the top. Mutually exclusive with background_color, and must be an RGB-type color. If foreground_color is also set, this field takes precedence.\n*   `sortOrder` (*type:* `String.t`, *default:* `nil`) - The order data should be sorted.","ref":"GoogleApi.Sheets.V4.Model.SortSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.SortSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.SortSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.SortSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.SortSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.SourceAndDestination","doc":"A combination of a source range and how to extend that source.","ref":"GoogleApi.Sheets.V4.Model.SourceAndDestination.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.SourceAndDestination","doc":"*   `dimension` (*type:* `String.t`, *default:* `nil`) - The dimension that data should be filled into.\n*   `fillLength` (*type:* `integer()`, *default:* `nil`) - The number of rows or columns that data should be filled into. Positive numbers expand beyond the last row or last column of the source. Negative numbers expand before the first row or first column of the source.\n*   `source` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The location of the data to use as the source of the autofill.","ref":"GoogleApi.Sheets.V4.Model.SourceAndDestination.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.SourceAndDestination.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.SourceAndDestination.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.SourceAndDestination.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.SourceAndDestination.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.Spreadsheet","doc":"Resource that represents a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.Spreadsheet.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.Spreadsheet","doc":"*   `dataSourceSchedules` (*type:* `list(GoogleApi.Sheets.V4.Model.DataSourceRefreshSchedule.t)`, *default:* `nil`) - Output only. A list of data source refresh schedules.\n*   `dataSources` (*type:* `list(GoogleApi.Sheets.V4.Model.DataSource.t)`, *default:* `nil`) - A list of external data sources connected with the spreadsheet.\n*   `developerMetadata` (*type:* `list(GoogleApi.Sheets.V4.Model.DeveloperMetadata.t)`, *default:* `nil`) - The developer metadata associated with a spreadsheet.\n*   `namedRanges` (*type:* `list(GoogleApi.Sheets.V4.Model.NamedRange.t)`, *default:* `nil`) - The named ranges defined in a spreadsheet.\n*   `properties` (*type:* `GoogleApi.Sheets.V4.Model.SpreadsheetProperties.t`, *default:* `nil`) - Overall properties of a spreadsheet.\n*   `sheets` (*type:* `list(GoogleApi.Sheets.V4.Model.Sheet.t)`, *default:* `nil`) - The sheets that are part of a spreadsheet.\n*   `spreadsheetId` (*type:* `String.t`, *default:* `nil`) - The ID of the spreadsheet. This field is read-only.\n*   `spreadsheetUrl` (*type:* `String.t`, *default:* `nil`) - The url of the spreadsheet. This field is read-only.","ref":"GoogleApi.Sheets.V4.Model.Spreadsheet.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.Spreadsheet.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.Spreadsheet.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.Spreadsheet.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.Spreadsheet.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.SpreadsheetProperties","doc":"Properties of a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.SpreadsheetProperties.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.SpreadsheetProperties","doc":"*   `autoRecalc` (*type:* `String.t`, *default:* `nil`) - The amount of time to wait before volatile functions are recalculated.\n*   `defaultFormat` (*type:* `GoogleApi.Sheets.V4.Model.CellFormat.t`, *default:* `nil`) - The default format of all cells in the spreadsheet. CellData.effectiveFormat will not be set if the cell's format is equal to this default format. This field is read-only.\n*   `iterativeCalculationSettings` (*type:* `GoogleApi.Sheets.V4.Model.IterativeCalculationSettings.t`, *default:* `nil`) - Determines whether and how circular references are resolved with iterative calculation. Absence of this field means that circular references result in calculation errors.\n*   `locale` (*type:* `String.t`, *default:* `nil`) - The locale of the spreadsheet in one of the following formats: * an ISO 639-1 language code such as `en` * an ISO 639-2 language code such as `fil`, if no 639-1 code exists * a combination of the ISO language code and country code, such as `en_US` Note: when updating this field, not all locales/languages are supported.\n*   `spreadsheetTheme` (*type:* `GoogleApi.Sheets.V4.Model.SpreadsheetTheme.t`, *default:* `nil`) - Theme applied to the spreadsheet.\n*   `timeZone` (*type:* `String.t`, *default:* `nil`) - The time zone of the spreadsheet, in CLDR format such as `America/New_York`. If the time zone isn't recognized, this may be a custom time zone such as `GMT-07:00`.\n*   `title` (*type:* `String.t`, *default:* `nil`) - The title of the spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.SpreadsheetProperties.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.SpreadsheetProperties.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.SpreadsheetProperties.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.SpreadsheetProperties.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.SpreadsheetProperties.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.SpreadsheetTheme","doc":"Represents spreadsheet theme","ref":"GoogleApi.Sheets.V4.Model.SpreadsheetTheme.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.SpreadsheetTheme","doc":"*   `primaryFontFamily` (*type:* `String.t`, *default:* `nil`) - Name of the primary font family.\n*   `themeColors` (*type:* `list(GoogleApi.Sheets.V4.Model.ThemeColorPair.t)`, *default:* `nil`) - The spreadsheet theme color pairs. To update you must provide all theme color pairs.","ref":"GoogleApi.Sheets.V4.Model.SpreadsheetTheme.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.SpreadsheetTheme.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.SpreadsheetTheme.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.SpreadsheetTheme.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.SpreadsheetTheme.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.TextFormat","doc":"The format of a run of text in a cell. Absent values indicate that the field isn't specified.","ref":"GoogleApi.Sheets.V4.Model.TextFormat.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.TextFormat","doc":"*   `bold` (*type:* `boolean()`, *default:* `nil`) - True if the text is bold.\n*   `fontFamily` (*type:* `String.t`, *default:* `nil`) - The font family.\n*   `fontSize` (*type:* `integer()`, *default:* `nil`) - The size of the font.\n*   `foregroundColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The foreground color of the text. Deprecated: Use foreground_color_style.\n*   `foregroundColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The foreground color of the text. If foreground_color is also set, this field takes precedence.\n*   `italic` (*type:* `boolean()`, *default:* `nil`) - True if the text is italicized.\n*   `link` (*type:* `GoogleApi.Sheets.V4.Model.Link.t`, *default:* `nil`) - The link destination of the text, if any. Setting the link field in a TextFormatRun will clear the cell's existing links or a cell-level link set in the same request. When a link is set, the text foreground color will be set to the default link color and the text will be underlined. If these fields are modified in the same request, those values will be used instead of the link defaults.\n*   `strikethrough` (*type:* `boolean()`, *default:* `nil`) - True if the text has a strikethrough.\n*   `underline` (*type:* `boolean()`, *default:* `nil`) - True if the text is underlined.","ref":"GoogleApi.Sheets.V4.Model.TextFormat.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.TextFormat.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.TextFormat.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.TextFormat.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.TextFormat.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.TextFormatRun","doc":"A run of a text format. The format of this run continues until the start index of the next run. When updating, all fields must be set.","ref":"GoogleApi.Sheets.V4.Model.TextFormatRun.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.TextFormatRun","doc":"*   `format` (*type:* `GoogleApi.Sheets.V4.Model.TextFormat.t`, *default:* `nil`) - The format of this run. Absent values inherit the cell's format.\n*   `startIndex` (*type:* `integer()`, *default:* `nil`) - The zero-based character index where this run starts, in UTF-16 code units.","ref":"GoogleApi.Sheets.V4.Model.TextFormatRun.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.TextFormatRun.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.TextFormatRun.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.TextFormatRun.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.TextFormatRun.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.TextPosition","doc":"Position settings for text.","ref":"GoogleApi.Sheets.V4.Model.TextPosition.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.TextPosition","doc":"*   `horizontalAlignment` (*type:* `String.t`, *default:* `nil`) - Horizontal alignment setting for the piece of text.","ref":"GoogleApi.Sheets.V4.Model.TextPosition.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.TextPosition.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.TextPosition.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.TextPosition.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.TextPosition.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.TextRotation","doc":"The rotation applied to text in a cell.","ref":"GoogleApi.Sheets.V4.Model.TextRotation.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.TextRotation","doc":"*   `angle` (*type:* `integer()`, *default:* `nil`) - The angle between the standard orientation and the desired orientation. Measured in degrees. Valid values are between -90 and 90. Positive angles are angled upwards, negative are angled downwards. Note: For LTR text direction positive angles are in the counterclockwise direction, whereas for RTL they are in the clockwise direction\n*   `vertical` (*type:* `boolean()`, *default:* `nil`) - If true, text reads top to bottom, but the orientation of individual characters is unchanged. For example: | V | | e | | r | | t | | i | | c | | a | | l |","ref":"GoogleApi.Sheets.V4.Model.TextRotation.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.TextRotation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.TextRotation.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.TextRotation.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.TextRotation.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.TextToColumnsRequest","doc":"Splits a column of text into multiple columns, based on a delimiter in each cell.","ref":"GoogleApi.Sheets.V4.Model.TextToColumnsRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.TextToColumnsRequest","doc":"*   `delimiter` (*type:* `String.t`, *default:* `nil`) - The delimiter to use. Used only if delimiterType is CUSTOM.\n*   `delimiterType` (*type:* `String.t`, *default:* `nil`) - The delimiter type to use.\n*   `source` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The source data range. This must span exactly one column.","ref":"GoogleApi.Sheets.V4.Model.TextToColumnsRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.TextToColumnsRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.TextToColumnsRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.TextToColumnsRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.TextToColumnsRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ThemeColorPair","doc":"A pair mapping a spreadsheet theme color type to the concrete color it represents.","ref":"GoogleApi.Sheets.V4.Model.ThemeColorPair.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ThemeColorPair","doc":"*   `color` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The concrete color corresponding to the theme color type.\n*   `colorType` (*type:* `String.t`, *default:* `nil`) - The type of the spreadsheet theme color.","ref":"GoogleApi.Sheets.V4.Model.ThemeColorPair.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ThemeColorPair.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ThemeColorPair.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ThemeColorPair.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ThemeColorPair.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.TimeOfDay","doc":"Represents a time of day. The date and time zone are either not significant or are specified elsewhere. An API may choose to allow leap seconds. Related types are google.type.Date and `google.protobuf.Timestamp`.","ref":"GoogleApi.Sheets.V4.Model.TimeOfDay.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.TimeOfDay","doc":"*   `hours` (*type:* `integer()`, *default:* `nil`) - Hours of day in 24 hour format. Should be from 0 to 23. An API may choose to allow the value \"24:00:00\" for scenarios like business closing time.\n*   `minutes` (*type:* `integer()`, *default:* `nil`) - Minutes of hour of day. Must be from 0 to 59.\n*   `nanos` (*type:* `integer()`, *default:* `nil`) - Fractions of seconds in nanoseconds. Must be from 0 to 999,999,999.\n*   `seconds` (*type:* `integer()`, *default:* `nil`) - Seconds of minutes of the time. Must normally be from 0 to 59. An API may allow the value 60 if it allows leap-seconds.","ref":"GoogleApi.Sheets.V4.Model.TimeOfDay.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.TimeOfDay.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.TimeOfDay.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.TimeOfDay.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.TimeOfDay.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.TreemapChartColorScale","doc":"A color scale for a treemap chart.","ref":"GoogleApi.Sheets.V4.Model.TreemapChartColorScale.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.TreemapChartColorScale","doc":"*   `maxValueColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The background color for cells with a color value greater than or equal to maxValue. Defaults to #109618 if not specified. Deprecated: Use max_value_color_style.\n*   `maxValueColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The background color for cells with a color value greater than or equal to maxValue. Defaults to #109618 if not specified. If max_value_color is also set, this field takes precedence.\n*   `midValueColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The background color for cells with a color value at the midpoint between minValue and maxValue. Defaults to #efe6dc if not specified. Deprecated: Use mid_value_color_style.\n*   `midValueColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The background color for cells with a color value at the midpoint between minValue and maxValue. Defaults to #efe6dc if not specified. If mid_value_color is also set, this field takes precedence.\n*   `minValueColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The background color for cells with a color value less than or equal to minValue. Defaults to #dc3912 if not specified. Deprecated: Use min_value_color_style.\n*   `minValueColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The background color for cells with a color value less than or equal to minValue. Defaults to #dc3912 if not specified. If min_value_color is also set, this field takes precedence.\n*   `noDataColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The background color for cells that have no color data associated with them. Defaults to #000000 if not specified. Deprecated: Use no_data_color_style.\n*   `noDataColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The background color for cells that have no color data associated with them. Defaults to #000000 if not specified. If no_data_color is also set, this field takes precedence.","ref":"GoogleApi.Sheets.V4.Model.TreemapChartColorScale.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.TreemapChartColorScale.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.TreemapChartColorScale.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.TreemapChartColorScale.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.TreemapChartColorScale.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.TreemapChartSpec","doc":"A Treemap chart.","ref":"GoogleApi.Sheets.V4.Model.TreemapChartSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.TreemapChartSpec","doc":"*   `colorData` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data that determines the background color of each treemap data cell. This field is optional. If not specified, size_data is used to determine background colors. If specified, the data is expected to be numeric. color_scale will determine how the values in this data map to data cell background colors.\n*   `colorScale` (*type:* `GoogleApi.Sheets.V4.Model.TreemapChartColorScale.t`, *default:* `nil`) - The color scale for data cells in the treemap chart. Data cells are assigned colors based on their color values. These color values come from color_data, or from size_data if color_data is not specified. Cells with color values less than or equal to min_value will have minValueColor as their background color. Cells with color values greater than or equal to max_value will have maxValueColor as their background color. Cells with color values between min_value and max_value will have background colors on a gradient between minValueColor and maxValueColor, the midpoint of the gradient being midValueColor. Cells with missing or non-numeric color values will have noDataColor as their background color.\n*   `headerColor` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The background color for header cells. Deprecated: Use header_color_style.\n*   `headerColorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The background color for header cells. If header_color is also set, this field takes precedence.\n*   `hideTooltips` (*type:* `boolean()`, *default:* `nil`) - True to hide tooltips.\n*   `hintedLevels` (*type:* `integer()`, *default:* `nil`) - The number of additional data levels beyond the labeled levels to be shown on the treemap chart. These levels are not interactive and are shown without their labels. Defaults to 0 if not specified.\n*   `labels` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data that contains the treemap cell labels.\n*   `levels` (*type:* `integer()`, *default:* `nil`) - The number of data levels to show on the treemap chart. These levels are interactive and are shown with their labels. Defaults to 2 if not specified.\n*   `maxValue` (*type:* `float()`, *default:* `nil`) - The maximum possible data value. Cells with values greater than this will have the same color as cells with this value. If not specified, defaults to the actual maximum value from color_data, or the maximum value from size_data if color_data is not specified.\n*   `minValue` (*type:* `float()`, *default:* `nil`) - The minimum possible data value. Cells with values less than this will have the same color as cells with this value. If not specified, defaults to the actual minimum value from color_data, or the minimum value from size_data if color_data is not specified.\n*   `parentLabels` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data the contains the treemap cells' parent labels.\n*   `sizeData` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data that determines the size of each treemap data cell. This data is expected to be numeric. The cells corresponding to non-numeric or missing data will not be rendered. If color_data is not specified, this data is used to determine data cell background colors as well.\n*   `textFormat` (*type:* `GoogleApi.Sheets.V4.Model.TextFormat.t`, *default:* `nil`) - The text format for all labels on the chart. The link field is not supported.","ref":"GoogleApi.Sheets.V4.Model.TreemapChartSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.TreemapChartSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.TreemapChartSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.TreemapChartSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.TreemapChartSpec.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.TrimWhitespaceRequest","doc":"Trims the whitespace (such as spaces, tabs, or new lines) in every cell in the specified range. This request removes all whitespace from the start and end of each cell's text, and reduces any subsequence of remaining whitespace characters to a single space. If the resulting trimmed text starts with a '+' or '=' character, the text remains as a string value and isn't interpreted as a formula.","ref":"GoogleApi.Sheets.V4.Model.TrimWhitespaceRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.TrimWhitespaceRequest","doc":"*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range whose cells to trim.","ref":"GoogleApi.Sheets.V4.Model.TrimWhitespaceRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.TrimWhitespaceRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.TrimWhitespaceRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.TrimWhitespaceRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.TrimWhitespaceRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.TrimWhitespaceResponse","doc":"The result of trimming whitespace in cells.","ref":"GoogleApi.Sheets.V4.Model.TrimWhitespaceResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.TrimWhitespaceResponse","doc":"*   `cellsChangedCount` (*type:* `integer()`, *default:* `nil`) - The number of cells that were trimmed of whitespace.","ref":"GoogleApi.Sheets.V4.Model.TrimWhitespaceResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.TrimWhitespaceResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.TrimWhitespaceResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.TrimWhitespaceResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.TrimWhitespaceResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UnmergeCellsRequest","doc":"Unmerges cells in the given range.","ref":"GoogleApi.Sheets.V4.Model.UnmergeCellsRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UnmergeCellsRequest","doc":"*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range within which all cells should be unmerged. If the range spans multiple merges, all will be unmerged. The range must not partially span any merge.","ref":"GoogleApi.Sheets.V4.Model.UnmergeCellsRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UnmergeCellsRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UnmergeCellsRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UnmergeCellsRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UnmergeCellsRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateBandingRequest","doc":"Updates properties of the supplied banded range.","ref":"GoogleApi.Sheets.V4.Model.UpdateBandingRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateBandingRequest","doc":"*   `bandedRange` (*type:* `GoogleApi.Sheets.V4.Model.BandedRange.t`, *default:* `nil`) - The banded range to update with the new properties.\n*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `bandedRange` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.","ref":"GoogleApi.Sheets.V4.Model.UpdateBandingRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateBandingRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateBandingRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateBandingRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateBandingRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateBordersRequest","doc":"Updates the borders of a range. If a field is not set in the request, that means the border remains as-is. For example, with two subsequent UpdateBordersRequest: 1. range: A1:A5 `{ top: RED, bottom: WHITE }` 2. range: A1:A5 `{ left: BLUE }` That would result in A1:A5 having a borders of `{ top: RED, bottom: WHITE, left: BLUE }`. If you want to clear a border, explicitly set the style to NONE.","ref":"GoogleApi.Sheets.V4.Model.UpdateBordersRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateBordersRequest","doc":"*   `bottom` (*type:* `GoogleApi.Sheets.V4.Model.Border.t`, *default:* `nil`) - The border to put at the bottom of the range.\n*   `innerHorizontal` (*type:* `GoogleApi.Sheets.V4.Model.Border.t`, *default:* `nil`) - The horizontal border to put within the range.\n*   `innerVertical` (*type:* `GoogleApi.Sheets.V4.Model.Border.t`, *default:* `nil`) - The vertical border to put within the range.\n*   `left` (*type:* `GoogleApi.Sheets.V4.Model.Border.t`, *default:* `nil`) - The border to put at the left of the range.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range whose borders should be updated.\n*   `right` (*type:* `GoogleApi.Sheets.V4.Model.Border.t`, *default:* `nil`) - The border to put at the right of the range.\n*   `top` (*type:* `GoogleApi.Sheets.V4.Model.Border.t`, *default:* `nil`) - The border to put at the top of the range.","ref":"GoogleApi.Sheets.V4.Model.UpdateBordersRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateBordersRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateBordersRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateBordersRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateBordersRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateCellsRequest","doc":"Updates all cells in a range with new data.","ref":"GoogleApi.Sheets.V4.Model.UpdateCellsRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateCellsRequest","doc":"*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields of CellData that should be updated. At least one field must be specified. The root is the CellData; 'row.values.' should not be specified. A single `\"*\"` can be used as short-hand for listing every field.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.GridRange.t`, *default:* `nil`) - The range to write data to. If the data in rows does not cover the entire requested range, the fields matching those set in fields will be cleared.\n*   `rows` (*type:* `list(GoogleApi.Sheets.V4.Model.RowData.t)`, *default:* `nil`) - The data to write.\n*   `start` (*type:* `GoogleApi.Sheets.V4.Model.GridCoordinate.t`, *default:* `nil`) - The coordinate to start writing data at. Any number of rows and columns (including a different number of columns per row) may be written.","ref":"GoogleApi.Sheets.V4.Model.UpdateCellsRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateCellsRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateCellsRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateCellsRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateCellsRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateChartSpecRequest","doc":"Updates a chart's specifications. (This does not move or resize a chart. To move or resize a chart, use UpdateEmbeddedObjectPositionRequest.)","ref":"GoogleApi.Sheets.V4.Model.UpdateChartSpecRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateChartSpecRequest","doc":"*   `chartId` (*type:* `integer()`, *default:* `nil`) - The ID of the chart to update.\n*   `spec` (*type:* `GoogleApi.Sheets.V4.Model.ChartSpec.t`, *default:* `nil`) - The specification to apply to the chart.","ref":"GoogleApi.Sheets.V4.Model.UpdateChartSpecRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateChartSpecRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateChartSpecRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateChartSpecRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateChartSpecRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleRequest","doc":"Updates a conditional format rule at the given index, or moves a conditional format rule to another index.","ref":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleRequest","doc":"*   `index` (*type:* `integer()`, *default:* `nil`) - The zero-based index of the rule that should be replaced or moved.\n*   `newIndex` (*type:* `integer()`, *default:* `nil`) - The zero-based new index the rule should end up at.\n*   `rule` (*type:* `GoogleApi.Sheets.V4.Model.ConditionalFormatRule.t`, *default:* `nil`) - The rule that should replace the rule at the given index.\n*   `sheetId` (*type:* `integer()`, *default:* `nil`) - The sheet of the rule to move. Required if new_index is set, unused otherwise.","ref":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleResponse","doc":"The result of updating a conditional format rule.","ref":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleResponse","doc":"*   `newIndex` (*type:* `integer()`, *default:* `nil`) - The index of the new rule.\n*   `newRule` (*type:* `GoogleApi.Sheets.V4.Model.ConditionalFormatRule.t`, *default:* `nil`) - The new rule that replaced the old rule (if replacing), or the rule that was moved (if moved)\n*   `oldIndex` (*type:* `integer()`, *default:* `nil`) - The old index of the rule. Not set if a rule was replaced (because it is the same as new_index).\n*   `oldRule` (*type:* `GoogleApi.Sheets.V4.Model.ConditionalFormatRule.t`, *default:* `nil`) - The old (deleted) rule. Not set if a rule was moved (because it is the same as new_rule).","ref":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateConditionalFormatRuleResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateDataSourceRequest","doc":"Updates a data source. After the data source is updated successfully, an execution is triggered to refresh the associated DATA_SOURCE sheet to read data from the updated data source. The request requires an additional `bigquery.readonly` OAuth scope.","ref":"GoogleApi.Sheets.V4.Model.UpdateDataSourceRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateDataSourceRequest","doc":"*   `dataSource` (*type:* `GoogleApi.Sheets.V4.Model.DataSource.t`, *default:* `nil`) - The data source to update.\n*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `dataSource` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.","ref":"GoogleApi.Sheets.V4.Model.UpdateDataSourceRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateDataSourceRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateDataSourceRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateDataSourceRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateDataSourceRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateDataSourceResponse","doc":"The response from updating data source.","ref":"GoogleApi.Sheets.V4.Model.UpdateDataSourceResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateDataSourceResponse","doc":"*   `dataExecutionStatus` (*type:* `GoogleApi.Sheets.V4.Model.DataExecutionStatus.t`, *default:* `nil`) - The data execution status.\n*   `dataSource` (*type:* `GoogleApi.Sheets.V4.Model.DataSource.t`, *default:* `nil`) - The updated data source.","ref":"GoogleApi.Sheets.V4.Model.UpdateDataSourceResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateDataSourceResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateDataSourceResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateDataSourceResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateDataSourceResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataRequest","doc":"A request to update properties of developer metadata. Updates the properties of the developer metadata selected by the filters to the values provided in the DeveloperMetadata resource. Callers must specify the properties they wish to update in the fields parameter, as well as specify at least one DataFilter matching the metadata they wish to update.","ref":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataRequest","doc":"*   `dataFilters` (*type:* `list(GoogleApi.Sheets.V4.Model.DataFilter.t)`, *default:* `nil`) - The filters matching the developer metadata entries to update.\n*   `developerMetadata` (*type:* `GoogleApi.Sheets.V4.Model.DeveloperMetadata.t`, *default:* `nil`) - The value that all metadata matched by the data filters will be updated to.\n*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `developerMetadata` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.","ref":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataResponse","doc":"The response from updating developer metadata.","ref":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataResponse","doc":"*   `developerMetadata` (*type:* `list(GoogleApi.Sheets.V4.Model.DeveloperMetadata.t)`, *default:* `nil`) - The updated developer metadata.","ref":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateDeveloperMetadataResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateDimensionGroupRequest","doc":"Updates the state of the specified group.","ref":"GoogleApi.Sheets.V4.Model.UpdateDimensionGroupRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateDimensionGroupRequest","doc":"*   `dimensionGroup` (*type:* `GoogleApi.Sheets.V4.Model.DimensionGroup.t`, *default:* `nil`) - The group whose state should be updated. The range and depth of the group should specify a valid group on the sheet, and all other fields updated.\n*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `dimensionGroup` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.","ref":"GoogleApi.Sheets.V4.Model.UpdateDimensionGroupRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateDimensionGroupRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateDimensionGroupRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateDimensionGroupRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateDimensionGroupRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateDimensionPropertiesRequest","doc":"Updates properties of dimensions within the specified range.","ref":"GoogleApi.Sheets.V4.Model.UpdateDimensionPropertiesRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateDimensionPropertiesRequest","doc":"*   `dataSourceSheetRange` (*type:* `GoogleApi.Sheets.V4.Model.DataSourceSheetDimensionRange.t`, *default:* `nil`) - The columns on a data source sheet to update.\n*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `properties` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.\n*   `properties` (*type:* `GoogleApi.Sheets.V4.Model.DimensionProperties.t`, *default:* `nil`) - Properties to update.\n*   `range` (*type:* `GoogleApi.Sheets.V4.Model.DimensionRange.t`, *default:* `nil`) - The rows or columns to update.","ref":"GoogleApi.Sheets.V4.Model.UpdateDimensionPropertiesRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateDimensionPropertiesRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateDimensionPropertiesRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateDimensionPropertiesRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateDimensionPropertiesRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectBorderRequest","doc":"Updates an embedded object's border property.","ref":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectBorderRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectBorderRequest","doc":"*   `border` (*type:* `GoogleApi.Sheets.V4.Model.EmbeddedObjectBorder.t`, *default:* `nil`) - The border that applies to the embedded object.\n*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `border` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.\n*   `objectId` (*type:* `integer()`, *default:* `nil`) - The ID of the embedded object to update.","ref":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectBorderRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectBorderRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectBorderRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectBorderRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectBorderRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionRequest","doc":"Update an embedded object's position (such as a moving or resizing a chart or image).","ref":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionRequest","doc":"*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields of OverlayPosition that should be updated when setting a new position. Used only if newPosition.overlayPosition is set, in which case at least one field must be specified. The root `newPosition.overlayPosition` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.\n*   `newPosition` (*type:* `GoogleApi.Sheets.V4.Model.EmbeddedObjectPosition.t`, *default:* `nil`) - An explicit position to move the embedded object to. If newPosition.sheetId is set, a new sheet with that ID will be created. If newPosition.newSheet is set to true, a new sheet will be created with an ID that will be chosen for you.\n*   `objectId` (*type:* `integer()`, *default:* `nil`) - The ID of the object to moved.","ref":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionResponse","doc":"The result of updating an embedded object's position.","ref":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionResponse","doc":"*   `position` (*type:* `GoogleApi.Sheets.V4.Model.EmbeddedObjectPosition.t`, *default:* `nil`) - The new position of the embedded object.","ref":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateEmbeddedObjectPositionResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateFilterViewRequest","doc":"Updates properties of the filter view.","ref":"GoogleApi.Sheets.V4.Model.UpdateFilterViewRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateFilterViewRequest","doc":"*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `filter` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.\n*   `filter` (*type:* `GoogleApi.Sheets.V4.Model.FilterView.t`, *default:* `nil`) - The new properties of the filter view.","ref":"GoogleApi.Sheets.V4.Model.UpdateFilterViewRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateFilterViewRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateFilterViewRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateFilterViewRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateFilterViewRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateNamedRangeRequest","doc":"Updates properties of the named range with the specified namedRangeId.","ref":"GoogleApi.Sheets.V4.Model.UpdateNamedRangeRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateNamedRangeRequest","doc":"*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `namedRange` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.\n*   `namedRange` (*type:* `GoogleApi.Sheets.V4.Model.NamedRange.t`, *default:* `nil`) - The named range to update with the new properties.","ref":"GoogleApi.Sheets.V4.Model.UpdateNamedRangeRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateNamedRangeRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateNamedRangeRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateNamedRangeRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateNamedRangeRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateProtectedRangeRequest","doc":"Updates an existing protected range with the specified protectedRangeId.","ref":"GoogleApi.Sheets.V4.Model.UpdateProtectedRangeRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateProtectedRangeRequest","doc":"*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `protectedRange` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.\n*   `protectedRange` (*type:* `GoogleApi.Sheets.V4.Model.ProtectedRange.t`, *default:* `nil`) - The protected range to update with the new properties.","ref":"GoogleApi.Sheets.V4.Model.UpdateProtectedRangeRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateProtectedRangeRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateProtectedRangeRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateProtectedRangeRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateProtectedRangeRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateSheetPropertiesRequest","doc":"Updates properties of the sheet with the specified sheetId.","ref":"GoogleApi.Sheets.V4.Model.UpdateSheetPropertiesRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateSheetPropertiesRequest","doc":"*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `properties` is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.\n*   `properties` (*type:* `GoogleApi.Sheets.V4.Model.SheetProperties.t`, *default:* `nil`) - The properties to update.","ref":"GoogleApi.Sheets.V4.Model.UpdateSheetPropertiesRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateSheetPropertiesRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateSheetPropertiesRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateSheetPropertiesRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateSheetPropertiesRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateSlicerSpecRequest","doc":"Updates a slicer's specifications. (This does not move or resize a slicer. To move or resize a slicer use UpdateEmbeddedObjectPositionRequest.","ref":"GoogleApi.Sheets.V4.Model.UpdateSlicerSpecRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateSlicerSpecRequest","doc":"*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root `SlicerSpec` is implied and should not be specified. A single \"*\"` can be used as short-hand for listing every field.\n*   `slicerId` (*type:* `integer()`, *default:* `nil`) - The id of the slicer to update.\n*   `spec` (*type:* `GoogleApi.Sheets.V4.Model.SlicerSpec.t`, *default:* `nil`) - The specification to apply to the slicer.","ref":"GoogleApi.Sheets.V4.Model.UpdateSlicerSpecRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateSlicerSpecRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateSlicerSpecRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateSlicerSpecRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateSlicerSpecRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateSpreadsheetPropertiesRequest","doc":"Updates properties of a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.UpdateSpreadsheetPropertiesRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateSpreadsheetPropertiesRequest","doc":"*   `fields` (*type:* `String.t`, *default:* `nil`) - The fields that should be updated. At least one field must be specified. The root 'properties' is implied and should not be specified. A single `\"*\"` can be used as short-hand for listing every field.\n*   `properties` (*type:* `GoogleApi.Sheets.V4.Model.SpreadsheetProperties.t`, *default:* `nil`) - The properties to update.","ref":"GoogleApi.Sheets.V4.Model.UpdateSpreadsheetPropertiesRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateSpreadsheetPropertiesRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateSpreadsheetPropertiesRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateSpreadsheetPropertiesRequest.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateSpreadsheetPropertiesRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateValuesByDataFilterResponse","doc":"The response when updating a range of values by a data filter in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.UpdateValuesByDataFilterResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateValuesByDataFilterResponse","doc":"*   `dataFilter` (*type:* `GoogleApi.Sheets.V4.Model.DataFilter.t`, *default:* `nil`) - The data filter that selected the range that was updated.\n*   `updatedCells` (*type:* `integer()`, *default:* `nil`) - The number of cells updated.\n*   `updatedColumns` (*type:* `integer()`, *default:* `nil`) - The number of columns where at least one cell in the column was updated.\n*   `updatedData` (*type:* `GoogleApi.Sheets.V4.Model.ValueRange.t`, *default:* `nil`) - The values of the cells in the range matched by the dataFilter after all updates were applied. This is only included if the request's `includeValuesInResponse` field was `true`.\n*   `updatedRange` (*type:* `String.t`, *default:* `nil`) - The range (in [A1 notation](/sheets/api/guides/concepts#cell)) that updates were applied to.\n*   `updatedRows` (*type:* `integer()`, *default:* `nil`) - The number of rows where at least one cell in the row was updated.","ref":"GoogleApi.Sheets.V4.Model.UpdateValuesByDataFilterResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateValuesByDataFilterResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateValuesByDataFilterResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateValuesByDataFilterResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateValuesByDataFilterResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.UpdateValuesResponse","doc":"The response when updating a range of values in a spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.UpdateValuesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.UpdateValuesResponse","doc":"*   `spreadsheetId` (*type:* `String.t`, *default:* `nil`) - The spreadsheet the updates were applied to.\n*   `updatedCells` (*type:* `integer()`, *default:* `nil`) - The number of cells updated.\n*   `updatedColumns` (*type:* `integer()`, *default:* `nil`) - The number of columns where at least one cell in the column was updated.\n*   `updatedData` (*type:* `GoogleApi.Sheets.V4.Model.ValueRange.t`, *default:* `nil`) - The values of the cells after updates were applied. This is only included if the request's `includeValuesInResponse` field was `true`.\n*   `updatedRange` (*type:* `String.t`, *default:* `nil`) - The range (in A1 notation) that updates were applied to.\n*   `updatedRows` (*type:* `integer()`, *default:* `nil`) - The number of rows where at least one cell in the row was updated.","ref":"GoogleApi.Sheets.V4.Model.UpdateValuesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.UpdateValuesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.UpdateValuesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.UpdateValuesResponse.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.UpdateValuesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.ValueRange","doc":"Data within a range of the spreadsheet.","ref":"GoogleApi.Sheets.V4.Model.ValueRange.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.ValueRange","doc":"*   `majorDimension` (*type:* `String.t`, *default:* `nil`) - The major dimension of the values. For output, if the spreadsheet data is: `A1=1,B1=2,A2=3,B2=4`, then requesting `range=A1:B2,majorDimension=ROWS` will return `[[1,2],[3,4]]`, whereas requesting `range=A1:B2,majorDimension=COLUMNS` will return `[[1,3],[2,4]]`. For input, with `range=A1:B2,majorDimension=ROWS` then `[[1,2],[3,4]]` will set `A1=1,B1=2,A2=3,B2=4`. With `range=A1:B2,majorDimension=COLUMNS` then `[[1,2],[3,4]]` will set `A1=1,B1=3,A2=2,B2=4`. When writing, if this field is not set, it defaults to ROWS.\n*   `range` (*type:* `String.t`, *default:* `nil`) - The range the values cover, in [A1 notation](/sheets/api/guides/concepts#cell). For output, this range indicates the entire requested range, even though the values will exclude trailing rows and columns. When appending values, this field represents the range to search for a table, after which values will be appended.\n*   `values` (*type:* `list(list(any()))`, *default:* `nil`) - The data that was read or to be written. This is an array of arrays, the outer array representing all the data and each inner array representing a major dimension. Each item in the inner array corresponds with one cell. For output, empty trailing rows and columns will not be included. For input, supported value types are: bool, string, and double. Null values will be skipped. To set a cell to an empty value, set the string value to an empty string.","ref":"GoogleApi.Sheets.V4.Model.ValueRange.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.ValueRange.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.ValueRange.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.ValueRange.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.ValueRange.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.WaterfallChartColumnStyle","doc":"Styles for a waterfall chart column.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartColumnStyle.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.WaterfallChartColumnStyle","doc":"*   `color` (*type:* `GoogleApi.Sheets.V4.Model.Color.t`, *default:* `nil`) - The color of the column. Deprecated: Use color_style.\n*   `colorStyle` (*type:* `GoogleApi.Sheets.V4.Model.ColorStyle.t`, *default:* `nil`) - The color of the column. If color is also set, this field takes precedence.\n*   `label` (*type:* `String.t`, *default:* `nil`) - The label of the column's legend.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartColumnStyle.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.WaterfallChartColumnStyle.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartColumnStyle.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.WaterfallChartColumnStyle.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartColumnStyle.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.WaterfallChartCustomSubtotal","doc":"A custom subtotal column for a waterfall chart series.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartCustomSubtotal.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.WaterfallChartCustomSubtotal","doc":"*   `dataIsSubtotal` (*type:* `boolean()`, *default:* `nil`) - True if the data point at subtotal_index is the subtotal. If false, the subtotal will be computed and appear after the data point.\n*   `label` (*type:* `String.t`, *default:* `nil`) - A label for the subtotal column.\n*   `subtotalIndex` (*type:* `integer()`, *default:* `nil`) - The zero-based index of a data point within the series. If data_is_subtotal is true, the data point at this index is the subtotal. Otherwise, the subtotal appears after the data point with this index. A series can have multiple subtotals at arbitrary indices, but subtotals do not affect the indices of the data points. For example, if a series has three data points, their indices will always be 0, 1, and 2, regardless of how many subtotals exist on the series or what data points they are associated with.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartCustomSubtotal.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.WaterfallChartCustomSubtotal.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartCustomSubtotal.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.WaterfallChartCustomSubtotal.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartCustomSubtotal.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.WaterfallChartDomain","doc":"The domain of a waterfall chart.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartDomain.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.WaterfallChartDomain","doc":"*   `data` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data of the WaterfallChartDomain.\n*   `reversed` (*type:* `boolean()`, *default:* `nil`) - True to reverse the order of the domain values (horizontal axis).","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartDomain.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.WaterfallChartDomain.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartDomain.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.WaterfallChartDomain.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartDomain.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.WaterfallChartSeries","doc":"A single series of data for a waterfall chart.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartSeries.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.WaterfallChartSeries","doc":"*   `customSubtotals` (*type:* `list(GoogleApi.Sheets.V4.Model.WaterfallChartCustomSubtotal.t)`, *default:* `nil`) - Custom subtotal columns appearing in this series. The order in which subtotals are defined is not significant. Only one subtotal may be defined for each data point.\n*   `data` (*type:* `GoogleApi.Sheets.V4.Model.ChartData.t`, *default:* `nil`) - The data being visualized in this series.\n*   `dataLabel` (*type:* `GoogleApi.Sheets.V4.Model.DataLabel.t`, *default:* `nil`) - Information about the data labels for this series.\n*   `hideTrailingSubtotal` (*type:* `boolean()`, *default:* `nil`) - True to hide the subtotal column from the end of the series. By default, a subtotal column will appear at the end of each series. Setting this field to true will hide that subtotal column for this series.\n*   `negativeColumnsStyle` (*type:* `GoogleApi.Sheets.V4.Model.WaterfallChartColumnStyle.t`, *default:* `nil`) - Styles for all columns in this series with negative values.\n*   `positiveColumnsStyle` (*type:* `GoogleApi.Sheets.V4.Model.WaterfallChartColumnStyle.t`, *default:* `nil`) - Styles for all columns in this series with positive values.\n*   `subtotalColumnsStyle` (*type:* `GoogleApi.Sheets.V4.Model.WaterfallChartColumnStyle.t`, *default:* `nil`) - Styles for all subtotal columns in this series.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartSeries.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.WaterfallChartSeries.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartSeries.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.WaterfallChartSeries.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartSeries.html#t:t/0"},{"type":"module","title":"GoogleApi.Sheets.V4.Model.WaterfallChartSpec","doc":"A waterfall chart.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartSpec.html"},{"type":"module","title":"Attributes - GoogleApi.Sheets.V4.Model.WaterfallChartSpec","doc":"*   `connectorLineStyle` (*type:* `GoogleApi.Sheets.V4.Model.LineStyle.t`, *default:* `nil`) - The line style for the connector lines.\n*   `domain` (*type:* `GoogleApi.Sheets.V4.Model.WaterfallChartDomain.t`, *default:* `nil`) - The domain data (horizontal axis) for the waterfall chart.\n*   `firstValueIsTotal` (*type:* `boolean()`, *default:* `nil`) - True to interpret the first value as a total.\n*   `hideConnectorLines` (*type:* `boolean()`, *default:* `nil`) - True to hide connector lines between columns.\n*   `series` (*type:* `list(GoogleApi.Sheets.V4.Model.WaterfallChartSeries.t)`, *default:* `nil`) - The data this waterfall chart is visualizing.\n*   `stackedType` (*type:* `String.t`, *default:* `nil`) - The stacked type.\n*   `totalDataLabel` (*type:* `GoogleApi.Sheets.V4.Model.DataLabel.t`, *default:* `nil`) - Controls whether to display additional data labels on stacked charts which sum the total value of all stacked values at each value along the domain axis. stacked_type must be STACKED and neither CUSTOM nor placement can be set on the total_data_label.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartSpec.html#module-attributes"},{"type":"function","title":"GoogleApi.Sheets.V4.Model.WaterfallChartSpec.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartSpec.html#decode/2"},{"type":"type","title":"GoogleApi.Sheets.V4.Model.WaterfallChartSpec.t/0","doc":"","ref":"GoogleApi.Sheets.V4.Model.WaterfallChartSpec.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}